PROGRAM CreatePartsBin (PartFile);

{***************************************************************************
 *                                                                         *
 *   Author     : Charlie Wiederhold                                       *
 *   Date       : January 7, 1996                                          *
 *   TA         : Gooty                                                    *
 *   TA Section : Wed. 3:00 - 4:00                                         *
 *   Assignment : Program 1 Inventory Tracker - Creating parts.bin         *
 *                                                                         *
 ***************************************************************************}

USES Crt,                    {* Used to clear the screen              *}
     List2Data;              {* Defines the types to be used          *}

VAR
  Part      : PartType;      {* Individual record of part information *}
  PartFile  : PartFileType;  {* File of all the part records          *}
  TestNum   : STRING;        {* Used to test for exiting condition    *}
  Exit      : Boolean;       {* Boolean value for exiting WHILE loop  *}

BEGIN {* CreatePartsBin *}

  {* Initializations *}
  assign (PartFile, 'Parts.Bin');
  rewrite (PartFile);
  Exit := False;

  {* Read data for parts.bin until the Empty String is hit, *}
  {* where the data will then be saved to parts.bin         *}
  WHILE NOT Exit DO
    BEGIN {* WHILE *}
      clrscr;
      write (' Enter Part Number ==> ');
      readln (TestNum);
      IF TestNum <> EmptyString THEN
          BEGIN
            Part.Number := TestNum;
            write (' Enter Part Description ==> ');
            readln (Part.Descr);
            write (' Enter Quantity on Hand ==> ');
            readln (Part.OnHand);
            write (' Enter Wholesale Cost ==> $');
            readln (Part.Wholesale);
            write (' Enter Retail Cost ==> $');
            readln (Part.Retail);
            write (PartFile, Part);
          END
        ELSE Exit := True;
    END; {* WHILE *}

  {* Clear the screen and close parts.bin *}
  clrscr;
  Close (PartFile);

END. {* CreatePartsBin *}