{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT List2Data; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************
 *                                                                         *
 *   Author     : Charlie Wiederhold                                       *
 *   Date       : January 7, 1996                                          *
 *   TA         : Gooty                                                    *
 *   TA Section : Wed. 3:00 - 4:00                                         *
 *   Assignment : Program 1 Inventory Tracker - UNIT List2Data             *
 *                                                                         *
 ***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


CONST
  MainBackColor   = 1;                 {* Color of main background  *}
  MainTextColor   = 15;                {* Color of main text        *}
  MainHeaderColor = 14;                {* Color of main header      *}
  MenuBackColor   = 7;                 {* Color of menu background  *}
  MenuTextColor   = 0;                 {* Color of menu text        *}
  MenuSelectColor = 9;                 {* Color of selection arrow  *}
  Line            = #196;              {* Character for line        *}
  EmptyString     = '';                {* Value used for exits      *}

TYPE
  PartString      = STRING[5];         {* String for Part.Nuber     *}
  PartDescrip     = STRING[20];        {* String for Part.Descr     *}

  ListElementType = RECORD
                      Number     : PartString;  {* Part number      *}
                      Descr      : PartDescrip; {* Part description *}
                      OnHand     : Integer;     {* On hand parts    *}
                      Wholesale,                {* Wholesale price  *}
                      Retail     : Real;        {* Retail price     *}
                    END; {* ListElementType *}

  SalesFile       = Text;              {* Text file for sales.rpt   *}
  LogFile         = Text;              {* Text file for sales.log   *}
  PartType        = ListElementType;   {* Better name for this type *}
  PartFileType    = FILE OF PartType;  {* Binay file of Parts       *}

  RelationType    = (Less, Greater, Equal); {* Used in Compare      *}

VAR
  Log : LogFile;                       {* Log file used throughout  *}

{***************************************************************************}
FUNCTION Compare
  (Item1,
   Item2 : ListElementType) : RelationType;
  {* Purpose : To compare two strings and determine their relation *}
  {*     Pre : Item1 and Item2 have not been compared              *}
  {*    Post : Item1 and Item2 have been compared and that value   *}
  {*           is returned to calling routine                      *}

{***************************************************************************}
FUNCTION StrLength
  (Strng : STRING) : Integer;
  {* Purpose : To allow the use of the Length funtion in Pascal,   *}
  {*           since there is a Length funtion in List2ADT that    *}
  {*           overrides it                                        *}
  {*     Pre : Unknown length                                      *}
  {*    Post : StrLength is equal to the Length (Strng);           *}

{***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************}
FUNCTION Compare
  (Item1,
   Item2 : ListElementType) : RelationType;
  {*     Pre : Item1 and Item2 have not been compared              *}
  {*    Post : Item1 and Item2 have been compared and that value   *}
  {*           is returned to calling routine                      *}

BEGIN {* Compare *}

  IF Item1.Number < Item2.Number THEN
      Compare := Less
    ELSE IF Item1.Number > Item2.Number THEN
      Compare := Greater
    ELSE Compare := Equal;

END; {* Compare *}

{***************************************************************************}
FUNCTION StrLength
  (Strng : STRING) : Integer;
  {*     Pre : Unknown length                                      *}
  {*    Post : StrLength is equal to the Length (Strng);           *}

BEGIN {* StrLength *}
  StrLength := Length (Strng);
END; {* StrLength *}

{***************************************************************************}

END. {* List2Data *}
