{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT Screen; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************
 *                                                                         *
 *   Author     : Charlie Wiederhold                                       *
 *   Date       : January 7, 1996                                          *
 *   TA         : Gooty                                                    *
 *   TA Section : Wed. 3:00 - 4:00                                         *
 *   Assignment : Program 1 Inventory Tracker - UNIT Screen                *
 *                                                                         *
 ***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


USES
  Crt,                  {* Used for basic screen functions *}
  Utility,              {* Used for basic routines/actions *}
  List2Data;            {* Declaration of types used       *}

{***************************************************************************}
PROCEDURE Header
  (Where : Byte);
  {* Purpose : To print the header to a list of parts     *}
  {*    Post : Header printed with proper alignment       *}

{***************************************************************************}
PROCEDURE PressEnter
  (Where : Byte);
  {* Purpose : Prompt for the user to hit enter when done *}
  {*    Post : User has reviewed data, and pressed enter  *}

{***************************************************************************}
PROCEDURE OutputPart
  (Part : PartType;
   Where : Byte);
  {* Purpose : Print out a single part                    *}
  {*    Post : Part information has been printed          *}

{***************************************************************************}
PROCEDURE ScreenSetup;
  {* Purpose : Setup the screen with proper design        *}
  {*    Post : Screen has been setup                      *}

{***************************************************************************}
PROCEDURE PrintMenu;
  {* Purpose : To print the text for the menu system      *}
  {*    Post : Menu has been printed                      *}

{***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{**************************************************************************}
PROCEDURE Header
  (Where : Byte);
  {*    Post : Header printed with proper alignment       *}

BEGIN {* Header *}
  WrtS (6,Where,'On Hand | Part Number |     Description      | Wholesale |  Retail  ');
  WrtS (6,Where + 1,'------- | ----------- | -------------------- | --------- | ---------');
END; {* Header *}

{**************************************************************************}
PROCEDURE PressEnter
  (Where : Byte);
  {*    Post : User has reviewed data, and pressed enter  *}

BEGIN {* PressEnter *}
  WrtS (25,Where,'Press<ENTER> to continue...');
  readln;
END; {* PressEnter *}

{**************************************************************************}
PROCEDURE OutputPart
  (Part : PartType;
   Where : Byte);
  {*    Post : Part information has been printed          *}

BEGIN {* OutputPart *}
  FrmtI (7,Where,Part.OnHand,5);
  WrtS (19,Where,Part.Number);
  WrtS (30,Where,Part.Descr);
  WrtC (54,Where,'$');
  WrtR (55,Where,Part.Wholesale,0,2);
  WrtC (66,Where,'$');
  WrtR (67,Where,Part.Retail,0,2);
END; {* OutputPart *}

{**************************************************************************}
PROCEDURE ScreenSetup;
  {*    Post : Screen has been setup                      *}

VAR
  Count : byte;  {* Counter variable for drawing separator lines *}

BEGIN {* ScreenSetup *}
  TcTb (MainTextColor,MainBackColor);
  clrscr;
  FOR Count := 3 TO 77 DO
    BEGIN
      WrtC (Count,1,Line);
      WrtC (Count,8,Line);
    END;
  TcTb (MainHeaderColor,MainBackColor);
  WrtS (18,1,' Charlie Wiederhold - Inventory Tracker ');
  TcTb (MainTextColor,MainBackColor);
END; {* ScreenSetup *}

{**************************************************************************}
PROCEDURE PrintMenu;
  {*    Post : Menu has been printed                      *}

BEGIN {* PrintMenu *}
  TcTb (MenuTextColor,MenuBackColor);
  WrtS (33,2, '   Sales   ');
  WrtS (33,3, '   Check   ');
  WrtS (33,4, '  Reorder  ');
  WrtS (33,5, '    New    ');
  WrtS (33,6, '  Updates  ');
  WrtS (33,7, '    END    ');
  TcTb (MainTextColor,MainBackColor);
END; {* PrintMenu *}

{**************************************************************************}

END. {* Screen *}
