{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<} PROGRAM Program2; {>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{///////////////////////////////////////////////////////////////////////////}
{/                                                                         /}
{/  Author     : Charlie Wiederhold                                        /}
{/  Date       : March 04, 1996                                            /}
{/  Assignment : Program assignment 2                                      /}
{/  TA         : Gooty                                                     /}
{/  Purpose    : To read in an ifnfix expression, and convert it to a      /}
{/               postfix expression and then evaluate that postfix         /}
{/               expression to obtain a real result.                       /}
{/                                                                         /}
{///////////////////////////////////////////////////////////////////////////}


USES
  Crt,                  {* The basic unit for many standard TP7 operations *}
  Utility,              {* Performs many of my routine tasks               *}
  PostFix,              {* Converts/evaluates the input string             *}
  Prog2Data;            {* Contains all the delarations used in Program2   *}

{***************************************************************************}
PROCEDURE ScreenSetup;
{* Purpose : To setup the main window box and header                       *}

BEGIN {* ScreenSetup *}

  Clear (HeaderColor,MainColor,1,1,80,25);
  WrtS (20,UpperYPos - 1,'Charlie Wiederhold - Program 2 - TA: Gooty');
  MakeWin (TextColor,BackColor,UpperXPos,UpperYPos,Width,Height);
  window (UpperXPos + 2,UpperYPos + 1,UpperXPos + Width - 3,
          UpperYPos + Height - 1);

END; {* ScreenSetup *}

{***************************************************************************}
PROCEDURE GetExpression
  (VAR InfixExp : STRING;    {* The infix expression entered               *}
   VAR Exit     : Boolean);  {* Boolean exit checking variable             *}
{* Purpose : To read a string from the keyboard to be converted/evaluated  *}
{*           and determine if the string was the exit key string           *}

BEGIN {* Get expression *}

  WrtS (17,1,'Enter an expression in infix notation');
  WrtS (12,2,'Type "#" when you are ready to exit the program.');
  ReadString (1,4,InfixExp,'==> ');
  IF InfixExp = '#' THEN Exit := True;
  writeln;

END; {* GetExpression *}

{***************************************************************************}
PROCEDURE OutputResults
   (VAR LogFile    : Text;    {* File to write the result to for checking  *}
        PostfixExp : STRING;  {* The converted postfix expression          *}
        Result     : Real);   {* The evaluated result                      *}
{* Purpose : Output the results from the infix to postfix and evaluation   *}

BEGIN {* OutputResults *}

  {* Output postfix expression *}
  WrtS (1,6,'Postfix Notation ==> ');
  WrtS (20,6,PostfixExp);

  {* Output evaluated result *}
  WrtS (1,7,'Evaluated Result ==> ');
  WrtR (20,7,Result,0,10);

  {* Output to LogFile *}
  writeln (LogFile,PostfixExp);
  writeln (LogFile,Result:0:10);

END; {* OutputResults *}

{***************************************************************************}
PROCEDURE OutputError
  (VAR LogFile : Text);       {* File to write the result to for checking  *}
{* Purpose : To print out an error message if an invalid expression        *}

BEGIN {* OutputError *}

  {* Error Message *}
  TcTb (ErrorText,ErrorBack);
  WrtS (15,6,' ERROR : Invalid Expression Entered ');

  {* Write error message to LogFile *}
  writeln (LogFile, 'ERROR : Invalid Expression Entered');

END; {* OutputError *}

{***************************************************************************}
PROCEDURE Prompt;
{* Purpose : Hold output on the screen and wait for <ENTER> to be pressed  *}

BEGIN {* OutputPrompt *}

  {* Prompt for <ENTER> *}
  TcTb (Highlight,BackColor);
  WrtS (21,8,' Press <ENTER> to continue');
  HideCursor (1,1,7);
  readln;

END; {* OutputPrompt *}

{***************************************************************************}
PROCEDURE ControlProcessing;
{* Purpose : Main controlling procedure that dictates the running of Prog2 *}

VAR
  InfixExp,                 {* Infix expression entered by the user        *}
  PostfixExp : STRING;      {* Postfix expression converted by UnitPostfix *}
  Error,                    {* Boolean error checking variable             *}
  Exit       : Boolean;     {* Boolean exit checking variable              *}
  Result     : Real;        {* The final real value result calculated      *}
  LogFile    : Text;        {* Records all data for each operation         *}

BEGIN {* ControlProcessing *}

  {* Initialize *}
  Exit := False;
  ScreenSetup;
  GetExpression (InfixExp,Exit);
  assign (LogFile, 'program2.log');
  rewrite (LogFile);

  {* If it is not the exit condition, then it evaluates the esxpression *}
  WHILE NOT Exit DO
    BEGIN {* While Do *}

      {* Convert the infix expression to postfix and output *}
      InfixtoPostfix(InfixExp,PostfixExp,Error);

      {* If a valid expression, evaluate result and output *}
      IF NOT Error THEN
          EvaluatePostfix(PostfixExp,Result,Error);

        {* IF a valid result, then output the results *}
        IF NOT Error THEN
            OutputResults (LogFile,PostfixExp,Result)

          {* Otherwise print out error message *}
          ELSE OutputError (LogFile);

      {* Hold output on screen *}
      Prompt;

      {* Get next expression *}
      ScreenSetup;
      GetExpression (InfixExp,Exit);
    END; {* While Do *}

  Clear (7,0,1,1,80,25);
  {* Close the LogFile *}
  close (LogFile);

END; {* ControlProcessing *}

{***************************************************************************}

BEGIN {* Program2 *}

  ControlProcessing;

END. {* Program2 *}