                 {* Charlie Wiederhold - Gooty Wed. 3-4 *}
{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT Basics; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


USES
  Crt,          {* Many screen and interface routines                      *}
  Utility,      {* Contains my common routines                             *}
  ListData,     {* Declaration of the list element type                    *}
  Prog4Data;    {* Main declaration for Program4                           *}

{* Due to the simple nature of these procedures only the purpose is given  *}

{***************************************************************************}
PROCEDURE ScreenSetup;
{* Purpose : To set up the main screen of the program                      *}

{***************************************************************************}
FUNCTION  AskUserInfo : Boolean;
{* Purpose : To get a 'Y' or 'N' response from the user                    *}

{***************************************************************************}
PROCEDURE BreakUpAuthors
   (    Names       : STRING;     {* Names to be split apart               *}
   VAR AuthorNames : AuthorArray);{* New array of all names given          *}
{* Purpose : To split the singl string of authors into an array of names   *}

{***************************************************************************}
PROCEDURE NotFound
  (VAR LogFile : Text);           {* LogFile                               *}
{* Purpose : Print the Not Found error message                             *}

{***************************************************************************}
FUNCTION QuitProgram : Boolean;
{* Purpose : Check to see if the user wants to exit                        *}

{***************************************************************************}
PROCEDURE OutputBook
  (    Book    : ListElementType; {* Book to be printed out                *}
   VAR LogFile : Text);           {* LogFile                               *}
{* Purpose : To output a book information to the screen                    *}

{***************************************************************************}
PROCEDURE InputWindow
  (    Process : ProcessMethod;   {* Process to be performed within window *}
   VAR Book    : ListElementType);{* Book to be read within the window     *}
{* Purpose : To create a window and read in value for a new book           *}

{***************************************************************************}
PROCEDURE GetBookFile
  (VAR Book      : ListElementType;{* Book to be read in from the file     *}
   VAR BookFile  : Text;           {* File books are saved on              *}
   VAR CurrentID : Integer);       {* ID number for the current book       *}
{* Purpose : Read in a new book from the book file for insertion           *}

{***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION{>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************}
PROCEDURE ScreenSetup;
{* Purpose : To set up the main screen of the program                      *}

BEGIN {* ScreenSetup *}

  Clear (HeaderColor,BackColor,1,1,80,25);
  MakeWin (TextColor,WinColor,3,2,12,6);
  WrtS (3,1,'Insert');
  WrtS (3,2,'Delete');
  WrtS (3,3,'Search');
  WrtS (3,4,'Quit');

END; {* ScreenSetup *}

{***************************************************************************}
FUNCTION  AskUserInfo : Boolean;
{* Purpose : To get a 'Y' or 'N' response from the user                    *}

VAR
  Choice : char;                     {* User selected char for results     *}

BEGIN {* AskUserInfo *}

  REPEAT
    Choice := upcase(Readkey);
  UNTIL (Choice = 'Y') OR (Choice = 'N');
  CASE Choice OF
    'Y' : AskUserInfo := True;
    'N' : AskUserInfo := False;
  END; {* Case *}

END; {* AskUserInfo *}

{***************************************************************************}
PROCEDURE BreakUpAuthors
   (    Names       : STRING;     {* Names to be split apart               *}
   VAR AuthorNames : AuthorArray);{* New array of all names given          *}
{* Purpose : To split the singl string of authors into an array of names   *}

VAR
  Current,                        {* Current author portion                *}
  Count    : Integer;             {* Loop control variable                 *}

BEGIN {* BreakUpAuthors *}

  FOR Count := 1 TO 10 DO AuthorNames[Count] := '';
  Current := 1;

  WHILE pos(';',Names) <> 0 DO
    BEGIN {* While *}
      Count := pos(';',Names);
      AuthorNames[Current] := copy (Names,1,(pos(';',Names) - 1));
      delete (Names,1,(pos(';',Names) + 1));
      IF Names[1] = ' ' THEN delete (Names,1,2);
      inc(Current);
    END; {* While *}

  AuthorNames[Current] := Names;

END; {* BreakUpAuthors *}

{***************************************************************************}
PROCEDURE NotFound
  (VAR LogFile : Text);           {* LogFile                               *}
{* Purpose : Print the Not Found error message                             *}

BEGIN {* NotFound *}

  clrscr;
  writeln;
  writeln (TitleHead, '/*/*/   No match found!   \*\*\');
  writeln (AuthorHead, '/*/*/   No match found!   \*\*\');
  writeln;
  writeln (' Press Enter to continue...');

  HideCursor (1,1,WinColor);
  readln;
  TcTb (TextColor,WinColor);

  writeln (LogFIle,'No match found');

END; {* NotFound *}

{***************************************************************************}
FUNCTION QuitProgram : Boolean;
{* Purpose : Check to see if the user wants to exit                        *}

BEGIN {* QuitProgram *}

  MakeWin (TextColor,WinColor,20,2,31,3);
  write ('  Exit? Are you sure? <Y/N>');

  HideCursor (1,1,WinColor);
  QuitProgram := AskUserInfo;

END; {* QuitProgram *}

{***************************************************************************}
PROCEDURE OutputBook
  (    Book    : ListElementType;{* Book to be printed out                *}
   VAR LogFile : Text);             {* LogFile                               *}
{* Purpose : To output a book information to the screen                    *}

BEGIN {* OutputBook *}

  writeln;
  writeln (TitleHead,Book.BookNode.Title);
  writeln (AuthorHead,Book.BookNode.Authors);
  writeln;

  writeln (LogFile,TitleHead,Book.BookNode.Title);
  writeln (LogFile,AuthorHead,Book.BookNode.Authors);
  writeln (LogFile);

END; {* OutputBook *}

{***************************************************************************}
PROCEDURE InputWindow
  (    Process : ProcessMethod;   {* Process to be performed within window *}
   VAR Book    : ListElementType);{* Book to be read within the window     *}
{* Purpose : To create a window and read in value for a new book           *}

BEGIN {* InputWindow *}

  MakeWin (TextColor,WinColor,5,11,70,8);
  window (30,11,50,11);
  TcTb (HeaderColor,WinColor);

  CASE Process OF
    PrintOut : write (' Search For A Book ');
    Remove   : write (' Delete A Book ');
    Insert   : write (' Insert A New Book ');
  END; {* Case *}

  window (17,18,64,18);
  TcTb (WinColor + 8,WinColor);

  write (' 60 characters max for Title and Author fields ');
  TcTb (TextColor,WinColor);
  window (7,12,73,17);

  Book.Element := ListPart;

  WrtS (1,1,'Enter the book title.');
  WrtS (1,2,'==> ');
  readln (Book.BookNode.Title);

  WrtS (1,4,'Enter the author(s). Multiple authors seperated by a ";".');
  WrtS (1,5,'==> ');
  readln (Book.BookNode.Authors);

END; {* InputWindow *}

{***************************************************************************}
PROCEDURE GetBookFile
  (VAR Book      : ListElementType;{* Book to be read in from the file     *}
   VAR BookFile  : Text;           {* File books are saved on              *}
   VAR CurrentID : Integer);       {* ID number for the current book       *}
{* Purpose : Read in a new book from the book file for insertion           *}

BEGIN {* GetBookFile *}

  readln (BookFile, Book.BookNode.Title);
  delete (Book.BookNode.Title,1,11);

  readln (BookFile, Book.BookNode.Authors);
  delete (Book.BookNode.Authors,1,11);
  readln (BookFile);

  inc(CurrentID);
  Book.BookNode.IDNum := CurrentID;

END; {* GetBookFile *}

{***************************************************************************}

END. {* Basics *}