{$m $4000,0,80000}
PROGRAM DOSRTS;

USES
  Crt,
  DOS,
  List2ADT,
  List2Data,
  Utility;

TYPE
  String8    = ARRAY [1..8] OF Char;
  SoundArray = ARRAY [1..10] OF STRING;


{***************************************************************************}
PROCEDURE HelpWindow;

BEGIN
  MakeWin (7,1,54,3,23,20,True,True);
  WrtS (3,2,'');
  WrtS (3,14,'');
  TcTb (11,1);
  WrtS (5,1,'Keyboard Help');

  TcTb (14,1);
  WrtS (2,3,'<F1> through <F10>');
  WrtS (2,8,'<TAB>');
  WrtS (2,10,'<ENTER>');
  WrtS (2,12,'<ESCAPE>');
  WrtS (2,15,'<HOME>');
  WrtS (2,17,'<END>');

  TcTb (15,1);
  WrtS (2,4,'Copies the selected');
  WrtS (2,5,'sound file to that');
  WrtS (2,6,'position in the RTS');
  WrtS (2,7,'being assembled');
  WrtS (2,9,'Edit RTS File Name');
  WrtS (2,11,'Create the RTS File');
  WrtS (2,13,'Cancel RTS creation');
  WrtS (2,16,'To top of sounds');
  WrtS (2,18,'To bottom of sounds');
END;

{***************************************************************************}
PROCEDURE RTSWindow (RTSName : String8; SoundList : SoundArray);

VAR
  Count : 0..10;

BEGIN
  MakeWin (7,1,28,10,22,13,True,True);
  TcTb (11,1);
  WrtS (5,1,'            ');
  Count := 0;
  WHILE (RTSName[Count + 1] <> ' ') AND (Count < 8) DO
    BEGIN
      inc(Count);
      WrtS (Count + 4,1,RTSName[Count]);
    END;
  write ('.RTS');
  TcTb (15,1);
  For Count := 2 TO 10 DO
    WrtS (2,Count,' F' + chr(Count + 47) + ' ');
  WrtS (2,11,'F10 ');
  FOR Count := 1 TO 10 DO
    BEGIN
      IF SoundList[Count] = '<EMPTY>' THEN TcTb (7,1)
        ELSE TcTb (14,1);
      WrtS (8,Count + 1,SoundList[Count]);
    END;
END;

{***************************************************************************}
PROCEDURE DirectoryWindow (DirList : ListType; VAR NumInWin : Byte);

VAR
  Count     : Byte;
  SoundFile : ListElementType;
  TempChr   : Char;

BEGIN
  MakeWin (7,1,6,3,18,20,True,True);
  TcTb (15,1);
  IF NOT(EmptyList(DirList)) THEN
      BEGIN
        IF ListLength(DirList) >= 18 THEN NumInWin := 18
          ELSE NumInWin := ListLength(DirList);
        FOR Count := 1 TO NumInWin DO
          BEGIN
            SoundFile.Position := Count;
            RetrieveElement (DirList,SoundFile);
            WrtS (2,Count,SoundFile.Name);
          END;
      END
    ELSE
      BEGIN
        WrtS (2,1,'No Files Found');
        WrtS (2,2,'Press <ENTER>');
        HideCursor (1,1,1);
        REPEAT
          TempChr := readkey
        UNTIL TempChr = #13;
      END;
END;

{***************************************************************************}
PROCEDURE UpdateList (VAR SoundList : SoundArray; DirList : ListType;
                      Choice : Char; Position : Byte);

VAR
  SendOver : ListElementType;
  Count    : Byte;

BEGIN
  SendOver.Position := Position;
  RetrieveElement (DirList,SendOver);
  delete (SendOver.Name,1,1);
  delete (SendOver.Name,length(SendOver.Name),1);
  SoundList[ord(Choice) - 58] := SendOver.Name;
  window (36,(ord(Choice) - 47),48,(ord(Choice) - 47));
  TcTb (14,1);
  write (SoundList[ord(Choice) - 58]);
  window (7,4,26,24);
END;

{***************************************************************************}
PROCEDURE ChangeRTSName (VAR RTSName : String8);

VAR
  Charac : Char;
  Count  : Byte;
  Exit   : Boolean;

BEGIN
  window (33,11,45,11);
  TcTb (15,1);
  WrtS (1,1,'        .RTS');
  TcTb (15,3);
  WrtS (1,1,'        ');
  FOR Count := 1 TO 8 DO RTSName[Count] := ' ';
  gotoXY (1,1);
  Exit := False;
  Count := 0;
  WHILE NOT Exit DO
     BEGIN
       Charac := upcase(readkey);
       IF (Charac IN [#33..#126]) AND (Count IN [0..7]) THEN
           BEGIN
             inc(Count);
             RTSName[Count] := Charac;
             WrtS (Count,1,RTSName[Count]);
             IF Count = 8 THEN GotoXY (Count,1);
           END
         ELSE
           IF (Charac = #8) AND (Count >= 1) THEN
               BEGIN
                 RTSName[Count] := ' ';
                 WrtS (Count,1,RTSName[Count]);
                 GotoXY (Count,1);
                 dec(Count);
               END
             ELSE
               IF (Charac = #13) THEN
                   Exit := True
                 ELSE
                   IF (Charac = #0) THEN
                     ELSE Beep (700,50);
     END;
  Clear (11,1,33,11,45,11);
  Count := 0;
  WHILE (RTSName[Count + 1] <> ' ') AND (Count < 8) DO
    BEGIN
      inc(Count);
      WrtS (Count,1,RTSName[Count]);
    END;
  write ('.RTS');
  window (7,4,26,24);
END;

{***************************************************************************}
PROCEDURE CreateSelect
  (RegText, RegBack, SelText, SelBack, Startx, StartY, Height : Byte;
   VAR Cursor    : Byte;
   DirList       : ListType;
   VAR RTSName   : String8;
   VAR SoundList : SoundArray);

VAR
  Choice      : Char;
  Top         : Integer;
  SelectSound : ListElementType;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE Move
  (Choice     : Char;
   VAR Cursor : Byte);

VAR
  Count : Byte;

BEGIN
  CASE Choice OF
    #72 : IF Cursor > 1 THEN dec(Cursor)
            ELSE IF (Top + Cursor - 1) > 1 THEN dec(Top);
    #80 : IF Cursor < Height THEN inc(Cursor)
            ELSE IF (Top + Cursor - 1) < ListLength(DirList) THEN inc(Top);
    #71 : BEGIN
            Cursor := 1;
            Top := 1;
          END;
    #79 : BEGIN
            Cursor := Height;
            Top := (ListLength(DirList) - Height + 1);
          END;
  END;
  TcTb (RegText, RegBack);
  FOR Count := 1 TO Height DO
    BEGIN
      SelectSound.Position := (Count + Top - 1);
      RetrieveElement (DirList,SelectSound);
      WrtS (StartX,Count,SelectSound.Name);
    END;
  TcTb (SelText, SelBack);
  SelectSound.Position := Cursor + Top - 1;
  RetrieveElement (DirList,SelectSound);
  WrtS (StartX, (Cursor + StartY - 1), SelectSound.Name);
END;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

BEGIN
  TcTb (SelText, SelBack);
  Top := Cursor;
  SelectSound.Position := Cursor;
  RetrieveElement (DirList,SelectSound);
  WrtS (StartX, (Cursor + StartY - 1), SelectSound.Name);
  Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
  Choice := readkey;
  WHILE NOT(Choice IN [#13,#27]) DO
    BEGIN
      IF Choice IN [#72,#80,#71,#79,#73,#81] THEN Move (Choice,Cursor);
      IF Choice IN [#59..#68] THEN UpdateList (SoundList,DirList,Choice,(Cursor + Top - 1));
      IF Choice = #9 THEN ChangeRTSName (RTSName);
      Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
      Choice := readkey;
    END;
  IF Choice = #13 THEN Cursor := 1
    ELSE Cursor := 2;
END;

{***************************************************************************}
PROCEDURE MakeRTS (VAR RTSName : String8; VAR SoundList : SoundArray);

VAR
  DirInfo   : SearchRec;
  Script    : Text;
  Batch     : Text;
  Count     : Byte;
  Check     : Char;
  FileName  : STRING;
  RTSMaker,
  Already,
  NotEnough : Boolean;

BEGIN

  clear (7,0,1,1,80,25);

  Count := 1;
  FileName := '';
  WHILE (RTSName[Count] <> ' ') AND (Count <= 8) DO
    BEGIN
      FileName := FileName + RTSName[Count];
      inc(Count);
    END;
  FileName := FileName + '.RTS';

  FindFirst ('rtsmaker.exe',Archive,DirInfo);
  IF DosError <> 0 THEN RTSMaker := False ELSE RTSMaker := True;
  FindFirst (FileName,Archive,DirInfo);
  IF DosError <> 0 THEN Already := False ELSE Already := True;
  NotEnough := False;
  FOR Count := 1 TO 10 DO
     IF SoundList[Count] = '<EMPTY>' THEN NotEnough := True;

  IF (NOT(RTSMaker)) OR (NotEnough) THEN
      BEGIN
        writeln ('This RTS file could not be created for the reason(s) listed below:');
        writeln;
        IF NOT(RTSMaker) THEN writeln ('- RTSMAKER.EXE could not be found in the same directory as DOSRTS.EXE');
        IF NotEnough THEN writeln ('- You did not specify 10 .WAV/.VOC files to be used in this RTS file');
        writeln;
        write ('Press <ENTER> to return to DOSRTSMaker...');
        REPEAT
          Check := readkey;
        UNTIL Check = #13;
      END
    ELSE
      BEGIN
        IF Already THEN
          BEGIN
            write (FileName, ' already exists... Overwrite it? <Y/N>');
            REPEAT
              Check := upcase(readkey);
            UNTIL Check IN ['Y','N'];
            IF Check = 'Y' THEN Already := False;
          END;
        IF NOT(Already) THEN
          BEGIN
            assign (Script, 'rtsscrpt.txt');
            rewrite (Script);
            writeln (Script,';This file is used by DOSRTSMaker as the script file');
            writeln (Script,';to create new RTS files. It may be deleted as it does');
            writeln (Script,';not affect how DOSRTSMaker runs. But, the next time');
            writeln (Script,';you make a new RTS file it will return.');
            writeln (Script,';');
            writeln (Script,FileName);
            FOR Count := 1 TO 10 DO
              writeln (Script,SoundList[Count]);
            close (Script);
            exec ('rtsmaker.exe','rtsscrpt.txt');
            writeln;
            write ('Press <ENTER> to return to DOSRTSMaker...');
            RTSName := 'DEFAULT1';
            FOR Count := 1 TO 10 DO SoundList[Count] := '<EMPTY>';
            REPEAT
              Check := readkey;
            UNTIL Check = #13;
          END;
      END;
END;

{***************************************************************************}
PROCEDURE GetDirectory (VAR DirList : ListType; Type1, Type2 : STRING);

VAR
  DirInfo   : SearchRec;
  SoundFile : ListElementType;
  Count,
  NumFiles  : Byte;

BEGIN
  FindFirst(Type1,Archive,DirInfo);
  NumFiles := 0;
  WHILE (DosError = 0) AND (NumFiles < 255) DO
    BEGIN
      inc(NumFiles);
      SoundFile.Name := ' ' + DirInfo.Name;
      FOR Count := length(SoundFile.Name) TO 13 DO
        SoundFile.Name := SoundFile.Name + ' ';
      InsertElement (DirList,SoundFile);
      FindNext(DirInfo);
    END;

  FindFirst(Type2,Archive,DirInfo);
  WHILE DosError = 0 DO
    BEGIN
      inc(NumFiles);
      SoundFile.Name := ' ' + DirInfo.Name;
      FOR Count := length(SoundFile.Name) TO 13 DO
        SoundFile.Name := SoundFile.Name + ' ';
      InsertElement (DirList,SoundFile);
      FindNext(DirInfo);
    END;

  ResetList (DirList);
  FOR Count := 1 TO NumFiles DO
    BEGIN
      GetNextItem (DirList,SoundFile);
      DeleteElement (DirList,SoundFile);
      SoundFile.Position := Count;
      InsertElement (DirList,SoundFile);
    END;
END;

{***************************************************************************}
PROCEDURE CreateRTS (VAR RTSName : String8; VAR SoundList : SoundArray);

VAR
  NumInWin,
  Count     : Byte;
  DirList   : ListType;
  SoundFile : ListElementType;
  Cursor    : Byte;

BEGIN

  CreateList (DirList);

  GetDirectory (DirList,'*.voc','*.wav');

  HelpWindow;
  RTSWindow (RTSName,SoundList);
  DirectoryWindow (DirList,NumInWin);

  Cursor := 1;
  IF NOT(EmptyList(DirList)) THEN
    BEGIN
      CreateSelect (15,1,0,7,2,1,NumInWin,Cursor,DirList,RTSName,SoundList);
      IF Cursor = 1 THEN MakeRTS (RTSName,SoundList);
    END;

  DestroyList (DirList);

END;

{***************************************************************************}
PROCEDURE BreakSelect
  (RegText, RegBack, SelText, SelBack, Startx, StartY, Height : Byte;
   VAR Cursor    : Byte;
   DirList       : ListType);

VAR
  Choice      : Char;
  Top         : Integer;
  SelectRTS   : ListElementType;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE Move
  (Choice     : Char;
   VAR Cursor : Byte);

VAR
  Count : Byte;

BEGIN
  CASE Choice OF
    #72 : IF Cursor > 1 THEN dec(Cursor)
            ELSE IF (Top + Cursor - 1) > 1 THEN dec(Top);
    #80 : IF Cursor < Height THEN inc(Cursor)
            ELSE IF (Top + Cursor - 1) < ListLength(DirList) THEN inc(Top);
    #71 : BEGIN
            Cursor := 1;
            Top := 1;
          END;
    #79 : BEGIN
            Cursor := Height;
            Top := (ListLength(DirList) - Height + 1);
          END;
  END;
  TcTb (RegText, RegBack);
  FOR Count := 1 TO Height DO
    BEGIN
      SelectRTS.Position := (Count + Top - 1);
      RetrieveElement (DirList,SelectRTS);
      WrtS (StartX,Count,SelectRTS.Name);
    END;
  TcTb (SelText, SelBack);
  SelectRTS.Position := Cursor + Top - 1;
  RetrieveElement (DirList,SelectRTS);
  WrtS (StartX, (Cursor + StartY - 1), SelectRTS.Name);
END;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

BEGIN
  TcTb (SelText, SelBack);
  Top := Cursor;
  SelectRTS.Position := Cursor;
  RetrieveElement (DirList,SelectRTS);
  WrtS (StartX, (Cursor + StartY - 1), SelectRTS.Name);
  Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
  Choice := readkey;
  WHILE NOT(Choice IN [#13,#27]) DO
    BEGIN
      IF Choice IN [#72,#80,#71,#79,#73,#81] THEN Move (Choice,Cursor);
      Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
      Choice := readkey;
    END;
  IF Choice = #13 THEN Cursor := Cursor + Top - 1
    ELSE Cursor := 0;
END;

{***************************************************************************}
PROCEDURE DecompileRTS (Position : Byte; DirList : ListType);

VAR
  Check      : Char;
  Parameter  : STRING;
  DirInfo    : SearchRec;
  WorkingRTS : ListElementType;

BEGIN
  Clear (7,0,1,1,80,25);
  FindFirst ('rtsmaker.exe',Archive,DirInfo);
  IF DOSError <> 0 THEN
      BEGIN
        writeln ('This RTS file could not be unpacked because:');
        writeln;
        writeln ('- RTSMAKER.EXE could not be found in the same directory as DOSRTS.EXE');
        writeln;
        write ('Press <ENTER> to return to DOSRTSMaker...');
        REPEAT
          Check := readkey;
        UNTIL Check = #13;
      END
    ELSE
      BEGIN
        WorkingRTS.Position := Position;
        RetrieveElement (DirList,WorkingRTS);
        delete (WorkingRTS.Name,1,1);
        delete (WorkingRTS.Name,length(WorkingRTS.Name),1);
        Parameter := '-u ' + WorkingRTS.Name;
        exec ('rtsmaker.exe',Parameter);
        writeln;
        write ('Press <ENTER> to return to DOSRTSMaker...');
        REPEAT
          Check := readkey;
        UNTIL Check = #13;
      END;
END;

{***************************************************************************}
PROCEDURE DestroyHelp;

BEGIN
  MakeWin (7,1,54,3,23,13,True,True);
  WrtS (3,2,'');
  WrtS (3,7,'');
  TcTb (11,1);
  WrtS (5,1,'Keyboard Help');

  TcTb (14,1);
  WrtS (2,3,'<ENTER>');
  WrtS (2,5,'<ESCAPE>');
  WrtS (2,8,'<HOME>');
  WrtS (2,10,'<END>');

  TcTb (15,1);
  WrtS (2,4,'Unpack the RTS file');
  WrtS (2,6,'Cancel unpacking');
  WrtS (2,9,'To top of list');
  WrtS (2,11,'To bottom of list');
END;

{***************************************************************************}
PROCEDURE BreakRTS;

VAR
  NumInWin,
  Cursor   : Byte;
  DirList  : ListType;

BEGIN

  CreateList (DirList);

  GetDirectory (DirList,'*.rts','');

  DestroyHelp;

  DirectoryWindow (DirList,NumInWin);

  Cursor := 1;
  IF NOT(EmptyList(DirList)) THEN
    BEGIN
      BreakSelect (15,1,0,7,2,1,NuminWin,Cursor,DirList);
      IF Cursor <> 0 THEN DecompileRTS (Cursor,DirList);
    END;

  DestroyList (DirList);

END;

{***************************************************************************}
PROCEDURE Initialize
  (VAR Menu      : MenuType;
   VAR Exit      : Boolean;
   VAR Cursor    : Byte;
   VAR RTSName   : String8;
   VAR SoundList : SoundArray);

VAR
  Count : 1..10;

BEGIN
  Menu[1] := ' Create a new RTS ';
  Menu[2] := ' Decompile an RTS ';
  Menu[3] := ' Exit DOSRTSMaker ';
  Exit := False;
  Cursor := 1;
  RTSName := 'DEFAULT1';
  FOR Count := 1 TO 10 DO SoundList[Count] := '<EMPTY>';
END;

{***************************************************************************}
PROCEDURE MainScreenSetup
  (Menu : MenuType);

VAR
  Count : Byte;

BEGIN
  Clear (0,7,1,1,80,1);
  WrtS (2,1,'DOSRTSMaker by Charlie Wiederhold');
  WrtS (53,1,'(c) 1996 Charlie Wiederhold');
  Window (1,2,80,25);
  TcTb (8,0);
  FOR Count := 2 TO 24 DO
    WrtS (1,Count,'');
  TcTb (10,0);
  WrtS (74,23,'ver 1.0');
  Clear (0,7,1,25,80,25);
  WrtS (15,1,'Visit WiederWeb: http://ccwf.cc.utexas.edu/~wieder/');
  TcTb (5,7);
  WrtC (13,1,#9);
  WrtC (67,1,#9);
  MakeWin (7,1,28,3,22,5,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 3 DO
    WrtS (2,Count,Menu[Count]);
END;

{***************************************************************************}
PROCEDURE ControlProcessing;

VAR
  Cursor      : Byte;
  Menu        : MenuType;
  Exit        : Boolean;
  RTSName     : String8;
  SoundList   : SoundArray;

BEGIN
  Initialize (Menu,Exit,Cursor,RTSName,SoundList);
  REPEAT
    MainScreenSetup (Menu);
    Select (15,1,0,7,2,1,3,Cursor,Menu);
    CASE Cursor OF
      1 : CreateRTS (RTSName,SoundList);
      2 : BreakRTS;
      3 : Exit := TRUE;
    END;
  UNTIL Exit;
END;

{***************************************************************************}

BEGIN
  checkbreak := False;
  ControlProcessing;
  clear (7,0,1,1,80,25);
  writeln ('Thanks for using DOSRTSMaker by Charlie Wiederhold.');
  writeln ('WiederWeb: http://ccwf.cc.utexas.edu/~wieder/');
END.