PROGRAM EditConFiles (User);

USES
  Crt,
  Utility,
  Settings,
  Sounds;

CONST
  MainBackColor                = 1;
  TextColor                    = 0;
  BackColor                    = 7;
  HighlightColor               = 4;
  HeaderColor                  = 14;
  SelectColor                  = 4;
  DefaultMaxPlayerHealth       = '100';
  DefaultMaxPlayerAtomicHealth = '200';
  DefaultStartArmorHealth      = '0';
  DefaultMaxPistolAmmo         = '200';
  DefaultMaxShotgunAmmo        = '50';
  DefaultMaxChaingunAmmo       = '200';
  DefaultMaxRPGAmmo            = '50';
  DefaultMaxHandbombAmmo       = '50';
  DefaultRPGBlastRadius        = '1780';
  DefaultHandbombBlastRadius   = '2500';
  DefaultKickStrength          = '10';
  DefaultPistolStrength        = '6';
  DefaultHandbombStrength      = '140';
  DefaultRPGStrength           = '140';
  DefaultShotgunStrength       = '10';
  DefaultChaingunStrength      = '9';
  DefaultBossStrength          = '4500';


{***************************************************************************}
PROCEDURE Initialize (VAR MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                      MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                      MaxHandbombAmmo,RPGBlastRadius,HandbombBlastRadius,
                      KickStrength,PistolStrength,HandbombStrength,RPGStrength,
                      ShotgunStrength,ChaingunStrength,BossStrength : STRING);

BEGIN
  MaxPlayerHealth := DefaultMaxPlayerHealth;
  MaxPlayerAtomicHealth := DefaultMaxPlayerAtomicHealth;
  StartArmorHealth :=  DefaultStartArmorHealth;
  MaxPistolAmmo := DefaultMaxPistolAmmo;
  MaxShotgunAmmo := DefaultMaxShotgunAmmo;
  MaxChaingunAmmo := DefaultMaxChaingunAmmo;
  MaxRPGAmmo := DefaultMaxRPGAmmo;
  MaxHandbombAmmo := DefaultMaxHandbombAmmo;
  RPGBlastRadius := DefaultRPGBlastRadius;
  HandbombBlastRadius := DefaultHandbombBlastRadius;
  KickStrength := DefaultKickStrength;
  PistolStrength := DefaultPistolStrength;
  HandbombStrength := DefaultHandbombStrength;
  RPGStrength := DefaultRPGStrength;
  ShotgunStrength := DefaultShotgunStrength;
  ChaingunStrength := DefaultChaingunStrength;
  BossStrength := DefaultBossStrength;
END;

{***************************************************************************}
PROCEDURE RewriteUserFile (VAR User : Text;
                           MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                           MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                           MaxHandbombAmmo,RPGBlastRadius,
                           HandbombBlastRadius,KickStrength,PistolStrength,
                           HandbombStrength,RPGStrength,ShotgunStrength,
                           ChaingunStrength,BossStrength : STRING);

BEGIN
  assign (User, 'user.con');
  rewrite (User);
  WriteIntro (User);
  WriteMiscGameSettings (User,MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                         MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                         MaxHandbombAmmo,RPGBlastRadius,
                         HandbombBlastRadius,KickStrength,PistolStrength,
                         HandbombStrength,RPGStrength,ShotgunStrength,
                         ChaingunStrength,BossStrength);
  WriteQuotes (User);
  WriteLevelNames (User);
  WriteSoundIntro (User);
  WriteActorSounds (User);
  WriteEquipSoundsA (User);
  WriteEquipSoundsB (User);
  close (User);
END;

{***************************************************************************}
PROCEDURE MainScreenSetup;

BEGIN
  Clear (HeaderColor,MainBackColor,1,1,80,25);
  WrtS (19,2,'EditCON Version 1.0 by Charlie Wiederhold');
  WrtS (15,3,'For use with Duke Nukem 3D Shareware Version 1.1');
  MakeWin (TextColor,BackColor,29,4,20,7);
  WrtS (3,1,'Player Info');
  WrtS (3,2,'Weapon Info');
  WrtS (3,3,'Boss Strength');
  WrtS (3,4,'Reset Defaults');
  WrtS (3,5,'Exit EditCON');
END;

{***************************************************************************}
PROCEDURE EditHealth (VAR Health : STRING);

VAR
  Cursor : Byte;

BEGIN
  MakeWin (TextColor,BackColor,55,13,9,11);
  WrtS (3,1,'100');
  WrtS (3,2,'200');
  WrtS (3,3,'300');
  WrtS (3,4,'400');
  WrtS (3,5,'500');
  WrtS (3,6,'600');
  WrtS (3,7,'700');
  WrtS (3,8,'800');
  WrtS (3,9,'900');
  Cursor := 1;
  Select (SelectColor,BackColor,3,9,2,1,Cursor);
  CASE Cursor OF
    1 : Health := '100';
    2 : Health := '200';
    3 : Health := '300';
    4 : Health := '400';
    5 : Health := '500';
    6 : Health := '600';
    7 : Health := '700';
    8 : Health := '800';
    9 : Health := '900';
  END;
  CLEAR (HeaderColor,MainBackColor,55,13,65,24);
END;

{***************************************************************************}
PROCEDURE EditPlayer (VAR MaxPlayerHealth,MaxPlayerAtomicHealth,
                          StartArmorHealth : STRING);

VAR
  Exit   : Boolean;
  Cursor : Byte;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,28,13,24,6);
      WrtS (3,1,'Max Regular Health');
      WrtS (3,2,'Max Atomic Health');
      WrtS (3,3,'Armor Start Amount');
      WrtS (3,4,'Exit Player Edit');
      Select (SelectColor,BackColor,18,4,2,1,Cursor);
      CASE Cursor OF
        1 : EditHealth (MaxPlayerHealth);
        2 : EditHealth (MaxPlayerAtomicHealth);
        3 : EditHealth (StartArmorHealth);
        4 : Exit := True;
      END;
    END;
END;

{***************************************************************************}
PROCEDURE EditAmmo (VAR MaxGunAmmo : STRING);

VAR
  Cursor : Byte;

BEGIN
  MakeWin (TextColor,BackColor,55,10,9,13);
  WrtS (3, 1,'1');
  WrtS (3, 2,'50');
  WrtS (3, 3,'100');
  WrtS (3, 4,'200');
  WrtS (3, 5,'300');
  WrtS (3, 6,'400');
  WrtS (3, 7,'500');
  WrtS (3, 8,'600');
  WrtS (3, 9,'700');
  WrtS (3,10,'800');
  WrtS (3,11,'900');
  Cursor := 1;
  Select (SelectColor,BackColor,3,11,2,1,Cursor);
  CASE Cursor OF
     1 : MaxGunAmmo := '  1';
     2 : MaxGunAmmo := ' 50';
     3 : MaxGunAmmo := '100';
     4 : MaxGunAmmo := '200';
     5 : MaxGunAmmo := '300';
     6 : MaxGunAmmo := '400';
     7 : MaxGunAmmo := '500';
     8 : MaxGunAmmo := '600';
     9 : MaxGunAmmo := '700';
    10 : MaxGunAmmo := '800';
    11 : MaxGunAmmo := '900';
  END;
  CLEAR (HeaderColor,MainBackColor,55,10,65,24);
END;

{***************************************************************************}
PROCEDURE EditMaxAmmo (VAR MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,MaxHandbombAmmo : STRING);

VAR
  Exit   : Boolean;
  Cursor : Byte;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,5,13,14,8);
      WrtS (3,1,'Pistol');
      WrtS (3,2,'Shotgun');
      WrtS (3,3,'Chaingun');
      WrtS (3,4,'RPG');
      WrtS (3,5,'PipeBomb');
      WrtS (3,6,'Exit');
      Select (SelectColor,BackColor,8,6,2,1,Cursor);
      CASE Cursor OF
        1 : EditAmmo (MaxPistolAmmo);
        2 : EditAmmo (MaxShotgunAmmo);
        3 : EditAmmo (MaxChaingunAmmo);
        4 : EditAmmo (MaxRPGAmmo);
        5 : EditAmmo (MaxHandbombAmmo);
        6 : Exit := True;
      END;
    END;
  Clear (HeaderColor,MainBackColor,5,13,20,22);
END;

{***************************************************************************}
PROCEDURE EditStrength (VAR WeaponStrength : STRING);

VAR
  Cursor : Byte;

BEGIN
  MakeWin (TextColor,BackColor,55,13,15,8);
  WrtS (3,1,'Puny');
  WrtS (3,2,'Puny Plus');
  WrtS (3,3,'Normal');
  WrtS (3,4,'Powerful');
  WrtS (3,5,'Too Strong');
  WrtS (3,6,'HELL FIRE');
  Cursor := 1;
  Select (SelectColor,BackColor,9,6,2,1,Cursor);
  CASE Cursor OF
     1 : WeaponStrength := '   1';
     2 : WeaponStrength := '   5';
     3 : WeaponStrength := '  50';
     4 : WeaponStrength := ' 200';
     5 : WeaponStrength := '2000';
     6 : WeaponStrength := '9000';
  END;
  CLEAR (HeaderColor,MainBackColor,55,13,71,22);
END;

{***************************************************************************}
PROCEDURE EditWeaponStrength (VAR KickStrength,PistolStrength,HandBombStrength,
                              RPGStrength,ShotgunStrength,ChaingunStrength : STRING);

VAR
  Exit   : Boolean;
  Cursor : Byte;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,5,13,14,9);
      WrtS (3,1,'Kicking');
      WrtS (3,2,'Pistol');
      WrtS (3,3,'Shotgun');
      WrtS (3,4,'Chaingun');
      WrtS (3,5,'RPG');
      WrtS (3,6,'PipeBomb');
      WrtS (3,7,'Exit');
      Select (SelectColor,BackColor,8,7,2,1,Cursor);
      CASE Cursor OF
        1 : EditStrength (KickStrength);
        2 : EditStrength (PistolStrength);
        3 : EditStrength (ShotgunStrength);
        4 : EditStrength (ChaingunStrength);
        5 : EditStrength (RPGStrength);
        6 : EditStrength (HandbombStrength);
        7 : Exit := True;
      END;
    END;
  Clear (HeaderColor,MainBackColor,5,13,20,23);
END;

{***************************************************************************}
PROCEDURE EditRadius (VAR Radius : STRING);

VAR
  Cursor : Byte;

BEGIN
  MakeWin (TextColor,BackColor,55,13,15,8);
  WrtS (3,1,'Nothing');
  WrtS (3,2,'Short');
  WrtS (3,3,'Normal');
  WrtS (3,4,'Long');
  WrtS (3,5,'Real Long');
  WrtS (3,6,'RUN AWAY!');
  Cursor := 1;
  Select (SelectColor,BackColor,9,6,2,1,Cursor);
  CASE Cursor OF
     1 : Radius := ' 100';
     2 : Radius := '1000';
     3 : Radius := '2000';
     4 : Radius := '3000';
     5 : Radius := '4000';
     6 : Radius := '5000';
  END;
  CLEAR (HeaderColor,MainBackColor,55,13,71,22);
END;

{***************************************************************************}
PROCEDURE EditBlastRadius (VAR RPGBlastRadius,HandbombBlastRadius : STRING);

VAR
  Exit   : Boolean;
  Cursor : Byte;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,5,13,14,5);
      WrtS (3,1,'RPG');
      WrtS (3,2,'PipeBomb');
      WrtS (3,3,'Exit');
      Select (SelectColor,BackColor,8,3,2,1,Cursor);
      CASE Cursor OF
        1 : EditRadius (RPGBlastRadius);
        2 : EditRadius (HandbombBlastRadius);
        3 : Exit := True;
      END;
    END;
  Clear (HeaderColor,MainBackColor,5,13,20,19);
END;

{***************************************************************************}
PROCEDURE EditWeapons (VAR MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                       MaxHandbombAmmo,KickStrength,PistolStrength,HandbombStrength,
                       RPGStrength,ShotgunStrength,ChaingunStrength,
                       RPGBlastRadius,HandbombBlastRadius : STRING);

VAR
  Exit   : Boolean;
  Cursor : Byte;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,28,13,22,6);
      WrtS (3,1,'Max Weapon Ammo');
      WrtS (3,2,'Weapon Strength');
      WrtS (3,3,'Blast Radius');
      WrtS (3,4,'Exit Weapon Edit');
      Select (SelectColor,BackColor,16,4,2,1,Cursor);
      CASE Cursor OF
        1 : EditMaxAmmo (MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,MaxHandbombAmmo);
        2 : EditWeaponStrength (KickStrength,PistolStrength,HandBombStrength,RPGStrength,ShotgunStrength,ChaingunStrength);
        3 : EditBlastRadius (RPGBlastRadius,HandbombBlastRadius);
        4 : Exit := True;
      END;
    END;
END;

{***************************************************************************}
PROCEDURE EditBoss (VAR BossStrength : STRING);

VAR
  Cursor : Byte;

BEGIN
  MakeWin (TextColor,BackColor,30,13,19,7);
  WrtS (3,1,'Complete Wimp');
  WrtS (3,2,'Not Too Bad');
  WrtS (3,3,'Normal Power');
  WrtS (3,4,'Pretty Hard');
  WrtS (3,5,'Are You CRAZY');
  Cursor := 1;
  Select (SelectColor,BackColor,13,5,2,1,Cursor);
  CASE Cursor OF
    1 : BossStrength := ' 500';
    2 : BossStrength := '2000';
    3 : BossStrength := '4500';
    4 : BossStrength := '7000';
    5 : BossStrength := '9500';
  END;
END;

{***************************************************************************}
PROCEDURE ResetDefaults (VAR MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                         MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                         MaxHandbombAmmo,RPGBlastRadius,
                         HandbombBlastRadius,KickStrength,PistolStrength,
                         HandbombStrength,RPGStrength,ShotgunStrength,
                         ChaingunStrength,BossStrength : STRING);

VAR
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,28,13,23,3);
  WrtS (2,1,'Are you sure? <Y/N>');
  HideCursor (1,1,7);
  REPEAT
    Choice := Upcase(Readkey);
  UNTIL (Choice = 'Y') OR (Choice = 'N');
  IF Choice = 'Y' THEN
      Initialize (MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                  MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                  MaxHandbombAmmo,RPGBlastRadius,
                  HandbombBlastRadius,KickStrength,PistolStrength,
                  HandbombStrength,RPGStrength,ShotgunStrength,
                  ChaingunStrength,BossStrength);
END;

{***************************************************************************}
PROCEDURE CheckExit (VAR Exit : Boolean);

VAR
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,28,13,23,3);
  WrtS (2,1,'Are you sure? <Y/N>');
  HideCursor (1,1,7);
  REPEAT
    Choice := Upcase(Readkey);
  UNTIL (Choice = 'Y') OR (Choice = 'N');
  IF Choice = 'Y' THEN Exit := True;
END;

{***************************************************************************}
PROCEDURE GetCurrentValues (VAR Current : Text;
                            VAR MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                            MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                            MaxHandbombAmmo,RPGBlastRadius,
                            HandbombBlastRadius,KickStrength,PistolStrength,
                            HandbombStrength,RPGStrength,ShotgunStrength,
                            ChaingunStrength,BossStrength : STRING);

BEGIN
  assign (Current, 'current.val');
  reset  (Current);
  readln (Current);
  readln (Current);
  readln (Current,MaxPlayerHealth);
  readln (Current,MaxPlayerAtomicHealth);
  readln (Current,StartArmorHealth);
  readln (Current,MaxPistolAmmo);
  readln (Current,MaxShotgunAmmo);
  readln (Current,MaxChaingunAmmo);
  readln (Current,MaxRPGAmmo);
  readln (Current,MaxHandbombAmmo);
  readln (Current,RPGBlastRadius);
  readln (Current,HandbombBlastRadius);
  readln (Current,KickStrength);
  readln (Current,PistolStrength);
  readln (Current,HandbombStrength);
  readln (Current,RPGStrength);
  readln (Current,ShotgunStrength);
  readln (Current,ChaingunStrength);
  readln (Current,BossStrength);
  close (Current);
END;

{***************************************************************************}
PROCEDURE SaveCurrentValues (VAR User, Current : Text;
                             MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                             MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                             MaxHandbombAmmo,RPGBlastRadius,
                             HandbombBlastRadius,KickStrength,PistolStrength,
                             HandbombStrength,RPGStrength,ShotgunStrength,
                             ChaingunStrength,BossStrength : STRING);

BEGIN
  assign (User, 'user.con');
  rewrite (User);
  WriteIntro (User);
  WriteMiscGameSettings (User,MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                         MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                         MaxHandbombAmmo,RPGBlastRadius,
                         HandbombBlastRadius,KickStrength,PistolStrength,
                         HandbombStrength,RPGStrength,ShotgunStrength,
                         ChaingunStrength,BossStrength);
  WriteQuotes (User);
  WriteLevelNames (User);
  WriteSoundIntro (User);
  WriteActorSounds (User);
  WriteEquipSoundsA (User);
  WriteEquipSoundsB (User);
  close (User);
  assign (Current, 'current.val');
  rewrite (Current);
  writeln (Current,'DO NOT DELETE! This file is used by EditCON.');
  writeln (Current);
  writeln (Current,MaxPlayerHealth);
  writeln (Current,MaxPlayerAtomicHealth);
  writeln (Current,StartArmorHealth);
  writeln (Current,MaxPistolAmmo);
  writeln (Current,MaxShotgunAmmo);
  writeln (Current,MaxChaingunAmmo);
  writeln (Current,MaxRPGAmmo);
  writeln (Current,MaxHandbombAmmo);
  writeln (Current,RPGBlastRadius);
  writeln (Current,HandbombBlastRadius);
  writeln (Current,KickStrength);
  writeln (Current,PistolStrength);
  writeln (Current,HandbombStrength);
  writeln (Current,RPGStrength);
  writeln (Current,ShotgunStrength);
  writeln (Current,ChaingunStrength);
  writeln (Current,BossStrength);
  close (Current);
END;

{***************************************************************************}
PROCEDURE ControlProcessing;

VAR
  User,
  Current               : Text;
  Exit                  : Boolean;
  Choice                : Char;
  Cursor                : Byte;
  MaxPlayerHealth,
  MaxPlayerAtomicHealth,
  StartArmorHealth,
  MaxPistolAmmo,
  MaxShotgunAmmo,
  MaxChaingunAmmo,
  MaxRPGAmmo,
  MaxHandbombAmmo,
  RPGBlastRadius,
  HandbombBlastRadius,
  KickStrength,
  PistolStrength,
  HandbombStrength,
  RPGStrength,
  ShotgunStrength,
  ChaingunStrength,
  BossStrength          : STRING;

BEGIN

  GetCurrentValues (Current,MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                    MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                    MaxHandbombAmmo,RPGBlastRadius,
                    HandbombBlastRadius,KickStrength,PistolStrength,
                    HandbombStrength,RPGStrength,ShotgunStrength,
                    ChaingunStrength,BossStrength);
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MainscreenSetup;
      Select (SelectColor,BackColor,14,5,2,1,Cursor);
      CASE Cursor OF
        1 : EditPlayer (MaxPlayerHealth,MaxPlayerAtomicHealth,
                        StartArmorHealth);
        2 : EditWeapons (MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                         MaxHandbombAmmo,KickStrength,PistolStrength,HandbombStrength,
                         RPGStrength,ShotgunStrength,ChaingunStrength,
                         RPGBlastRadius,HandbombBlastRadius);
        3 : EditBoss (BossStrength);
        4 : ResetDefaults (MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                           MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                           MaxHandbombAmmo,RPGBlastRadius,
                           HandbombBlastRadius,KickStrength,PistolStrength,
                           HandbombStrength,RPGStrength,ShotgunStrength,
                           ChaingunStrength,BossStrength);
        5 : CheckExit (Exit);
      END;
    END;
  MakeWin (TextColor,BackColor,26,13,27,3);
  WrtS (2,1,'Save all changes? <Y/N>');
  HideCursor (1,1,7);
  REPEAT
    Choice := Upcase(Readkey);
  UNTIL (Choice = 'Y') OR (Choice = 'N');
  IF Choice = 'Y' THEN
      SaveCurrentValues (User,Current,MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                        MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                        MaxHandbombAmmo,RPGBlastRadius,
                        HandbombBlastRadius,KickStrength,PistolStrength,
                        HandbombStrength,RPGStrength,ShotgunStrength,
                        ChaingunStrength,BossStrength);
  Clear (7,0,1,1,80,25);
  writeln ('Exiting EditCON Version 1.0 by Charlie Wiederhold....');
  writeln;
END;

{***************************************************************************}

BEGIN
  ControlProcessing;
END.