UNIT Settings;

INTERFACE

PROCEDURE WriteIntro            (VAR User : Text);
PROCEDURE WriteMiscGameSettings (VAR User : Text;
                                 MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                                 MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                                 MaxHandbombAmmo,RPGBlastRadius,
                                 HandbombBlastRadius,KickStrength,PistolStrength,
                                 HandbombStrength,RPGStrength,ShotgunStrength,
                                 ChaingunStrength,BossStrength : STRING);
PROCEDURE WriteQuotes           (VAR User : Text);
PROCEDURE WriteLevelNames       (VAR User : Text);

IMPLEMENTATION

PROCEDURE WriteIntro (VAR User : Text);

BEGIN
writeln (User, '');
writeln (User, '/* This .CON file edited by EditCON written by Charlie Wiederhold');
writeln (User, '--------------------------------------------------------------------------------');
writeln (User, 'IMPORTANT NOTICE IF YOU USE MODIFIED .CON FILES');
writeln (User, '');
writeln (User, 'If you are playing a MULTIPLAY game (Dukematch or Co-op) and you are');
writeln (User, 'using *modified* .CON files (USER.CON, GAME.CON, DEFS.CON), then each');
writeln (User, 'multiplayer must be using the EXACT SAME .CON files, or the game will');
writeln (User, 'get out of sync and/or develop other problems.');
writeln (User, '');
writeln (User, '--------------------------------------------------------------------------------');
writeln (User, 'Duke Nukem 3D Update');
writeln (User, 'by Todd Replogle');
writeln (User, '');
writeln (User, 'SHAREWARE VERSION   v1.1');
writeln (User, '');
writeln (User, '     Red Trooper doesn''t ''beam'' away as much, and don''t respawn into');
writeln (User, '      walls.');
writeln (User, '');
writeln (User, '     The BLAST RADIUSES for various weapons are redefinable.');
writeln (User, '');
writeln (User, '     Respawn times have been split into two separate variables,');
writeln (User, '      RESPAWNACTORTIME and RESPAWNITEMTIME.');
writeln (User, '');
writeln (User, '     Duke''s running speed/friction is redefinable.');
writeln (User, '');
writeln (User, '     Minor weapon hit point balance adjustments.');
writeln (User, '');
writeln (User, '--------------------------------------------------------------------------------');
writeln (User, '');
writeln (User, 'SHAREWARE VERSION   v1.0');
writeln (User, '');
writeln (User, 'This file is designed to allow users to modify certain parameters');
writeln (User, 'within the game that affect Duke, his weapons, actors and their');
writeln (User, 'weapons, sound fx, system messages, etc.');
writeln (User, '');
writeln (User, '3D Realms encourages you to experiment freely with the parameters');
writeln (User, 'contained in this file, and to share your discoveries with the rest');
writeln (User, 'of the world.  However, BE ADVISED that 3D Realms does NOT offer ');
writeln (User, 'any technical support on how to use this file or other user-modifiable ');
writeln (User, 'features of this game.  Do NOT call 3D Realms or Apogee Software ');
writeln (User, 'for advice or help with this subject.  ');
writeln (User, '');
writeln (User, 'You make modifications to this and other files at your own risk. ');
writeln (User, 'It is recommended that you first make a backup copy of the game ');
writeln (User, 'before making any changes.');
writeln (User, '');
writeln (User, 'Finally, be aware that this is the SHAREWARE VERSION of Duke Nukem 3D.');
writeln (User, 'The complete REGISTERED VERSION on CDROM contains a more complete');
writeln (User, 'set of useful and interesting tools to enable you to make many more');
writeln (User, 'significant changes to the game, including a level and art editor which');
writeln (User, 'allows you to create your own maps.');
writeln (User, '');
writeln (User, 'TECH FACTS YOU SHOULD KNOW:');
writeln (User, 'The game expects to find the file USER.CON in its directory.  So, if');
writeln (User, 'you make changes and rename it for safe keeping or for sharing with');
writeln (User, 'friends, be sure to rename it back to USER.CON before using it with');
writeln (User, 'the game.');
writeln (User, '');
writeln (User, 'Other tech facts are scattered throughout the rest of this file.');
writeln (User, '');
writeln (User, '--------------------------------------------------------------------------------');
END;

PROCEDURE WriteMiscGameSettings (VAR User : Text;
                                 MaxPlayerHealth,MaxPlayerAtomicHealth,StartArmorHealth,
                                 MaxPistolAmmo,MaxShotgunAmmo,MaxChaingunAmmo,MaxRPGAmmo,
                                 MaxHandbombAmmo,RPGBlastRadius,
                                 HandbombBlastRadius,KickStrength,PistolStrength,
                                 HandbombStrength,RPGStrength,ShotgunStrength,
                                 ChaingunStrength,BossStrength : STRING);

BEGIN
writeln (User, '*/');
writeln (User, '');
writeln (User, '// ******************');
writeln (User, '// MISC GAME SETTINGS');
writeln (User, '// ******************');
writeln (User, '');
writeln (User, 'define MAXPLAYERHEALTH          ', MaxPlayerHealth);
writeln (User, '');
writeln (User, 'define MAXPLAYERATOMICHEALTH    ', MaxPlayerAtomicHealth, '     // doubles as maxarmor.');
writeln (User, 'define DOUBLEMAXPLAYERHEALTH    MAXPLAYERATOMICHEALTH');
writeln (User, 'define STARTARMORHEALTH         ', StartArmorHealth);
writeln (User, 'define RETRIEVEDISTANCE         844');
writeln (User, 'define DEFAULTVISIBILITY        512');
writeln (User, 'define GENERICIMPACTDAMAGE      10');
writeln (User, '');
writeln (User, 'define MAXPISTOLAMMO           ', MaxPistolAmmo);
writeln (User, 'define MAXSHOTGUNAMMO           ', MaxShotgunAmmo);
writeln (User, 'define MAXCHAINGUNAMMO         ', MaxChaingunAmmo);
writeln (User, 'define MAXRPGAMMO               ', MaxRPGAmmo);
writeln (User, 'define MAXHANDBOMBAMMO          ', MaxHandbombAmmo);
writeln (User, 'define MAXSHRINKERAMMO          50');
writeln (User, 'define MAXFLAMETHROWERAMMO      99');
writeln (User, 'define MAXTRIPBOMBAMMO          10');
writeln (User, '');
writeln (User, 'define RESPAWNACTORTIME 768');
writeln (User, 'define RESPAWNITEMTIME 768');
writeln (User, '');
writeln (User, 'define RUNNINGSPEED 53200');
writeln (User, '');
writeln (User, 'define PLAYDEADTIME 120');
writeln (User, 'define SHRUNKCOUNT 270');
writeln (User, 'define SHRUNKDONECOUNT 304');
writeln (User, '');
writeln (User, '// Various blasting radius distances.');
writeln (User, '');
writeln (User, 'define RPGBLASTRADIUS           ', RPGBlastRadius);
writeln (User, 'define PIPEBOMBRADIUS           ', HandbombBlastRadius);
writeln (User, 'define SHRINKERBLASTRADIUS      2048');
writeln (User, 'define TRIPBOMBBLASTRADIUS      3880');
writeln (User, 'define MORTERBLASTRADIUS        2500');
writeln (User, 'define BOUNCEMINEBLASTRADIUS    2500');
writeln (User, 'define SEENINEBLASTRADIUS       2048');
writeln (User, '');
writeln (User, 'gamestartup     DEFAULTVISIBILITY GENERICIMPACTDAMAGE MAXPLAYERHEALTH');
writeln (User, '                STARTARMORHEALTH  RESPAWNACTORTIME RESPAWNITEMTIME RUNNINGSPEED');
writeln (User, '                RPGBLASTRADIUS PIPEBOMBRADIUS SHRINKERBLASTRADIUS TRIPBOMBBLASTRADIUS');
writeln (User, '                MORTERBLASTRADIUS BOUNCEMINEBLASTRADIUS SEENINEBLASTRADIUS');
writeln (User, '                MAXPISTOLAMMO MAXSHOTGUNAMMO MAXCHAINGUNAMMO');
writeln (User, '                MAXRPGAMMO MAXHANDBOMBAMMO MAXSHRINKERAMMO MAXFLAMETHROWERAMMO');
writeln (User, '                MAXTRIPBOMBAMMO');
writeln (User, '');
writeln (User, '// Weapon Strengths');
writeln (User, 'define KNEE_WEAPON_STRENGTH             ', KickStrength);
writeln (User, 'define PISTOL_WEAPON_STRENGTH            ', PistolStrength, '  // Adds rand()%5 (0 to 5)');
writeln (User, 'define HANDBOMB_WEAPON_STRENGTH        ', HandbombStrength);
writeln (User, '');
writeln (User, '');
writeln (User, '');
writeln (User, '// For direct hits with the rocket launcher,');
writeln (User, '// this amount is actually doubled.  Otherwise,');
writeln (User, '// damage values depend on distance. The');
writeln (User, '// further, the weaker.');
writeln (User, '');
writeln (User, 'define RPG_WEAPON_STRENGTH              ', RPGStrength);
writeln (User, '');
writeln (User, '');
writeln (User, 'define SHRINKER_WEAPON_STRENGTH          0');
writeln (User, 'define SHOTGUN_WEAPON_STRENGTH          ', ShotgunStrength);
writeln (User, 'define CHAINGUN_WEAPON_STRENGTH          ', ChaingunStrength);
writeln (User, 'define FLAMETHROWER_WEAPON_STRENGTH     10');
writeln (User, 'define COOL_EXPLOSION_STRENGTH          38');
writeln (User, 'define TRIPBOMB_STRENGTH               100');
writeln (User, 'define FIRELASER_WEAPON_STRENGTH         7');
writeln (User, 'define MORTER_WEAPON_STRENGTH           50');
writeln (User, 'define BOUNCEMINE_WEAPON_STRENGTH      150');
writeln (User, 'define SPIT_WEAPON_STRENGTH              8');
writeln (User, 'define BULLET_WEAPON_STRENGTH           30');
writeln (User, '');
writeln (User, '// Enemy strengths (hit points).');
writeln (User, '');
writeln (User, 'define TROOPSTRENGTH            30');
writeln (User, 'define PIGCOPSTRENGTH           100');
writeln (User, 'define PIG_SHIELD_AMOUNT1       75');
writeln (User, 'define PIG_SHIELD_AMOUNT2       50');
writeln (User, 'define LIZSTRENGTH              60');
writeln (User, 'define LIZGETTINGDAZEDAT        15');
writeln (User, 'define LIZEATINGPLAYER          -2');
writeln (User, 'define JELLYSTRENGTH           175');
writeln (User, 'define JELLYSCRATCHINGPLAYER   -11');
writeln (User, 'define RECONSTRENGTH            50');
writeln (User, 'define TURRETSTRENGTH           30');
writeln (User, 'define ROTTURRETSTRENGTH        40');
writeln (User, 'define DRONESTRENGTH            20');
writeln (User, 'define SNAKESTRENGTH            50');
writeln (User, 'define CAPTAINSTRENGTH          50');
writeln (User, 'define CAPTSPINNINGPLAYER       -5');
writeln (User, 'define FATGUYSTRENGTH           120');
writeln (User, '');
writeln (User, 'define PISTOLAMMOAMOUNT         12');
writeln (User, 'define SHOTGUNAMMOAMOUNT        10');
writeln (User, 'define CHAINGUNAMMOAMOUNT       50');
writeln (User, 'define RPGAMMOBOX               5');
writeln (User, 'define CRYSTALAMMOAMOUNT        1');
writeln (User, 'define FUELAMMOAMOUNT           25');
writeln (User, 'define HANDBOMBBOX              5');
writeln (User, '');
writeln (User, '');
writeln (User, 'define BOSS1STRENGTH            ', BossStrength);
writeln (User, 'define BOSS2SMALLDUKESTRENGTH   1500');
writeln (User, 'define BOSS2LARGEDUKESTRENGTH   1500');
writeln (User, 'define BOSS3STRENGTH            2000');
writeln (User, '');
writeln (User, '');
writeln (User, '// Miscellaneous strengths.');
writeln (User, '');
writeln (User, 'define WEAKEST           1');
writeln (User, 'define WEAK              5');
writeln (User, 'define MEDIUMSTRENGTH    10');
writeln (User, 'define TOUGH             20');
writeln (User, 'define REALLYTOUGH       30');
writeln (User, 'define HBOMBTOUGH       100');
writeln (User, 'define GOTTASMART        90');
writeln (User, 'define BOMBTOUGH        100');
writeln (User, '');
writeln (User, '');
writeln (User, '// Players'' inventory amounts.');
writeln (User, '');
writeln (User, 'define STEROID_AMOUNT           400');
writeln (User, 'define SHIELD_AMOUNT            100');
writeln (User, 'define SCUBA_AMOUNT            6400');
writeln (User, 'define HOLODUKE_AMOUNT         2400');
writeln (User, 'define JETPACK_AMOUNT          1600');
writeln (User, 'define BODYSUIT_AMOUNT         1600');
writeln (User, 'define HEAT_AMOUNT             1200');
writeln (User, 'define FIRSTAID_AMOUNT          MAXPLAYERHEALTH');
writeln (User, 'define BOOT_AMOUNT              200');
writeln (User, '');
writeln (User, 'define SPAWNAMMOODDS             96');
writeln (User, '');
writeln (User, '');
END;

PROCEDURE WriteQuotes (VAR User : Text);

BEGIN
writeln (User, '// Maximum quote size is 64 characters.');
writeln (User, 'definequote  0        AUTO AIMING');
writeln (User, 'definequote  1        MANUAL AIMING / SNIPER MODE!');
writeln (User, 'definequote  2        ACTIVATED');
writeln (User, 'definequote  3        MEDKIT');
writeln (User, 'definequote  4        LOCKED');
writeln (User, 'definequote  5        GIVING EVERYTHING!');
writeln (User, 'definequote  6        BOOTS');
writeln (User, 'definequote  7        WASTED!');
writeln (User, 'definequote  8        UNLOCKED');
writeln (User, 'definequote  9        A SECRET PLACE!');
writeln (User, 'definequote 10        SQUISH!');
writeln (User, 'definequote 11        ALL DOORS UNLOCKED');
writeln (User, 'definequote 12        USED STEROIDS');
writeln (User, 'definequote 13        PRESS SPACE TO RESTART LEVEL');
writeln (User, 'definequote 14        n/a');
writeln (User, 'definequote 15        DEACTIVATED');
writeln (User, 'definequote 16        SWITCH OPERATED ONLY!');
writeln (User, 'definequote 17        GOD MODE: ON');
writeln (User, 'definequote 18        GOD MODE: OFF');
writeln (User, 'definequote 19        HEALING!');
writeln (User, 'definequote 20        CROSSHAIR OFF');
writeln (User, 'definequote 21        CROSSHAIR ON');
writeln (User, 'definequote 22        YOU''RE TOO GOOD TO BE CHEATING!');
writeln (User, 'definequote 23        MESSAGES: ON');
writeln (User, 'definequote 24        MESSAGES: OFF');
writeln (User, 'definequote 25        TYPE THE CHEAT CODE:');
writeln (User, 'definequote 26        DETAIL: LOW');
writeln (User, 'definequote 27        DETAIL: HIGH');
writeln (User, 'definequote 28        LOADING QUICK GAME...');
writeln (User, 'definequote 29        BRIGHTNESS LEVEL: ONE');
writeln (User, 'definequote 30        BRIGHTNESS LEVEL: TWO');
writeln (User, 'definequote 31        BRIGHTNESS LEVEL: THREE');
writeln (User, 'definequote 32        BRIGHTNESS LEVEL: FOUR');
writeln (User, 'definequote 33        BRIGHTNESS LEVEL: FIVE');
writeln (User, 'definequote 34        SOUND: ON');
writeln (User, 'definequote 35        SOUND: OFF');
writeln (User, 'definequote 36        SCREEN CAPTURED');
writeln (User, 'definequote 37        STEROIDS');
writeln (User, 'definequote 38        ARMOR');
writeln (User, 'definequote 39        SCUBA GEAR');
writeln (User, 'definequote 40        Press F1 for Help');
writeln (User, 'definequote 41        JETPACK');
writeln (User, 'definequote 42        BODY SUIT');
writeln (User, 'definequote 43        ACCESS CARD');
writeln (User, 'definequote 44        MOUSE AIMING OFF');
writeln (User, 'definequote 45        MOUSE AIMING ON');
writeln (User, 'definequote 46        CHEAT CODE:  UNRECOGNIZED');
writeln (User, 'definequote 47        HOLODUKE ON');
writeln (User, 'definequote 48        HOLODUKE OFF');
writeln (User, 'definequote 49        HOLODUKE NOT FOUND YET!');
writeln (User, 'definequote 50        JETPACK NOT FOUND YET!');
writeln (User, 'definequote 51        HOLODUKE');
writeln (User, 'definequote 52        JETPACK ON');
writeln (User, 'definequote 53        JETPACK OFF');
writeln (User, 'definequote 54        CHAINGUN CANNON!');
writeln (User, 'definequote 55        PIPEBOMB!');
writeln (User, 'definequote 56        RPG!');
writeln (User, 'definequote 57        SHOTGUN');
writeln (User, 'definequote 58        LASER TRIPBOMB!');
writeln (User, 'definequote 59        FLAMETHROWER!');
writeln (User, 'definequote 60        SHRINKER!');
writeln (User, 'definequote 61        SMALL MEDKIT: +10');
writeln (User, 'definequote 62        LARGE MEDKIT: +30');
writeln (User, 'definequote 63        AMMO FOR CHAINGUN CANNON!');
writeln (User, 'definequote 64        AMMO FOR RPG!');
writeln (User, 'definequote 65        AMMO FOR PISTOL!');
writeln (User, 'definequote 66        AMMO FOR FLAMETHROWER!');
writeln (User, 'definequote 67        BOOTS OFF');
writeln (User, 'definequote 68        BOOTS ON');
writeln (User, 'definequote 69        AMMO FOR SHOTGUN');
writeln (User, 'definequote 70        BLUE ACCESS CARD REQUIRED');
writeln (User, 'definequote 71        RED ACCESS CARD REQUIRED');
writeln (User, 'definequote 72        YELLOW ACCESS CARD REQUIRED');
writeln (User, 'definequote 73        WEAPON LOWERED');
writeln (User, 'definequote 74        WEAPON RAISED');
writeln (User, 'definequote 75        PROTECTIVE BOOTS ON');
writeln (User, 'definequote 76        SCUBA GEAR ON');
writeln (User, 'definequote 77        SPACE SUIT ON');
writeln (User, 'definequote 78        AMMO FOR SHRINKER');
writeln (User, 'definequote 79        BUY MAJOR STRYKER');
writeln (User, 'definequote 80        MIGHTY FOOT ENGAGED');
writeln (User, 'definequote 81        WEAPON MODE ON');
writeln (User, 'definequote 82        WEAPON MODE OFF');
writeln (User, 'definequote 83        FOLLOW MODE OFF');
writeln (User, 'definequote 84        FOLLOW MODE ON');
writeln (User, 'definequote 85        RUN MODE OFF');
writeln (User, 'definequote 86        RUN MODE ON');
writeln (User, 'definequote 87        SPACE SUIT');
writeln (User, 'definequote 88        JET PACK');
writeln (User, 'definequote 89        AIRTANK');
writeln (User, 'definequote 90        STEROIDS');
writeln (User, 'definequote 91        HOLODUKE');
writeln (User, 'definequote 92        MUSIC: ON');
writeln (User, 'definequote 93        MUSIC: OFF');
writeln (User, 'definequote 94        SCROLL MODE: ON');
writeln (User, 'definequote 95        SCROLL MODE: OFF');
writeln (User, 'definequote 96        BRIGHTNESS LEVEL: SIX');
writeln (User, 'definequote 97        BRIGHTNESS LEVEL: SEVEN');
writeln (User, 'definequote 98        BRIGHTNESS LEVEL: EIGHT');
writeln (User, 'definequote 99        REGISTER COSMO TODAY!');
writeln (User, 'definequote 100       n/a');
writeln (User, 'definequote 101       NIGHT VISION GOGGLES');
writeln (User, 'definequote 102       WE''RE GONNA FRY YOUR ASS, NUKEM!');
writeln (User, 'definequote 103       SCREEN SAVED');
writeln (User, 'definequote 104       GOT USED ARMOR');
writeln (User, 'definequote 105       PIRATES SUCK!');
writeln (User, 'definequote 106       NIGHT VISION ON');
writeln (User, 'definequote 107       NIGHT VISION OFF');
writeln (User, 'definequote 108       YOU''RE BURNING!  ');
writeln (User, 'definequote 109       VIEW MODE OFF');
writeln (User, 'definequote 110       VIEW MODE ON');
writeln (User, 'definequote 111       n/a');
writeln (User, 'definequote 112       CLIPPING: ON');
writeln (User, 'definequote 113       CLIPPING: OFF');
writeln (User, 'definequote 114       !!! INCORRECT VERSION !!!');
writeln (User, 'definequote 115       <Please Leave Blank>');
writeln (User, 'definequote 116       <Please Leave Blank>');
writeln (User, 'definequote 117       <Please Leave Blank>');
writeln (User, '');
END;

PROCEDURE WriteLevelNames (VAR User : Text);

BEGIN
writeln (User, '// Level file names cannot excede 13 characters.');
writeln (User, '// Level par cannot excede 5 characters (min:sec)');
writeln (User, '// Level titles cannot excede 32 characters.');
writeln (User, '');
writeln (User, 'definelevelname 0 0 E1L1.map 01:45 00:53 HOLLYWOOD HOLOCAUST');
writeln (User, 'definelevelname 0 1 E1L2.map 05:10 03:21 RED LIGHT DISTRICT');
writeln (User, 'definelevelname 0 2 E1L3.map 05:35 03:41 DEATH ROW');
writeln (User, 'definelevelname 0 3 E1L4.map 07:20 04:40 TOXIC DUMP');
writeln (User, 'definelevelname 0 4 E1L5.map 09:10 05:00 THE ABYSS');
writeln (User, 'definelevelname 0 5 E1L6.map 05:15 02:58 LAUNCH FACILITY');
writeln (User, 'definelevelname 0 6 E1L7.map 00:00 00:00 BLANK');
writeln (User, 'definelevelname 0 7 E1L8.map 00:00 00:00 BLANK');
writeln (User, '');
writeln (User, '');
writeln (User, 'definelevelname 1 0 E2L1.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 1 E2L2.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 2 E2L3.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 3 E2L4.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 4 E2L5.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 5 E2L6.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 6 E2L7.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 7 E2L8.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 1 8 E2L9.map 00:00 00:00 n/a');
writeln (User, '');
writeln (User, 'definelevelname 2 0 E3L1.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 1 E3L2.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 2 E3L3.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 3 E3L4.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 4 E3L5.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 5 E3L6.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 6 E3L7.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 7 E3L8.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 2 8 E3L9.map 00:00 00:00 n/a');
writeln (User, '');
writeln (User, 'definelevelname 3 0 E4L1.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 1 E4L2.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 2 E4L3.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 3 E4L4.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 4 E4L5.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 5 E4L6.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 6 E4L7.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 7 E4L8.map 00:00 00:00 n/a');
writeln (User, 'definelevelname 3 8 E4L9.map 00:00 00:00 USER FILE');
writeln (User, '');
END;

END.