UNIT ResetSave;

INTERFACE

USES
  UserCon1,
  UserCon2,
  GameCon1,
  GameCon2,
  GameCon3,
  DefsCon,
  Crt,
  ECData,
  Utility;

PROCEDURE SaveFiles        (Player : PlayerR;
                            Ammo : AmmoR;
                            Box : BoxR;
                            Strength : StrengthR;
                            Radius : RadiusR;
                            Enemy : EnemyR);

PROCEDURE GetCurrentValues (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

PROCEDURE ResetDefaultVals (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

PROCEDURE PrintCurrentVals (Player : PlayerR;
                            Ammo : AmmoR;
                            Box : BoxR;
                            Strength : StrengthR;
                            Radius : RadiusR;
                            Enemies : EnemyR);
PROCEDURE PrintFileVals;

IMPLEMENTATION

{***************************************************************************}
PROCEDURE SaveFiles (Player : PlayerR;
                     Ammo : AmmoR;
                     Box : BoxR;
                     Strength : StrengthR;
                     Radius : RadiusR;
                     Enemy : EnemyR);

VAR
  Data     : DataR;
  Current  : DataF;
  UserFile,
  GameFile,
  DefsFile : Text;

BEGIN
  assign (UserFile, 'user.con');
  rewrite (UserFile);
  UserPart1 (UserFile);
  UserPart2 (UserFile,Player,Ammo,Box,Strength,Radius,Enemy);
  UserPart3 (UserFile);
  UserPart4 (UserFile);
  UserPart5 (UserFile);
  UserPart6 (UserFile);
  UserPart7 (UserFile);
  UserPart8 (UserFile);
  close (UserFile);

  assign (GameFile, 'game.con');
  rewrite (GameFile);
  GamePart1 (GameFile);
  GamePart2 (GameFile);
  GamePart3 (GameFile);
  GamePart4 (GameFile);
  GamePart5 (GameFile);
  GamePart6 (GameFile);
  GamePart7 (GameFile);
  GamePart8 (GameFile);
  GamePart9 (GameFile);
  close (GameFile);

  assign (DefsFile, 'defs.con');
  rewrite (DefsFile);
  DefsPart1 (DefsFile);
  DefsPart2 (DefsFile);
  DefsPart3 (DefsFile);
  DefsPart4 (DefsFile);
  DefsPart5 (DefsFile);
  DefsPart6 (DefsFile);
  DefsPart7 (DefsFile);
  close (DefsFile);

  assign (Current, 'editcon.val');
  rewrite (Current);
  Data.Player := Player;
  Data.Ammo := Ammo;
  Data.Box := Box;
  Data.Strength := Strength;
  Data.Radius := Radius;
  Data.Enemy := Enemy;
  write (Current,Data);
  close (Current);
END;

{***************************************************************************}
PROCEDURE GetCurrentValues (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

VAR
  Data     : DataR;
  Current  : DataF;

BEGIN
  assign (Current, 'editcon.val');
  reset  (Current);
  read (Current,Data);
  Player := Data.Player;
  Ammo := Data.Ammo;
  Box := Data.Box;
  Strength := Data.Strength;
  Radius := Data.Radius;
  Enemy := Data.Enemy;
  close (Current);
END;

{***************************************************************************}
PROCEDURE ResetDefaultVals (VAR Player : PlayerR;
                            VAR Ammo : AmmoR;
                            VAR Box : BoxR;
                            VAR Strength : StrengthR;
                            VAR Radius : RadiusR;
                            VAR Enemy : EnemyR);

BEGIN
  Player.MaxHealth1 := DefMaxHealth1;
  Player.MaxHealth2 := DefMaxHealth2;
  Player.MaxArmor   := DefMaxArmor;
  Player.StartArmor := DefStartArmor;
  Player.Steroids := DefSteroids;
  Player.Scuba := DefScuba;
  Player.Holoduke := DefHoloduke;
  Player.Jetpack := DefJetpack;
  Player.Boots := DefBoots;
  Player.Vision := DefVision;
  Player.Medkit := DefMedkit;
  Ammo.Pistol := DefPistolAmmo;
  Ammo.Shotgun := DefShotgunAmmo;
  Ammo.Chaingun := DefChaingunAmmo;
  Ammo.RPG := DefRPGAmmo;
  Ammo.Pipebomb := DefPipebombAmmo;
  Box.Pistol := DefPistolBox;
  Box.Shotgun := DefShotgunBox;
  Box.Chaingun := DefChaingunBox;
  Box.RPG := DefRPGBox;
  Box.Pipebomb := DefPipebombBox;
  Radius.RPG := DefRPGRadius;
  Radius.Pipebomb := DefPipebombRadius;
  Strength.Kick := DefKickStrength;
  Strength.Pistol := DefPistolStrength;
  Strength.Pipebomb := DefPipebombStrength;
  Strength.RPG := DefRPGStrength;
  Strength.Shotgun := DefShotgunStrength;
  Strength.Chaingun := DefChaingunStrength;
  Enemy.Trooper := DefTrooperStrength;
  Enemy.RedTroop := DefRedTroopStrength;
  Enemy.PigCop := DefPigCopStrength;
  Enemy.PigCopShield1 := DefPigCopShield1;
  Enemy.PigCopShield2 := DefPigCopShield2;
  Enemy.Recon := DefReconStrength;
  Enemy.Octabrain := DefOctaBStrength;
  Enemy.Turret := DefTurretStrength;
  Enemy.Boss1 := DefBoss1Strength;
END;

{***************************************************************************}
PROCEDURE Page1 (Player : PlayerR; Enemies : EnemyR);

BEGIN
  MakeWin (TextColor,BackColor,35,2,31,22);
  writeln ('   Regular Health ==> ', Player.MaxHealth1);
  writeln ('    Atomic Health ==> ', Player.MaxHealth2);
  writeln ('   Starting Armor ==> ', Player.StartArmor);
  writeln ('        Max Armor ==> ', Player.MaxArmor);
  TcTb (1,7);
  writeln ('   Steroid Bottle ==> ', Player.Steroids);
  writeln ('  Scuba Gear Tank ==> ', Player.Scuba);
  writeln ('  Holoduke Amount ==> ', Player.Holoduke);
  writeln ('     Jetpack Fuel ==> ', Player.Jetpack);
  writeln ('  Boot Time Limit ==> ', Player.Boots);
  writeln ('     Night Vision ==> ', Player.Vision);
  writeln ('    Medkit Amount ==> ', Player.Medkit);
  TcTb (0,7);
  writeln ('  Regular Trooper ==> ', Enemies.Trooper);
  writeln ('      Red Trooper ==> ', Enemies.RedTroop);
  writeln ('          Pig Cop ==> ', Enemies.PigCop);
  writeln ('  Pig Cop Armor 1 ==> ', Enemies.PigCopShield1);
  writeln ('  Pig Cop Armor 2 ==> ', Enemies.PigCopShield2);
  writeln ('        Recon Car ==> ', Enemies.Recon);
  writeln ('        Octabrain ==> ', Enemies.Octabrain);
  writeln ('  Rotating Turret ==> ', Enemies.Turret);
  write   ('      Ending Boss ==> ', Enemies.Boss1);
  window (58,23,64,23);
  TcTb (15,7);
  write (' PgDn ');
  HideCursor (1,1,7);
END;

{***************************************************************************}
PROCEDURE Page2 (Ammo : AmmoR; Box : BoxR; Strength : StrengthR; Radius : RadiusR);

BEGIN
  MakeWin (TextColor,BackColor,35,2,31,22);
  writeln ('      Pistol Ammo ==> ', Ammo.Pistol);
  writeln ('     Shotgun Ammo ==> ', Ammo.Shotgun);
  writeln ('    Chaingun Ammo ==> ', Ammo.Chaingun);
  writeln ('         RPG Ammo ==> ', Ammo.RPG);
  writeln ('    Pipebomb Ammo ==> ', Ammo.Pipebomb);
  TcTb (1,7);
  writeln ('       Pistol Box ==> ', Box.Pistol);
  writeln ('      Shotgun Box ==> ', Box.Shotgun);
  writeln ('     Chaingun Box ==> ', Box.Chaingun);
  writeln ('          RPG Box ==> ', Box.RPG);
  writeln ('     Pipebomb Box ==> ', Box.Pipebomb);
  TcTb (0,7);
  writeln ('    Kicking Power ==> ', Strength.Kick);
  writeln ('     Pistol Power ==> ', Strength.Pistol);
  writeln ('    Shotgun Power ==> ', Strength.Shotgun);
  writeln ('   Chaingun Power ==> ', Strength.Chaingun);
  writeln ('        RPG Power ==> ', Strength.RPG);
  writeln ('   Pipebomb Power ==> ', Strength.Pipebomb);
  TcTb (1,7);
  writeln ('       RPG Radius ==> ', Radius.RPG);
  write   ('  Pipebomb Radius ==> ', Radius.Pipebomb);
  window (58,23,64,23);
  TcTb (15,7);
  write (' PgUp ');
  HideCursor (1,1,7);
END;

{***************************************************************************}
PROCEDURE PrintCurrentVals (Player : PlayerR;
                            Ammo : AmmoR;
                            Box : BoxR;
                            Strength : StrengthR;
                            Radius : RadiusR;
                            Enemies : EnemyR);

VAR
  Choice : Char;

BEGIN
  Choice := #73;
  REPEAT
    CASE Choice OF
      #73 : Page1 (Player,Enemies);
      #81 : Page2 (Ammo,Box,Strength,Radius);
    END;
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}
PROCEDURE PrintFileVals;

VAR
  Player   : PlayerR;
  Ammo     : AmmoR;
  Box      : BoxR;
  Strength : StrengthR;
  Radius   : RadiusR;
  Enemies  : EnemyR;
  Current  : Text;
  Choice   : Char;

BEGIN
  GetCurrentValues (Player,Ammo,Box,Strength,Radius,Enemies);
  Choice := #73;
  REPEAT
    CASE Choice OF
      #73 : Page1 (Player,Enemies);
      #81 : Page2 (Ammo,Box,Strength,Radius);
    END;
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}

END.