UNIT ECData;

INTERFACE

USES
  Crt,
  Utility;

CONST
  MainBackColor       = 1;
  TextColor           = 0;
  BackColor           = 7;
  HighlightColor      = 4;
  HeaderColor         = 14;
  SelectText          = 14;
  SelectBack          = 0;

  DefMaxHealth1       = '100';
  DefMaxHealth2       = '200';
  DefMaxArmor         = '100';
  DefStartArmor       = '0  ';
  DefSteroids         = '400 ';
  DefScuba            = '6400';
  DefHoloDuke         = '2400';
  DefJetpack          = '1600';
  DefBoots            = '200 ';
  DefVision           = '1200';
  DefMedkit           = '100 ';

  DefPistolAmmo       = '200';
  DefShotgunAmmo      = '50 ';
  DefChaingunAmmo     = '200';
  DefRPGAmmo          = '50 ';
  DefPipebombAmmo     = '50 ';
  DefShrinkerAmmo     = '50 ';
  DefDevastatorAmmo   = '99 ';
  DefFreezerAmmo      = '99 ';
  DefTripbombAmmo     = '10 ';

  DefPistolBox        = '12 ';
  DefShotgunBox       = '10 ';
  DefChaingunBox      = '50 ';
  DefRPGBox           = '5  ';
  DefPipebombBox      = '5  ';
  DefShrinkerBox      = '5  ';
  DefDevastatorBox    = '15 ';
  DefFreezerBox       = '25 ';

  DefRPGRadius        = '1780 ';
  DefPipebombRadius   = '2500 ';
  DefShrinkerRadius   = '650  ';
  DefTripbombRadius   = '3800 ';

  DefKickStrength     = '10  ';
  DefPistolStrength   = '6   ';
  DefPipebombStrength = '140 ';
  DefRPGStrength      = '140 ';
  DefShotgunStrength  = '10  ';
  DefChaingunStrength = '9   ';
  DefShrinkerStrength = '0   ';
  DefFreezerStrength  = '16  ';
  DefTripbombStrength = '100 ';

  DefTrooperStrength  = '30  ';
  DefPigCopStrength   = '100 ';
  DefPigCopShield1    = '75  ';
  DefPigCopShield2    = '50  ';
  DefReconStrength    = '50  ';
  DefOctaBStrength    = '175 ';
  DefTurretStrength   = '30  ';
  DefRTurretStrength  = '40  ';
  DefDroneStrength    = '150 ';
  DefLizardStrength   = '100 ';
  DefCommandStrength  = '350 ';
  DefSharkStrength    = '35  ';
  DefBoss1Strength    = '4500 ';
  DefMinBoss1Strength = '1000 ';
  DefBoss2Strength    = '4500 ';
  DefBoss3Strength    = '4500 ';

TYPE

  String3   = STRING[3];
  String4   = STRING[4];
  String5   = STRING[5];

  PlayerR   = RECORD
                MaxHealth1,
                MaxHealth2,
                StartArmor,
                MaxArmor,
                Medkit           : String3;
                Steroids,
                Scuba,
                HoloDuke,
                Jetpack,
                Boots,
                Vision           : String4;
              END;

  AmmoR     = RECORD
                Pistol,
                Shotgun,
                Chaingun,
                RPG,
                Pipebomb,
                Shrinker,
                Devastator,
                Freezer,
                Tripbomb         : String3;
              END;

  BoxR      = RECORD
                Pistol,
                Shotgun,
                Chaingun,
                RPG,
                Pipebomb,
                Shrinker,
                Devastator,
                Freezer          : String3;
              END;

  StrengthR = RECORD
                Kick,
                Pistol,
                Shotgun,
                Chaingun,
                RPG,
                Pipebomb,
                Shrinker,
                Freezer,
                Tripbomb         : String4
              END;

  RadiusR   = RECORD
                RPG,
                Pipebomb,
                Shrinker,
                Tripbomb         : String5;
              END;

  EnemyR    = RECORD
                Trooper,
                PigCop,
                PigCopShield1,
                PigCopShield2,
                Recon,
                Octabrain,
                Turret,
                RotTurret,
                Lizard,
                Drone,
                Commander,
                Shark            : String4;
                Boss1,
                MiniBoss1,
                Boss2,
                Boss3            : String5;
              END;

  DataR     = RECORD
                Player   : PlayerR;
                Ammo     : AmmoR;
                Box      : BoxR;
                Strength : StrengthR;
                Radius   : RadiusR;
                Enemy    : EnemyR;
              END;

  DataF     = FILE OF DataR;

FUNCTION  Check (Tc, Tb, StartX, StartY : Byte; Prompt : STRING) : Boolean;
PROCEDURE AboutEditCON;
PROCEDURE MainScreenSetup;
PROCEDURE NotAvail;
PROCEDURE UDCChart;

IMPLEMENTATION

{***************************************************************************}
FUNCTION Check (Tc, Tb, StartX, StartY : Byte; Prompt : STRING) : Boolean;

VAR
  Choice : Char;

BEGIN
  MakeWin (Tc,Tb,StartX,StartY,(length(Prompt) + 4),3,True,True);
  WrtS (2,1,Prompt);
  HideCursor (1,1,Tb);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN ['Y','y','N','n',#13,#27]);
  IF (Choice IN ['Y','y',#13]) THEN
      Check := True
    ELSE Check := False;
END;

{***************************************************************************}
PROCEDURE AboutEditCON;

VAR
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,25,2,50,13,True,True);
  TcTb (5,7);
  WrtS (2,1,'             EditCON Version 2.0');
  TcTb (4,7);
  WrtS (2,3,'          For use with Duke Nukem 3D');
  WrtS (2,4,'            Version 1.3d Shareware');
  TcTb (0,7);
  WrtS (2,6,'          Author - Charlie Wiederhold');
  WrtS (2,7,'                Date - May, 1996');
  WrtS (2,8,'        E-Mail - wieder@mail.utexas.edu');
  WrtS (2,9,'WiederWeb - http://ccwf.cc.utexas.edu/~wieder/');
  TcTb (15,0);
  WrtS (12,11,' This program is freeware ');
  HideCursor (1,1,7);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}
PROCEDURE MainScreenSetup;

BEGIN
  Clear (HeaderColor,MainBackColor,1,1,80,25);
  MakeWin (TextColor,BackColor,1,1,17,25,False,False);
  WrtS (2,2,'Player Info');
  WrtS (2,3,'Weapon Info');
  WrtS (2,4,'Enemy Info');
  WrtS (2,5,'Current Setup');
  WrtS (2,6,'Current Files');
  WrtS (2,7,'Reset Default');
  WrtS (2,8,'UDC Chart');
  WrtS (2,9,'About EditCON');
  WrtS (2,10,'Exit EditCON');

  TcTb (3,5);
  WrtS (2,15,'   ');
  WrtS (2,16,'           ');
  WrtS (2,17,'        ');
  WrtS (2,18,'   ');
  TcTb (10,0);
  WrtS (2,19,' EditCON 2.0 ');
  TcTb (23,4);


END;

{***************************************************************************}
PROCEDURE NotAvail;

VAR
  Choice : Char;

BEGIN
  MakeWin (TextColor,BackColor,27,2,29,3,True,True);
  WrtS (2,1,'This Option Not Available');
  HideCursor (1,1,7);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}
PROCEDURE UDCHelp;

VAR
  Choice : Char;

BEGIN
  MakeWin (0,3,26,7,41,9,True,True);
  writeln ('  This  chart  shows the  UDC  values');
  writeln ('  (User Defined Change) for all items');
  writeln ('  which are modified  by precentages.');
  writeln ('  Here the items are shown at 100% so');
  writeln ('  you can  judge UDC  changes better.');
  writeln ('  These are the  actual values in the');
  write   ('  original factory set .CON files.');
  HideCursor (1,1,3);
  REPEAT
    Choice := Readkey;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}
PROCEDURE UDCChart;

VAR
  Choice : Char;

BEGIN
  Choice := #59;
  REPEAT
    IF Choice = #59 THEN
        BEGIN
          MakeWin (TextColor,BackColor,23,3,49,20,True,True);
          writeln ('  Steroid Bottle: 200            Trooper: 30');
          writeln ('      Scuba Tank: 3200           Pig Cop: 100');
          writeln ('   Holoduke Pack: 1600        PC Armor 1: 75');
          writeln ('    Jetpack Fuel: 600         PC Armor 2: 50');
          writeln ('     Boot Amount: 100          Recon Car: 250');
          writeln ('    Night Vision: 1200         Octabrain: 175');
          writeln ('      Kick Power: 10              Turret: 30');
          writeln ('    Pistol Power: 6        Rotate Turret: 40');
          writeln ('   Shotgun Power: 10              Lizard: 100');
          writeln ('  Chaingun Power: 9                Drone: 150');
          writeln ('       RPG Power: 140              Shark: 35');
          writeln ('  Pipebomb Power: 140          Commander: 350');
          writeln ('  Tripbomb Power: 100          Mini Boss: 1000');
          writeln ('   Freezer Power: 16      Episode 1 Boss: 4500');
          writeln ('      RPG Radius: 1780    Episode 2 Boss: 4500');
          writeln (' PipeBomb Radius: 2500    Episode 2 Boss: 4500');
          writeln (' Shrinker Radius: 650');
          write   (' Tripbomb Radius: 3800');
          window (35,22,80,22);
          write (' Press <F1> for UDC Notes ');
          window (39,3,80,3);
          TcTb (15,7);
          WrtS (1,1,' UDC Value Chart ');
          HideCursor (1,1,7);
        END;
    Choice := Readkey;
    IF Choice = #59 THEN UDCHelp;
  UNTIL (Choice IN [#13,#27]);
END;

{***************************************************************************}

END.