UNIT GrubData;

INTERFACE

USES
  DOS,
  NewDelay,
  Crt;

CONST
  Testing     = TRUE;

  MainW       = 64;
  MainH       = 40;
  StatW       = 16;
  StatH       = 40;
  TextW       = 80;
  TextH       = 8;
  Exit_       = #27;

  Forward_    = #72;
  Backward_   = #80;
  SlideRight_ = #88;
  SlideLeft_  = #90;
  ClimbUp_    = #65;
  ClimbDown_  = #83;
  TurnRight_  = #77;
  TurnLeft_   = #75;

  MapExtention = '.map';
  DefaultRoot  = 'core';

TYPE
  TxtMsgType = ARRAY [1..TextH] OF STRING;
  MovingType = (MoveForward, MoveBackward, SlideLeft, SlideRight,
                ClimbUp, ClimbDown, TurnLeft, TurnRight);
  FacingType = (North,South,East,West);
  CanGoType  = RECORD
                 North,
                 South,
                 East,
                 West    : Boolean;
               END;
  WorldType  = ARRAY [1..250,1..250] OF Boolean;
  MapType    = RECORD
                 Ceiling,
                 Floor,
                 Walls   : Byte;
               END;
  PlayerType = RECORD
                 XPos,
                 YPos    : Byte;
                 Facing  : FacingType;
               END;
  WinPosType = RECORD
                 Text,
                 AltText,
                 Back,
                 StartX,
                 StartY  : Byte;
                 Border,
                 Shadow  : Boolean;
               END;
  FileName   = STRING[12];

PROCEDURE Wait;
FUNCTION GetRoot : FileName;

IMPLEMENTATION

{****************************************************************************}
PROCEDURE Wait;

BEGIN
  REPEAT UNTIL keypressed;
END;

{****************************************************************************}
FUNCTION GetRoot : FileName;

VAR
  Count    : Integer;
  TempRoot : FileName;
  DirInfo  : SearchRec;
  CoreFile : Text;

BEGIN
  TempRoot := '';
  FOR Count := 1 TO ParamCount DO
    BEGIN
      IF ParamStr(Count) = '-game' THEN
        TempRoot := ParamStr (Count + 1) + '\';
    END;

  IF TempRoot = '' THEN
    BEGIN
      FindFirst ('root.txt',Archive,DirInfo);
      IF DosError = 0 THEN
          BEGIN
            assign (CoreFile,DirInfo.Name);
            reset (CoreFile);
            readln (CoreFile,TempRoot);
            close (CoreFile);
            TempRoot := TempRoot;
          END
        ELSE TempRoot := DefaultRoot;
    END;
  GetRoot := TempRoot;
END;

{****************************************************************************}

END.
