PROGRAM MailList;

USES
  Crt;

TYPE
  String50   = STRING[50];
  ArrayRange = 1..1000;
  ArrayData  = ARRAY [ArrayRange] OF String50;

VAR
  TotalPeople : Integer;

{***************************************************************************}
PROCEDURE Swap (VAR First, Second : String50);

VAR
  Temp : String50;

BEGIN
  Temp := First;
  First := Second;
  Second := Temp;
END;

{***************************************************************************}
PROCEDURE QuickSort (VAR Data : ArrayData; Low, High : ArrayRange);

VAR
  LowerCheck,
  UpperCheck : integer;

BEGIN
  LowerCheck := low + 1;
  UpperCheck := high;

  REPEAT
    WHILE (LowerCheck <= UpperCheck) AND (Data[UpperCheck] >= Data[Low]) DO
      UpperCheck := UpperCheck - 1;

    WHILE (LowerCheck < UpperCheck) AND (Data[LowerCheck] <= Data[Low]) DO
      LowerCheck := LowerCheck + 1;

    IF LowerCheck < UpperCheck
      THEN Swap (Data[LowerCheck],Data[UpperCheck]);

  UNTIL UpperCheck <= LowerCheck;

  Swap (Data[Low],Data[UpperCheck]);

  IF Low < UpperCheck - 1
    THEN QuickSort (Data,Low,UpperCheck - 1);
  IF UpperCheck + 1 < High
    THEN QuickSort (Data,UpperCheck + 1, High);
END;

{***************************************************************************}
PROCEDURE FixMailList (WhichList : STRING; VAR TotalPeople : Integer);

VAR
  Count,
  Count2,
  Count3   : Integer;
  TempStr  : String50;
  MailList : Text;
  List     : ArrayData;

BEGIN
  assign (MailList, WhichList);
  reset (MailList);

  FOR Count := 1 TO 3 DO readln (MailList);

  Count := 0;
  REPEAT
    inc(Count);
    readln (MailList, List[Count]);
  UNTIL EoF(MailList);

  FOR Count2 := 1 TO Count DO
    IF List[Count2][1] = '<' THEN
      BEGIN
        delete (List[Count2],1,1);
        delete (List[Count2],length(List[Count2]),1);
      END;

  FOR Count2 := 1 TO Count DO
    FOR Count3 := 1 TO length(List[Count2]) DO
      CASE List[Count2][Count3] OF
        'A' : List[Count2][Count3] := 'a';
        'B' : List[Count2][Count3] := 'b';
        'C' : List[Count2][Count3] := 'c';
        'D' : List[Count2][Count3] := 'd';
        'E' : List[Count2][Count3] := 'e';
        'F' : List[Count2][Count3] := 'f';
        'G' : List[Count2][Count3] := 'g';
        'H' : List[Count2][Count3] := 'h';
        'I' : List[Count2][Count3] := 'i';
        'J' : List[Count2][Count3] := 'j';
        'K' : List[Count2][Count3] := 'k';
        'L' : List[Count2][Count3] := 'l';
        'M' : List[Count2][Count3] := 'm';
        'N' : List[Count2][Count3] := 'n';
        'O' : List[Count2][Count3] := 'o';
        'P' : List[Count2][Count3] := 'p';
        'Q' : List[Count2][Count3] := 'q';
        'R' : List[Count2][Count3] := 'r';
        'S' : List[Count2][Count3] := 's';
        'T' : List[Count2][Count3] := 't';
        'U' : List[Count2][Count3] := 'u';
        'V' : List[Count2][Count3] := 'v';
        'W' : List[Count2][Count3] := 'w';
        'X' : List[Count2][Count3] := 'x';
        'Y' : List[Count2][Count3] := 'y';
        'Z' : List[Count2][Count3] := 'z';
        ELSE List[Count2][Count3] := List[Count2][Count3];
      END;

  QuickSort (List,1,Count);

  close (MailList);

  assign (MailList, WhichList);
  rewrite (MailList);

  writeln (MailList, '\TITLE Rodeo Shootout Mailing List');
  writeln (MailList, '\SENDER Rodeo Shootout Mailing List');
  writeln (MailList, '\REPLYTO Rodeo Shootout Mailing List <wieder@mail.utexas.edu>');
  TotalPeople := Count - 3;

  FOR Count2 := 1 TO Count DO
    writeln (MailList,List[Count2]);

  close (MailList);
END;

{***************************************************************************}

BEGIN
  TextColor (7);
  TextBackGround (0);
  clrscr;
  FixMailList ('rodeo.pml',TotalPeople);
  writeln ('Rodeo Shootout Totals ==> ', TotalPeople);
END.