PROGRAM Supp12;

{****************************************************************************}
{*                                                                          *}
{*  Author       : Charlie Wiederhold                                       *}
{*  Date         : October 2, 1995                                          *}
{*  Assignment   : Additional Problem number 12                             *}
{*  Purpose      : Writing the numbers from 0 to 1000 in alphabetical order *}
{*                                                                          *}
{****************************************************************************}

USES
  Printer, crt;                 {* Used to print the numbers to the printer *}

CONST
  zero      = 'zero        ';   {* These constants are used to represent    *}
  one       = 'one         ';   {* their respective number as text so that  *}
  two       = 'two         ';   {* they can be combined to form all the     *}
  three     = 'three       ';   {* combinations of numbers between 0 and    *}
  four      = 'four        ';   {* 1000                                     *}
  five      = 'five        ';
  six       = 'six         ';
  seven     = 'seven       ';
  eight     = 'eight       ';
  nine      = 'nine        ';
  ten       = 'ten         ';
  eleven    = 'eleven      ';
  twelve    = 'twelve      ';
  thirteen  = 'thirteen    ';
  fourteen  = 'fourteen    ';
  fifteen   = 'fifteen     ';
  sixteen   = 'sixteen     ';
  seventeen = 'seventeen   ';
  eighteen  = 'eighteen    ';
  nineteen  = 'nineteen    ';
  twenty    = 'twenty      ';
  thirty    = 'thirty      ';
  fourty    = 'fourty      ';
  fifty     = 'fifty       ';
  sixty     = 'sixty       ';
  seventy   = 'seventy     ';
  eighty    = 'eighty      ';
  ninety    = 'ninety      ';
  hundred   = 'hundred     ';
  thousand  = 'one thousand';

TYPE
  {* Array used to pass the string to be added to each number *}
  AddField  = packed array [1..12] of char;
  {* Array for the entire string representing each number *}
  NumField  = packed array [1..60] of char;
  {* Array of numbers 0 to 1000 *}
  NumArray  = array [0..1000] of NumField;

VAR
  Count,                        {* Counting variable *}
  Counter,                      {* Counting variable *}
  Hundreds,                     {* Loop control for the hundreds position *}
  Tens,                         {* Loop control for the tens position *}
  Ones,                         {* Loop control for the ones position *}
  Current,                      {* Current number being converted to text *}
  Position  : integer;          {* Position to place string *}
  Temp      : NumField;         {* Temporary string for the sort *}
  Build     : NumArray;         {* The array of numbers from 1 to 1000 *}

{***************************************************************************}
{* Procedure ToText : This procedure adds the designated string to the     *}
{*                    packed array designated by WhichNum, and applies the *}
{*                    string to the position in the packed array given by  *}
{*                    Position                                             *}
{***************************************************************************}

PROCEDURE ToText (Var PositionIn : integer; WhichNum : word;
                  Addition : AddField);

BEGIN

  for Count := (PositionIn - 1) to (PositionIn + 10) do
    Build[WhichNum,Count + 1] := Addition[Count mod 12 + 1];
  PositionIn := PositionIn + 12;

END;

{***************************************************************************}


BEGIN {* Supp12 *}

  {* Initializes all the strings to a nul value *}
  for Count := 0 to 1000 do
    for Counter := 1 to 60 do
      Build[Count,Counter] := ' ';

  {* Sets the 0th and 1000th terms to their respective text values *}
  Position := 1;
  ToText (Position,0,zero);

  Position := 1;
  ToText (Position,1000,thousand);

  {* These next loops builds numbers 1..999 into their text values *}

  {* This loop represents and applies the hundreds digit to the numbers *}
  for hundreds := 0 to 9 do

    {* This loop represents and applies the tens digit to the numbers *}
    for tens := 0 to 9 do

      {* This loop represents and applies the ones digit to the numbers *}
      for ones := 0 to 9 do
        begin {* For loop ones *}

          {* Current number being converted to text value *}
          Current := (Hundreds * 100) + (Tens * 10) + Ones;

          Position := 1;

          {* Sets the hundreds value to current Build if Hundreds > 0 *}
          case hundreds of
            1 : ToText (Position,Current,one);
            2 : ToText (Position,Current,two);
            3 : ToText (Position,Current,three);
            4 : ToText (Position,Current,four);
            5 : ToText (Position,Current,five);
            6 : ToText (Position,Current,six);
            7 : ToText (Position,Current,seven);
            8 : ToText (Position,Current,eight);
            9 : ToText (Position,Current,nine);
          end;

          {* if hundreds is > 0 it adds the string 'hundreds to the number *}
          if (hundreds > 0)
            then ToText (Position,Current,hundred);

          {* Adds the tens and teens places to the numbers *}
          case tens of
            1 : case ones of
                  0 : ToText (Position,Current,ten);
                  1 : ToText (Position,Current,eleven);
                  2 : ToText (Position,Current,twelve);
                  3 : ToText (Position,Current,thirteen);
                  4 : ToText (Position,Current,fourteen);
                  5 : ToText (Position,Current,fifteen);
                  6 : ToText (Position,Current,sixteen);
                  7 : ToText (Position,Current,seventeen);
                  8 : ToText (Position,Current,eighteen);
                  9 : ToText (Position,Current,nineteen);
                end;
            2 : ToText (Position,Current,twenty);
            3 : ToText (Position,Current,thirty);
            4 : ToText (Position,Current,fourty);
            5 : ToText (Position,Current,fifty);
            6 : ToText (Position,Current,sixty);
            7 : ToText (Position,Current,seventy);
            8 : ToText (Position,Current,eighty);
            9 : ToText (Position,Current,ninety);
          end;

          {* Adds the ones place to the numbers, except the teens *}
          if tens <> 1 then
            case ones of
              1 : ToText (Position,Current,one);
              2 : ToText (Position,Current,two);
              3 : ToText (Position,Current,three);
              4 : ToText (Position,Current,four);
              5 : ToText (Position,Current,five);
              6 : ToText (Position,Current,six);
              7 : ToText (Position,Current,seven);
              8 : ToText (Position,Current,eight);
              9 : ToText (Position,Current,nine);
            end;

        end; {* For loop ones *}

  {* Sorts the list from 0 to 1000 into alphabetical order *}
  for count := 0 to 1000 do

    for counter := 0 to 999 do

      if Build[counter] > Build[counter + 1]
        then
          {* Tests to see if numbers are alphabetically in order *}
          {* If the number before the current number is greater than the *}
          {* current number alphabetically (a < b) then it switches it *}
          begin
            Temp := Build[counter];
            Build[counter] := Build[counter + 1];
            Build[counter + 1] := Temp;
          end;

  {* Writes the output to the screen *}
  for current := 0 to 1000 do
    writeln (Build[current]);

END. {* Supp12 *}