Program GRADEBOOK;

{*****************************************************************************
 *  Author     : Charlie Wiederhold                                          *
 *  Date       : May 3, 1995                                                 *
 *  Assignment : Write a grade bbok using arrays                             *
 *  Purpose    : To read a max of 10 students and 5 grades each, while       *
 *               printing out the average and class average after all grades *
 *               have been entered                                           *
 *****************************************************************************}

Uses CRT{, WGRADES};

Const
  maxgrades   = 5;
  maxstudents = 10;
  exit_char   = 'x';

Type
  name_array    = array [1..maxstudents] of string;
  grade_array   = array [1..maxstudents, 1..maxgrades] of integer;
  average_array = array [1..maxstudents] of real;

var
  name       : name_array;      {* Array of class names *}
  grades     : grade_array;     {* Array of class grades *}
  average    : average_array;   {* Array of class averages *}
  classave,                     {* Class averages *}
  classsum   : real;            {* Class sum of grades *}
  studcount,                    {* Number of students *}
  gradesum,                     {* Student sum of grades *}
  count,                        {* Counting variable *}
  counter    : integer;         {* Counting variable *}

{=============================================================================}

{*** Averages the grade of the specifiesd student ***}

Function AVE (gradenum : integer; gradesum : real) : real;

var
  sum : integer; {* Sum of grades *}

Begin {AVE}

  AVE := gradesum / gradenum;

End; {AVE}

{=============================================================================}
{*****************************************************************************}

{*** Outputs all grades, and the class average ***}

Procedure OUTPUT(names : name_array; numstudents : integer;
                 grades : grade_array;
                 averages : average_array; classave : real);

Begin {OUTPUT}

  clrscr;

  {* Header *}
  writeln ('Name                 Gr1  Gr2  Gr3  Gr4  Gr5   Average');
  writeln ('----                 ---  ---  ---  ---  ---   -------');

  {* Student info *}
  for count := 1 to studcount do
    begin
      write (name[count]);
      gotoXY (20,count + 2);
      for counter := 1 to maxgrades do
        write (grades[count,counter]:5);
      write (average[count]:10:1);
      writeln;
    end;

  {* Class average *}
  writeln;
  writeln;
  writeln ('Class size ==> ', numstudents);
  write ('Class average ==> ', classave:5:1);
  readln;

End; {OUTPUT}

{*****************************************************************************}

{*** Reads the students and their grades ***}

Procedure GETSTUDENTS (var names : name_array; var numstudents : integer;
                       var grades : grade_array;
                       var averages : average_array; var classave : real);

Begin {GETSTUDENTS}

  {* Initialization *}
  classsum := 0;
  studcount := 0;
  clrscr;

  {* Get beginning loop control value / name *}
  write ('Enter name or <x> to exit ==> ');
  readln (name[studcount + 1]);

  {* Check to see if done *}
  while (name[studcount + 1] <> exit_char) and (studcount < maxstudents) do
    begin
      gradesum := 0;
      inc(studcount);
      writeln;

      {* Read grades *}
      for counter := 1 to maxgrades do
        begin
          write ('Enter grade ', counter, ' ==> ');
          readln (grades[studcount,counter]);
          gradesum := gradesum + grades[studcount,counter];
        end;

      {* Average student grades *}
      average[studcount] := AVE(maxgrades,gradesum);

      {* Get class sum of grades *}
      classsum := classsum + average[studcount];
      clrscr;

      {* Get new loop control value / name *}
      if studcount <> maxstudents then
        begin
          write ('Enter name or <x> to exit ==> ');
          readln (name[studcount + 1]);
        end;
    end;

  clrscr;
  if studcount = maxstudents
    then
      begin
        write ('The class is now full. Press <ENTER> to view grades.');
        readln;
      end;

  {* Average class grade *}
  classave := AVE(studcount,classsum);

End; {GETSTUDENTS}

{*****************************************************************************}

BEGIN {*** MAIN ***}

  textcolor (7);
  textbackground (0);

  {* Get student information *}
  GETSTUDENTS (name,studcount,grades,average,classave);

  {* Call the output procedure *}
  OUTPUT (name,studcount,grades,average,classave);

END. {*** MAIN ***}
