{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT WIEDER; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



Uses CRT;

procedure ERROR;
procedure TCTB       (tc, tb : integer);
procedure WRTC       (x, y : byte; chr : char);
procedure WRTS       (x, y : byte; str : string);
procedure WRTI       (x, y : byte; int : integer);
procedure WRTR       (x, y : byte; reel : real; field, decimal : byte);
procedure FRMTC      (x, y : byte; chr : char; field : byte);
procedure FRMTS      (x, y : byte; str : string; field : byte);
procedure FRMTI      (x, y : byte; int : integer; field : byte);
procedure REGWIN;
Procedure CLEAR      (text, backcolor, ulx, uly, lrx, lry : integer);
procedure MAKEWINDB  (text, backcolor, ulx, uly, lrx, lry : integer;
                      shadow, border : boolean; bordercolor : byte);
procedure LINEWIN    (text, backcolor,
                      startx, endx, yline, background : integer);
procedure HIDECURSOR (x, y, color : integer);
procedure SELECTBAR  (text, background, leftx, rightx, topy, bottomy : byte;
                      var cursor, menupos : byte;
                      var choice : char;
                      leftcharacter, rightcharacter : char);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{********* Produces a sound when run, used when an error has occured *********}

procedure error;

begin
  sound (200);
  delay (200);
  nosound;
end;

{=============================================================================}

{****** Combines the textcolor textbackground commands into one command ******}

procedure TCTB (tc, tb : integer);

begin
  textcolor (tc);
  textbackground (tb);
end;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure WRTC (x, y : byte; chr: char);
begin
  gotoXY (x, y);
  write (chr);
end;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure WRTS (x, y : byte; str : string);
begin
  gotoXY (x, y);
  write (str);
end;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure WRTI (x, y : byte; int : integer);
begin
  gotoXY (x, y);
  write (int);
end;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure WRTR (x, y : byte; reel : real; field, decimal : byte);
begin
  gotoXY (x, y);
  write (reel:field:decimal);
end;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure FRMTC (x, y : byte; chr : char; field : byte);
begin
  gotoXY (x,y);
  write (chr:field);
end;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure FRMTS (x, y : byte; str : string; field : byte);
begin
  gotoXY (x,y);
  write (str:field);
end;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure FRMTI (x, y : byte; int: integer; field : byte);
begin
  gotoXY (x,y);
  write (int:field);
end;

{=============================================================================}

{*************** Resizes to standard window without clearing it **************}

procedure REGWIN;

begin
  window (1,1,80,25);
end;

{=============================================================================}

{***************** Redraws the standard window and clears it *****************}

procedure CLEAR (text, backcolor, ulx, uly, lrx, lry : integer);

begin
  TCTB (text, backcolor);
  window (ulx,uly,lrx,lry);
  clrscr;
end;

{=============================================================================}

{***************** Redraws the specified window and clears it ****************}

procedure MAKEWINDB (text, backcolor, ulx, uly, lrx, lry : integer;
                     shadow, border : boolean; bordercolor : byte);

var
  count : byte;

begin
  if shadow
    then CLEAR (0, 0, (ulx + 2), (uly + 1), (lrx + 2), (lry + 1));
  CLEAR (text, backcolor, ulx, uly, lrx, lry);
  if border
    then
      begin
        TCTB (bordercolor,backcolor);
        REGWIN;
        for count := (ulx + 2) to (lrx - 2) do
          begin
            WRTC (count,uly,chr(205));
            WRTC (count,lry,chr(205));
          end;
        for count := (uly + 1) to (lry - 1) do
          begin
            WRTC ((ulx + 1),count,chr(186));
            WRTC ((lrx - 1),count,chr(186));
          end;
        WRTC ((ulx + 1),uly,chr(201));
        WRTC ((lrx - 1),uly,chr(187));
        WRTC ((ulx + 1),lry,chr(200));
        WRTC ((lrx - 1),lry,chr(188));
      end;
    window ((ulx + 2), (uly + 1), (lrx - 2), (lry - 1));
    TCTB (text,backcolor);

end;

{=============================================================================}

{*********** Draws a window only one line tall and draws the shadow **********}

procedure LINEWIN (text, backcolor, startx, endx, yline, background : integer);

var
  xpos : integer;

begin
  window (1,1,80,25);
  TCTB (0,background);
  for xpos := (startx + 1) to (endx + 1) do
    WRTC (xpos, (yline + 1), '');
  WRTC ((endx + 1), yline ,'');
  CLEAR (text, backcolor, startx, yline, endx, yline);
  TCTB (text,backcolor);
end;

{=============================================================================}

{****************************** Hides the cursor *****************************}

procedure HIDECURSOR (x, y, color : integer);

begin
  TCTB (color, color);
  WRTC (x, y, ' ');
  gotoXY (x,y);
end;

{=============================================================================}

{******************* Moves about in a vertical selection bar *****************}

procedure SELECTBAR (text, background, leftx, rightx, topy, bottomy : byte;
                     var cursor, menupos : byte;
                     var choice : char;
                     leftcharacter, rightcharacter : char);

begin
  TCTB (text, background);
  WRTC (leftx, ((topy - 1) + cursor) ,leftcharacter);
  WRTC (rightx, ((topy - 1) + cursor), rightcharacter);
  repeat
    HIDECURSOR ((leftx - 1), ((topy - 1) + cursor), background);
    choice := readkey;
    case choice of
      #80 : begin
              TCTB (background, background);
              WRTC (leftx, ((topy - 1) + cursor) ,' ');
              WRTC (rightx, ((topy - 1) + cursor),' ');
              if ((topy - 1) + cursor) = bottomy
                then cursor := 1
                else inc(cursor);
              TCTB (text, background);
              WRTC (leftx, ((topy - 1) + cursor), leftcharacter);
              WRTC (rightx, ((topy - 1) + cursor), rightcharacter);
            end;
      #72 : begin
              TCTB (background, background);
              WRTC (leftx, ((topy - 1) + cursor) ,' ');
              WRTC (rightx, ((topy - 1) + cursor),' ');
              if ((topy - 1) + cursor) = topy
                then cursor := ((bottomy - topy) + 1)
                else dec(cursor);
              TCTB (text, background);
              WRTC (leftx, ((topy - 1) + cursor), leftcharacter);
              WRTC (rightx, ((topy - 1) + cursor), rightcharacter);
            end;
      #33 : choice := #59;
      #18 : choice := #60;
      #25 : choice := #61;
      #45 : choice := #62;
      #35 : choice := #63;
    end;  { case }

  until (choice = #13) or (choice = #27) or
        (choice = #75) or (choice = #77) or
        ((choice >= #59) and (choice <= #63));

end;

{=============================================================================}

END.  {*** Unit WIEDER ***}