program MrLaeZ;

{****************************************************************************
 *   Author   : Charlie Wiederhold                                          *
 *   Date     : 01/08/95                                                    *
 *   Purpose  : This program is designed to gather three exam grades, five  *
 *              quiz grades and one final exam grade. Then it averages the  *
 *              grades and produces a percentage score and a letter grade.  *
 *                   Grade limits : Exam  = 100 max                         *
 *                                  Quiz  =  10 max                         *
 *                                  Final = 200 max                         *
 *   Method   : Write statements prompt the user to enter the grades, and   *
 *              procedures do the averageing and converting to letter       *
 *              grades which uses a case statement to do the convertion.    *
 ****************************************************************************}

uses crt;  { allows for better screen manipulation }

const
  maxe = 100;  { maximum grade for exam }
  maxq = 10;   { maximum grade for quiz }
  maxf = 200;  { maximum grade for final }

type
  exam_array = array [1..4] of integer;  { array of exam grades }
  quiz_array = array [1..5] of integer;  { array of quiz grades }

var
  exam     : exam_array;   { exam grade variable }
  quiz     : exam_array;   { quiz grade variable }
  ready    : char;         { initial question variable to start }
  gradeE,                  { sub grade for exam }
  gradeQ,                  { sub grade for quiz }
  subscore,                { sub total grade }
  finscore,                { rounded final percentage score }
  j        : integer;      { output control variable }
  letter   : string;       { letter grade variable }

{****************************************************************************}
procedure tctb (tc,tb : integer);

{ simplifies these two statements }
Begin   { tctb }
  textcolor (tc);
  textbackground (tb);
End;    { tctb }
{****************************************************************************}
procedure writeat (x,y : integer; strng : string);

{ simplifies these two statements }
Begin   { writeat }
  gotoXY (x,y);
  write (strng);
End;    { writeat }
{****************************************************************************}
procedure hide (tc,tb,x,y : integer);

{ allows the cursor to be hidden from the screen }
Begin   { hide }
  tctb (tc,tb);
  writeat (x,y,' ');
  gotoXY (x,y);
End;    { hide }
{****************************************************************************}
procedure getgrade;

{ gathers the grade info from the user }
Begin

  tctb (0,7);
  clrscr;

  { gets the exam grades }
  writeln (' We are going to begin by entering the three exam grades.');
  writeln (' Maximum grade of 100.');
  for j := 1 to 3 do
    begin   { for }
      writeat (4,j + 4,'Exam grade ');
      write (j, ': ');
      repeat
        begin    { repeat }
          writeat (18,j + 4,'    ');
          gotoXy (18,j + 4);
          readln (exam[j]);
        end;      { repeat }
      until exam[j] <= maxe;
    end;   { for }

  { gets the quiz grades }
  clrscr;
  writeln (' Now enter the five quiz grades.');
  writeln (' Maximum grade of 10.');
  for j := 1 to 5 do
    begin  { for }
      writeat (4,j + 4,'Quiz grade ');
      write (j, ': ');
      repeat
        begin   { repeat }
          writeat (18,j + 4,'    ');
          gotoXy (18,j + 4);
          readln (quiz[j]);
        end;    { repeat }
      until quiz[j] <= maxq;
    end;   { for }

  { gets the final exam grade }
  clrscr;
  writeln (' Now enter the single final examination grade.');
  writeln (' Maximum grade of 200.');
  for j := 1 to 3 do
    writeln;
  repeat
    begin   { repeat }
      writeat (4,5,'Final Examination :      ');
      gotoXY (24,5);
      readln (exam[4]);
    end;    { repeat }
  until exam[4] <= maxf;

End;  { getgrade }
{****************************************************************************}
procedure calcgrades;

{ calculates the grades and converts to letter grade }
Begin

  { opening values }
  gradeE := 0;
  gradeQ := 0;

  { addition }
  for j := 1 to 3 do
    gradeE := gradeE + exam[j];
  for j := 1 to 5 do
    gradeQ := gradeQ + quiz[j];
  gradeQ := gradeQ * 2;

  { sub and final scores }
  subscore := gradeE + gradeQ + exam[4];
  finscore := round(subscore / 6);

  { converts the grades to letter grades }
  case finscore of
     0..69  : letter := ' F';
    70..79  : letter := ' C';
    80..89  : letter := ' B';
    90..94  : letter := ' A';
    95..100 : letter := 'A+';
  end;   { case }

End;  { calcgrades }
{****************************************************************************}
procedure gradesystem;

{ sets up the screen for a display of the calculating system }
Begin

  { makes the display lighter than the rest of the data }
  tctb (8,7);

  { letter convertion }
  writeat (28,5,' 0 -  69 = F');
  writeat (28,6,'70 -  79 = C');
  writeat (28,7,'80 -  89 = B');
  writeat (28,8,'90 -  94 = A');
  writeat (28,9,'95 - 100 = A+');

  { grading system }
  writeat (43,3,'  Grading System');
  writeat (43,4,'-----------------');
  writeat (43,5,'       Exam Total');
  writeat (43,6,'+  2 x Quiz Total');
  writeat (43,7,'+      Final Exam');
  writeat (43,8,'=================');
  writeat (43,9,'        Total / 6');
  writeat (43,10,'=================');
  writeat (43,11,' Percentage Score');

End;  { gradesystem }
{****************************************************************************}
procedure report;

{ outputs the grades and the reportr of the students grades }
Begin  { report }

  { changes screen }
  window (1,1,80,25);
  tctb (1,1);
  clrscr;

  { creates the window effect }
  tctb (0,0);
  for j := 1 to 61 do
    writeat (j + 11,21,' ');
  for j := 1 to 15 do
    writeat (71,j + 5,'  ');
  window (10,5,70,20);
  tctb (0,7);
  clrscr;

  { sets up the report }
  writeln;
  writeln (' GRADE REPORT');
  writeln;
  writeln;

  { exams }
  writeln ('  Exam Grades :');
  for j := 1 to 3 do
    begin
      writeat (17,j + 4,'');
      write (exam[j]:4);
    end;
  writeln;
  writeln;

  { quiz }
  writeln ('  Quiz Grades :');
  for j := 1 to 5 do
    begin
      writeat (17,j + 8,'');
      write (quiz[j]:4);
    end;
  writeln;
  writeln;

  { final }
  writeln ('  Final Exam  :', exam[4]:5);

  { calculates the grades }
  calcgrades;

  { used for display of grading system }
  gradesystem;

  { percentage grade }
  if finscore < 70
    then
      tctb (4,7)
    else
      tctb (1,7);
  writeat (28,14,'Percentage Grade :');
  write (finscore:4);

  { letter grade }
  writeat (28,15,'Letter Grade     :');
  write (letter:4);

  { holds outputon screen }
  hide (7,7,1,1);
  readln;

End; { report }
{****************************************************************************}
procedure done;

{ closing screen shown when ready = N}
Begin   { done }

  tctb (0,7);
  clrscr;
  writeat (16,5,'Thank you for using this program.');
  writeat (23,7,'Press <Enter>.');

  { hold output on screen }
  hide (7,7,1,1);
  readln;

End;  { done }
{****************************************************************************}
procedure run;

{ this is the main procedure in which all the others are integrated }
Begin   { run }

  { sets up the opening screen }
  window (1,1,80,25);
  tctb (1,1);
  clrscr;
  tctb (0,0);

  { produces the window effect }
  for j := 1 to 61 do
    writeat (j + 11,16,' ');
  for j := 1 to 10 do
    writeat (71,j + 5,'  ');
  window (10,5,70,15);
  tctb (0,7);
  clrscr;

  { asks if the user is ready }
  writeat (18,4,'Hello Mr. Lae Z. Programmer');
  writeat (14,5,'Are you ready to enter some grades?');
  writeat (23,8,'( )es  or  ( )o');
  tctb (5,7);
  writeat (24,8,'Y');
  writeat (35,8,'N');
  hide (7,7,1,1);

  { reads the answer until it is valid }
  repeat
    ready := upcase(readkey);
  until (ready = 'Y') or (ready = 'N');

  { determines the action depending upon the answer to ready }
  case ready of
    'Y' : begin
            getgrade;
            report;
          end;
    'N' : done;
  end;   { case }

End;  { run }
{****************************************************************************}
Begin  { main }

  { controls the number of times the program is run }
  while ready <> 'N' do
    run;

End.   { main }
