Program CREATEMAP (scene_file);

USES CRT, UTILITY;

Type

  enemy_type      = (trooper1, trooper2, trooper3, trooper4, trooper5,
                     tank1, tank2, tank3,
                     heli1, heli2, heli3,
                     plane1, plane2, plane3,
                     base1, base2, base3, base4);
  weapon_type     = (machine_gun, laser_gun, bomb);
  mountain_type   = (large, medium, small);

  scene_range     = 1..25;
  strength_range  = 1..100;
  distance_range  = 50..250;
  level_range     = 1..3;
  quad_range      = 1..4;
  ew_range        = 1..5;
  ns_range        = 'A'..'E';
  mntnstart_range = 1..54;
  mountain_range  = 1..5;

  enemy_record = record
                   name      : enemy_type;
                   weapon    : weapon_type;
                   distance  : distance_range;
                   strength  : strength_range;
                 end;

  quad_record  = record
                   ewpos     : ew_range;
                   nspos     : ns_range;
                 end;

  mntn_record  = record
                   use       : boolean;
                   mntn      : mountain_type;
                   mntnstart : mntnstart_range;
                 end;
  mntn_array   = array [mountain_range] of mntn_record;

  data_record = record
                   enemy     : enemy_record;
                   quadrant  : quad_record;
                   mountains : mntn_array;
                 end;
  scene_array  = array [scene_range] of data_record;

  scene_record = record
                   scenes    : scene_array;
                   level     : level_range;
                   quad      : quad_range;
                 end;

  scene_file   = file of scene_record;

var
  ename,
  eweapon,
  edistance,
  estrength,
  muse,
  mtype,
  mstart,
  add,
  count,
  count2     : byte;
  counter    : char;
  scene      : scene_record;
  save_scene : scene_file;

Begin
  with scene do
    begin
      level := 1;
      quad := 1;
    end;
  add := 0;
  for counter := 'A' to 'E' do
    begin
      for count := 1 to 5 do
        begin
          scene.scenes[add + count].quadrant.ewpos := count;
          scene.scenes[add + count].quadrant.nspos := counter;
        end;
      add := add + 5;
    end;
  tctb (15,0);
  regwin;
  for count := 1 to 25 do
    begin
      clrscr;
      writeln ('Scene #', count);
      write ('Enemy name ==> ');
      readln (ename);
      case ename of
         0 : scene.scenes[count].enemy.name := trooper1;
         1 : scene.scenes[count].enemy.name := trooper2;
         2 : scene.scenes[count].enemy.name := trooper3;
         3 : scene.scenes[count].enemy.name := trooper4;
         4 : scene.scenes[count].enemy.name := trooper5;
         5 : scene.scenes[count].enemy.name := tank1;
         6 : scene.scenes[count].enemy.name := tank2;
         7 : scene.scenes[count].enemy.name := tank3;
         8 : scene.scenes[count].enemy.name := heli1;
         9 : scene.scenes[count].enemy.name := heli2;
        10 : scene.scenes[count].enemy.name := heli3;
        11 : scene.scenes[count].enemy.name := plane1;
        12 : scene.scenes[count].enemy.name := plane2;
        13 : scene.scenes[count].enemy.name := plane3;
        14 : scene.scenes[count].enemy.name := base1;
        15 : scene.scenes[count].enemy.name := base2;
        16 : scene.scenes[count].enemy.name := base3;
        17 : scene.scenes[count].enemy.name := base4;
      end;
      case ename of
         0,
         1,
         2 : scene.scenes[count].enemy.weapon := machine_gun;
         3,
         4 : scene.scenes[count].enemy.weapon := laser_gun;
         5 : scene.scenes[count].enemy.weapon := machine_gun;
         6 : scene.scenes[count].enemy.weapon := laser_gun;
         7 : scene.scenes[count].enemy.weapon := bomb;
         8 : scene.scenes[count].enemy.weapon := machine_gun;
         9 : scene.scenes[count].enemy.weapon := laser_gun;
        10 : scene.scenes[count].enemy.weapon := bomb;
        11 : scene.scenes[count].enemy.weapon := machine_gun;
        12 : scene.scenes[count].enemy.weapon := laser_gun;
        13 : scene.scenes[count].enemy.weapon := bomb;
        14,
        15 : scene.scenes[count].enemy.weapon := laser_gun;
        16 : scene.scenes[count].enemy.weapon := bomb;
        17 : scene.scenes[count].enemy.weapon := bomb;
      end;
      case ename of
         0 : scene.scenes[count].enemy.distance := 50;
         1 : scene.scenes[count].enemy.distance := 75;
         2 : scene.scenes[count].enemy.distance := 100;
         3 : scene.scenes[count].enemy.distance := 150;
         4 : scene.scenes[count].enemy.distance := 200;
         5 : scene.scenes[count].enemy.distance := 60;
         6 : scene.scenes[count].enemy.distance := 120;
         7 : scene.scenes[count].enemy.distance := 210;
         8 : scene.scenes[count].enemy.distance := 70;
         9 : scene.scenes[count].enemy.distance := 150;
        10 : scene.scenes[count].enemy.distance := 220;
        11 : scene.scenes[count].enemy.distance := 80;
        12 : scene.scenes[count].enemy.distance := 150;
        13 : scene.scenes[count].enemy.distance := 245;
        14 : scene.scenes[count].enemy.distance := 100;
        15 : scene.scenes[count].enemy.distance := 150;
        16 : scene.scenes[count].enemy.distance := 200;
        17 : scene.scenes[count].enemy.distance := 250;
      end;
      case ename of
         0 : scene.scenes[count].enemy.strength := 10;
         1 : scene.scenes[count].enemy.strength := 20;
         2 : scene.scenes[count].enemy.strength := 25;
         3 : scene.scenes[count].enemy.strength := 35;
         4 : scene.scenes[count].enemy.strength := 50;
         5 : scene.scenes[count].enemy.strength := 15;
         6 : scene.scenes[count].enemy.strength := 45;
         7 : scene.scenes[count].enemy.strength := 75;
         8 : scene.scenes[count].enemy.strength := 25;
         9 : scene.scenes[count].enemy.strength := 50;
        10 : scene.scenes[count].enemy.strength := 80;
        11 : scene.scenes[count].enemy.strength := 30;
        12 : scene.scenes[count].enemy.strength := 75;
        13 : scene.scenes[count].enemy.strength := 90;
        14 : scene.scenes[count].enemy.strength := 80;
        15 : scene.scenes[count].enemy.strength := 85;
        16 : scene.scenes[count].enemy.strength := 95;
        17 : scene.scenes[count].enemy.strength := 100;
      end;
      writeln;
    end;
    for count := 1 to 25 do
      for add := 1 to 5 do
        begin
          clrscr;
          writeln ('Scene #', count);
          write ('Use mountain ', add, ' ==> ');
          readln (muse);
          if muse = 0
            then
              begin
                for count2 := add to 5 do
                  begin
                    scene.scenes[count2].mountains[add].use := false;
                    scene.scenes[count2].mountains[add].mntn := small;
                    scene.scenes[count2].mountains[add].mntnstart := 1;
                  end;
                add := 5;
              end
            else
              begin
                scene.scenes[count].mountains[add].use := true;
                write ('Mountain type ==> ');
                readln (mtype);
                case mtype of
                  0 : scene.scenes[count].mountains[add].mntn := large;
                  1 : scene.scenes[count].mountains[add].mntn := medium;
                  2 : scene.scenes[count].mountains[add].mntn := small;
                end;
                write ('Mountain start ==> ');
                readln (scene.scenes[count].mountains[add].mntnstart);
              end;
        end;
  assign (save_scene, 'c:q2l1.map');
  rewrite (save_scene);
  write (save_scene, scene);
  close (save_scene);
End.