PROGRAM TANKGAME (scene_saved, player_saved);

USES CRT, UTILITY, WINDOWS, NOISES, ENEMIES;

Type
  enemy_type      = (trooper1, trooper2, trooper3, trooper4, trooper5,
                     tank1, tank2, tank3,
                     heli1, heli2, heli3,
                     plane1, plane2, plane3,
                     base1, base2, base3, base4);
  tank_type       = (tankA, tankB, tankC);
  weapon_type     = (machine_gun, laser_gun, bomb);
  mountain_type   = (large, medium, small);

  scene_range     = 1..25;
  strength_range  = 1..100;
  distance_range  = 50..250;
  level_range     = 1..3;
  quad_range      = 1..4;
  ew_range        = 1..5;
  ns_range        = 'A'..'E';
  mntnstart_range = 1..54;
  mountain_range  = 1..5;
  enemy_record = record
                   name      : enemy_type;
                   weapon    : weapon_type;
                   distance  : distance_range;
                   strength  : strength_range;
                 end;
  quad_record  = record
                   ewpos     : ew_range;
                   nspos     : ns_range;
                 end;
  mntn_record  = record
                   use       : boolean;
                   mntn      : mountain_type;
                   mntnstart : mntnstart_range;
                 end;
  mntn_array   = array [mountain_range] of mntn_record;
  data_record = record
                   enemy     : enemy_record;
                   quadrant  : quad_record;
                   mountains : mntn_array;
                 end;
  scene_array  = array [scene_range] of data_record;
  scene_record = record
                   scenes    : scene_array;
                   level     : level_range;
                   quad      : quad_range;
                 end;
  scene_file   = file of scene_record;

  player_record = record
                    name     : string[15];
                    strength : strength_range;
                    tank     : tank_type;
                    weapon   : weapon_type;
                  end;
  player_file   = file of player_record;

var
  level,
  quad,
  game,
  pos,
  count,
  counter      : byte;
  player       : player_record;
  player_saved : player_file;
  scene        : scene_record;
  scene_saved  : scene_file;
  selec        : char;

{****************************************************************************}
Procedure LOAD_PLAYER;

Begin
  case game of
    1 : assign (player_saved, 'c:player1.man');
    2 : assign (player_saved, 'c:player2.man');
    3 : assign (player_saved, 'c:player3.man');
    4 : assign (player_saved, 'c:player4.man');
    5 : assign (player_saved, 'c:player5.man');
  end;
  reset (player_saved);
  read (player_saved, player);
  close (player_saved);
End;

{****************************************************************************}
Procedure LOAD_QUAD;

Begin
  case level of
    1 : case quad of
          1 : assign (scene_saved, 'c:q1l1.map');
          2 : assign (scene_saved, 'c:q2l1.map');
          3 : assign (scene_saved, 'c:q3l1.map');
          4 : assign (scene_saved, 'c:q4l1.map');
        end;
    2 : case quad of
          1 : assign (scene_saved, 'c:q1l2.map');
          2 : assign (scene_saved, 'c:q2l2.map');
          3 : assign (scene_saved, 'c:q3l2.map');
          4 : assign (scene_saved, 'c:q4l2.map');
        end;
    3 : case quad of
          1 : assign (scene_saved, 'c:q1l3.map');
          2 : assign (scene_saved, 'c:q2l3.map');
          3 : assign (scene_saved, 'c:q3l3.map');
          4 : assign (scene_saved, 'c:q4l3.map');
        end;
  end;
  reset (scene_saved);
  read (scene_saved, scene);
  close(scene_saved);
End;

{****************************************************************************}
Procedure WRITE_PLAYER;

Begin
  statuswin;
  tctb (9,0);
  wrts (3,2,player.name);
  frmti (3,4,player.strength,3);
  case player.tank of
    tankA : wrts (3,6,'Basic Tank');
    tankB : wrts (3,6,'Heavy Tank');
    tankC : wrts (3,6,'Turbo Tank');
  end;
  case player.weapon of
    machine_gun : wrts (3,8,'Machine Gun');
    laser_gun   : wrts (3,8,'Laser Gun  ');
    bomb        : wrts (3,8,'Bombs      ');
  end;
End;

{****************************************************************************}
Procedure WRITE_SCENE;

Begin
  VIEW;
  viewwin;
  tctb (15,5);
  wrti (8,1,scene.level);
  for count := 1 to 5 do
    if scene.scenes[pos].mountains[count].use
      then
        begin
          case scene.scenes[pos].mountains[count].mntn of
            small  : SMALLHILL (scene.scenes[pos].mountains[count].mntnstart);
            medium : MEDIUMHILL (scene.scenes[pos].mountains[count].mntnstart);
            large  : LARGEHILL (scene.scenes[pos].mountains[count].mntnstart);
          end;
        end;
  case scene.scenes[pos].enemy.name of
    trooper1 : TROOPER (2,2);
    trooper2 : TROOPER (0,2);
    trooper3 : TROOPER (7,2);
    trooper4 : TROOPER (0,7);
    trooper5 : TROOPER (0,0);
    tank1    : TANK (2,0);
    tank2    : TANK (7,0);
    tank3    : TANK (0,7);
    heli1    : HELI (2,0,7);
    heli2    : HELI (7,0,0);
    heli3    : HELI (0,7,7);
    plane1   : PLANE (2,0,7);
    plane2   : PLANE (7,0,0);
    plane3   : PLANE (0,7,7);
    base1    : BASE (2,7,7);
    base2    : BASE (2,0,0);
    base3    : BASE (7,0,0);
    base4    : BASE (0,7,7);
  end;
  tctb (9,0);
  positionwin;
  wrti (14,2,scene.quad);
  wrtc (16,2,scene.scenes[pos].quadrant.nspos);
  wrti (14,4,scene.quad);
  wrti (16,4,scene.scenes[pos].quadrant.ewpos);
  targetwin;
  case scene.scenes[pos].enemy.weapon of
    machine_gun : wrts (3,4,'Machine Gun');
    laser_gun   : wrts (3,4,'Laser Gun  ');
    bomb        : wrts (3,4,'Bombs      ');
  end;
  frmti (22,2,scene.scenes[pos].enemy.distance,3);
  frmti (22,4,scene.scenes[pos].enemy.strength,3);
  case scene.scenes[pos].enemy.name of
    trooper1 : wrts (3,2,'Private      ');
    trooper2 : wrts (3,2,'Corporal     ');
    trooper3 : wrts (3,2,'Sergeant     ');
    trooper4 : wrts (3,2,'Captain      ');
    trooper5 : wrts (3,2,'General      ');
    tank1    : wrts (3,2,'Basic Tank   ');
    tank2    : wrts (3,2,'Armor Tank   ');
    tank3    : wrts (3,2,'Turbo Tank   ');
    heli1    : wrts (3,2,'Basic Chopper');
    heli2    : wrts (3,2,'Armor Chopper');
    heli3    : wrts (3,2,'Turbo Chopper');
    plane1   : wrts (3,2,'Basic Plane  ');
    plane2   : wrts (3,2,'Armor Plane  ');
    plane3   : wrts (3,2,'Turbo Plane  ');
    base1    : wrts (3,2,'Campout      ');
    base2    : wrts (3,2,'Barracks     ');
    base3    : wrts (3,2,'Com Center   ');
    base4    : wrts (3,2,'Headquarters ');
  end;
End;

{****************************************************************************}
Procedure MOVE;

Begin
  case selec of
    #72 : if pos < 21 then pos := pos + 5;
    #80 : if pos > 5 then pos := pos - 5;
    #77 : if pos mod 5 <> 0 then inc(pos);
    #75 : if (pos - 1) mod 5 <> 0 then dec(pos);
  end;
  WRITE_SCENE;
End;

{****************************************************************************}
Procedure OPENING;

Begin
  pos := 1;
  level := 1;
  quad := 1;
  game := 1;
  LOAD_QUAD;
  LOAD_PLAYER;
  CHOICE;
  STATUS;
  TARGET;
  POSITION;
  EMBLEM;
  VIEW;
  WRITE_SCENE;
  WRITE_PLAYER;
End;

{****************************************************************************}

BEGIN
  OPENING;
  repeat
    regwin;
    hidecursor (2,2,0);
    selec := readkey;
    if (selec = #72) or (selec = #80) or (selec = #77) or (selec = #75)
      then MOVE;
    case selec of
      '1' : siren;
      '2' : machinegun;
      '3' : laser;
      '4' : canon;
      '5' : hit;
      #27 : deadscreen;
    end;
  until selec = #27;
  clear (7,0,1,1,80,25);
END.