unit UTIL;

interface

uses CRT;

var
  Saved_Scr_Chars   : array [1..80,1..25] of char;
  Saved_Scr_Attr    : array [1..80,1..25] of byte;
  vs                : word;


procedure TCTB (fcolor,bcolor : byte);
procedure WRITEAT (x,y : byte; the_string : string);
procedure CLRAT (x,y : byte; spaces : byte);
procedure RWIN (x1,y1,x2,y2    : byte;
                boarder        : boolean;
                fcolor,bcolor  : byte);
procedure NORMWIN;
Procedure GetOAXY(x,y:byte; var Ba,ca:byte);
Procedure No_Cursor;
Procedure Cursor(a,b:shortint);
function VidSeg : word;
procedure FASTWRITE (x,y : byte;  ch : char;  atrib : byte);
procedure Save_Screen;
procedure Call_Screen;
procedure SCR_INIT;



implementation


{***************************************************************************}
procedure TCTB (fcolor,bcolor : byte);
  begin
    textcolor (fcolor);
    textbackground (bcolor);
  end;
{***************************************************************************}
procedure WRITEAT (x,y : byte; the_string : string);
begin
  gotoXY (x,y);
  write (the_string);
end;
{***************************************************************************}
procedure CLRAT (x,y : byte; spaces : byte);
var n : byte;
begin
  gotoXY (x,y);
  for n := 1 to spaces do
    write (' ');
  gotoXY (x,y);
end;
{***************************************************************************}
procedure RWIN (x1,y1,x2,y2    : byte;
                boarder        : boolean;
                fcolor,bcolor  : byte);
  var
    x, y   : byte;

  begin
    textbackground (0);
    window (x1+2,y1+1,x2+2,y2+1);
    clrscr;
    textcolor (fcolor);
    textbackground (bcolor);
    window (x1,y1,x2,y2);
    if boarder then
      begin
        clrscr;
        window (1,1,80,25);
        for x := x1 to x2 do
          begin
            gotoXY (x,y1);
            write ('');
          end;
        for x := x1 to x2 do
          begin
            gotoXY (x,y2);
            write ('');
          end;
        for y := y1 to y2 do
          begin
            gotoXY (x1,y);
            write ('');
          end;
        for y := y1 to y2 do
          begin
            gotoXY (x2,y);
            write ('');
          end;
        gotoXY (x1,y1); write ('');
        gotoXY (x1,y2); write ('');
        gotoXY (x2,y1); write ('');
        gotoXY (x2,y2); write ('');
        window (x1+1,y1+1,x2-1,y2-1);
      end;
  end;
{***************************************************************************}
procedure NORMWIN;
begin
  window (1,1,80,25);
end;
{***************************************************************************}
{--------------------------------------------------------------------------}

Procedure GetOAXY(x,y:byte; var Ba,ca:byte); assembler;
VAR
   A:BYTE;
asm
   MOV AH,2
   MOV DH,Y
   MOV DL,X
   MOV BH,0
   INT $10
   MOV AH,8
   MOV BH,0
   INT $10
   LES BX,BA
   MOV ES:[BX],AH
   LES BX,CA
   MOV ES:[BX],AL
end;

{---------------------------------------------------------------------------}
Procedure No_Cursor; assembler;
asm
   MOV AH,1
   MOV CH,1
   MOV CL,0
   INT $10
end;
{---------------------------------------------------------------------------}
Procedure Cursor(a,b:shortint); assembler;
asm
   MOV AH,1
   MOV CH,A
   MOV CL,B
   INT $10
end;
{---------------------------------------------------------------------------}
{***************************************************************************}

function VidSeg : word;
  begin
    if mem[$000:$0449] = 7 then
      VidSeg := $B000
    else
      VidSeg := $B800;
  end;

{***************************************************************************}

procedure FASTWRITE (x,y : byte;  ch : char;  atrib : byte);
  var
    w          : word;
    i, colatr  : byte;

  begin
    colatr := atrib;                         { get attr byte }
    w := ((y-1)*80 + (x-1))*2;               { calculate offset }

    memW[vs:w] := (colatr shl 8) + ord(ch);
  end;

{***************************************************************************}

procedure Save_Screen;

var   i, j, b, c   : byte;
      ch           : char;

begin
  for i := 0 to 79 do
    for j := 0 to 24 do
      begin
        GetOAXY(i,j,b,c);
        ch := chr(c);
        Saved_Scr_Chars[i+1,j+1] := ch;
        Saved_Scr_Attr[i+1,j+1] := b;
      end;
end;

{***************************************************************************}

procedure Call_Screen;

var  i, j, b, c   : byte;
     ch           : char;

begin
  for i := 0 to 79 do
    for j := 0 to 24 do
      begin
        ch := Saved_Scr_Chars[i+1,j+1];
        b := Saved_Scr_Attr[i+1,j+1];
        FastWrite(i+1,j+1,ch,b);
      end;
end;
{***************************************************************************}
procedure SCR_INIT;

var  x, y    : byte;

begin
  { clearing and setting the entire screen to blue }
  TCTB(0,1);
  clrscr;

  { the top and bottom ribbons }
  TCTB(0,7);
  write ('   File    Options    Library                                            Help   ');
  gotoXY (1,25);
  clreol;
  write (' F1-Help    F2-Game SetUp    F3-Start Simulation                       ESC-Quit');

  { red lettering for hot keys }
  TCTB(4,7);
  gotoXY (4,1);  write ('F');
  gotoXY (12,1);  write ('O');
  gotoXY (23,1);  write ('L');
  gotoXY (74,1);  write ('H');
  gotoXY (2,25);  write ('F1');
  gotoXY (13,25);  write ('F2');
  gotoXY (30,25);  write ('F3');
  gotoXY (70,25); write ('ALT-X');

  { the boarder }
  TCTB(15,1);
  for x := 2 to 79 do
    begin
      gotoXY (x,2);
      write ('');
    end;
  for x := 2 to 79 do
    begin
      gotoXY (x,24);
      write ('');
    end;
  for y := 3 to 23 do
    begin
      gotoXY (1,y);
      write ('');
    end;
  for y := 3 to 23 do
    begin
      gotoXY (80,y);
      write ('');
    end;
  gotoXY (1,2); write ('');
  gotoXY (80,2); write ('');
  gotoXY (1,24); write ('');
  gotoXY (80,24); write ('');
  gotoXY (17,2); write (' Star Trek:  StarShip Tactical Combat Simulator ');
  gotoXY (2,3);

end;
{***************************************************************************}


end.