{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT WIEDERDM; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



Uses CRT;

procedure TCTB       (tc, tb : integer);
procedure WRTC       (x, y : byte; chr : char);
procedure WRTS       (x, y : byte; str : string);
procedure REGWIN;
Procedure CLEAR      (text, backcolor, ulx, uly, lrx, lry : integer);
procedure MAKEWIN    (text, backcolor, ulx, uly, lrx, lry : integer;
                      shadow, border : boolean; bordercolor : byte);
procedure HIDECURSOR (x, y, color : integer);
procedure SELECTBAR  (leftx, rightx, topy, bottomy : byte;
                      var cursor, menupos : byte;
                      var choice : char);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{****** Combines the textcolor textbackground commands into one command ******}

procedure TCTB (tc, tb : integer);

Begin
  textcolor (tc);
  textbackground (tb);
End;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure WRTC (x, y : byte; chr: char);

Begin
  gotoXY (x, y);
  write (chr);
End;

{=============================================================================}

{******** Combines the gotoXY and the write commands into one command ********}

procedure WRTS (x, y : byte; str : string);

Begin
  gotoXY (x, y);
  write (str);
End;

{=============================================================================}

{*************** Resizes to standard window without clearing it **************}

procedure REGWIN;

Begin
  window (1,1,80,25);
End;

{=============================================================================}

{***************** Redraws the standard window and clears it *****************}

procedure CLEAR (text, backcolor, ulx, uly, lrx, lry : integer);

Begin
  TCTB (text, backcolor);
  window (ulx,uly,lrx,lry);
  clrscr;
End;

{=============================================================================}

{***************** Redraws the specified window and clears it ****************}

procedure MAKEWIN (text, backcolor, ulx, uly, lrx, lry : integer;
                   shadow, border : boolean; bordercolor : byte);

var
  count : byte;

Begin
  if shadow
    then CLEAR (0, 0, (ulx + 2), (uly + 1), (lrx + 2), (lry + 1));
  CLEAR (text, backcolor, ulx, uly, lrx, lry);
  if border
    then
      begin
        TCTB (bordercolor,backcolor);
        REGWIN;
        for count := (ulx + 2) to (lrx - 2) do
          begin
            WRTC (count,uly,chr(205));
            WRTC (count,lry,chr(205));
          end;
        for count := (uly + 1) to (lry - 1) do
          begin
            WRTC ((ulx + 1),count,chr(186));
            WRTC ((lrx - 1),count,chr(186));
          end;
        WRTC ((ulx + 1),uly,chr(201));
        WRTC ((lrx - 1),uly,chr(187));
        WRTC ((ulx + 1),lry,chr(200));
        WRTC ((lrx - 1),lry,chr(188));
      end;
    window ((ulx + 2), (uly + 1), (lrx - 2), (lry - 1));
    TCTB (text,backcolor);
End;

{=============================================================================}

{****************************** Hides the cursor *****************************}

procedure HIDECURSOR (x, y, color : integer);

Begin
  TCTB (color, color);
  WRTC (x, y, ' ');
  gotoXY (x,y);
End;

{=============================================================================}

{******************* Moves about in a vertical selection bar *****************}

procedure SELECTBAR (leftx, rightx, topy, bottomy : byte;
                     var cursor, menupos : byte;
                     var choice : char);

Begin
  TCTB (4,3);
  WRTC (leftx, ((topy - 1) + cursor) ,#16);
  WRTC (rightx, ((topy - 1) + cursor),#17);
  repeat
    HIDECURSOR ((leftx - 1), ((topy - 1) + cursor),3);
    choice := readkey;
    case choice of
      #80 : begin
              TCTB (3,3);
              WRTC (leftx, ((topy - 1) + cursor) ,' ');
              WRTC (rightx, ((topy - 1) + cursor),' ');
              if ((topy - 1) + cursor) = bottomy
                then cursor := 1
                else inc(cursor);
              TCTB (4,3);
              WRTC (leftx, ((topy - 1) + cursor),#16);
              WRTC (rightx, ((topy - 1) + cursor),#17);
            end;
      #72 : begin
              TCTB (3,3);
              WRTC (leftx, ((topy - 1) + cursor) ,' ');
              WRTC (rightx, ((topy - 1) + cursor),' ');
              if ((topy - 1) + cursor) = topy
                then cursor := ((bottomy - topy) + 1)
                else dec(cursor);
              TCTB (4,3);
              WRTC (leftx, ((topy - 1) + cursor),#16);
              WRTC (rightx, ((topy - 1) + cursor),#17);
            end;
    end;  { case }

  until (choice = #13) or (choice = #27) or
        (choice = #75) or (choice = #77) or
        (choice = #32) or (choice = #45) or (choice = #35) or
        (choice = #59) or (choice = #60) or (choice = #61);
End;

{=============================================================================}

END.  {** Unit WIEDER **}