PROGRAM WINST (class_file, grade_file, period_file, teacher_file);

{*****************************************************************************
 *      This program is only used and called during the installation of      *
 *      WiederGrades, thus the name WINST (WiederGradeInstall).  All it      *
 *      does is create the files for WiederGrades, and gets the teacher.     *
 *****************************************************************************}

Const
  nograde     = -999;
  maxdgrades  = 30;
  maxtgrades  = 15;
  maxstudents = 40;
  nul         = 0;
  maxgrade    = 100;
  maxidnum    = 19999;

Type
  grade_range    = nograde..maxgrade;
  daily_range    = nul..maxdgrades;
  test_range     = nul..maxtgrades;
  class_range    = nul..maxstudents;
  idnum_range    = nul..maxidnum;

  dgrade_array   = array [1..maxdgrades] of grade_range;
  tgrade_array   = array [1..maxtgrades] of grade_range;
  dgname_array   = array [1..maxdgrades] of string;
  tgname_array   = array [1..maxtgrades] of string;
  name_array     = array [1..maxstudents] of string;
  idnum_array    = array [1..maxstudents] of idnum_range;

  teacher_record = record
                     name      : string[22];
                   end;

  class_record   = record
                     classname : string[11];
                     size      : class_range;
                     name      : name_array;
                     idnum     : idnum_array;
                   end;

  grade_record   = record
                     dnum      : daily_range;
                     tnum      : test_range;
                     dnames    : dgname_array;
                     tnames    : tgname_array;
                     classave  : real;
                   end;

  student_record = record
                     dgrades   : dgrade_array;
                     tgrades   : tgrade_array;
                     currentd  : daily_range;
                     currentt  : test_range;
                     dailysum,
                     testsum   : integer;
                     daily,
                     test,
                     total     : real;
                   end;

  student_array  = array [1..maxstudents] of student_record;

  teacher_info   = file of teacher_record;
  classes        = file of class_record;
  grades         = file of grade_record;
  students       = file of student_array;

Var
  teacher_file : teacher_info;
  class_file   : classes;
  grade_file   : grades;
  student_file : students;
  teacher      : teacher_record;
  student      : student_array;
  grade        : grade_record;
  class        : class_record;
  namechar     : char;
  period,
  count,
  counter      : byte;

Begin
  for count := 1 to maxstudents do
    begin
      student[count].currentd := 0;
      student[count].currentt := 0;
      student[count].daily := 0.0;
      student[count].test := 0.0;
      student[count].total := 0.0;
      student[count].dailysum := 0;
      student[count].testsum := 0;
      for counter := 1 to maxdgrades do student[count].dgrades[counter] := -999;
      for counter := 1 to maxtgrades do student[count].tgrades[counter] := -999;
    end;
  grade.dnum := 0;
  grade.tnum := 0;
  for count := 1 to maxdgrades do grade.dnames[count] := '';
  for count := 1 to maxtgrades do grade.tnames[count] := '';
  grade.classave := 0.0;
  class.size := 0;
  class.classname := '';
  for count := 1 to maxstudents do
    begin
      class.name[count] := '';
      class.idnum[count] := nul;
    end;
  for period := 1 to 7 do
    begin
      case period of
        1 : begin
              assign (class_file, 'c:\classes\class1.dat');
              assign (grade_file, 'c:\grades\grade1.dat');
              assign (student_file, 'c:\periods\period1.dat');
            end;
        2 : begin
              assign (class_file, 'c:\classes\class2.dat');
              assign (grade_file, 'c:\grades\grade2.dat');
              assign (student_file, 'c:\periods\period2.dat');
            end;
        3 : begin
              assign (class_file, 'c:\classes\class3.dat');
              assign (grade_file, 'c:\grades\grade3.dat');
              assign (student_file, 'c:\periods\period3.dat');
            end;
        4 : begin
              assign (class_file, 'c:\classes\class4.dat');
              assign (grade_file, 'c:\grades\grade4.dat');
              assign (student_file, 'c:\periods\period4.dat');
            end;
        5 : begin
              assign (class_file, 'c:\classes\class5.dat');
              assign (grade_file, 'c:\grades\grade5.dat');
              assign (student_file, 'c:\periods\period5.dat');
            end;
        6 : begin
              assign (class_file, 'c:\classes\class6.dat');
              assign (grade_file, 'c:\grades\grade6.dat');
              assign (student_file, 'c:\periods\period6.dat');
            end;
        7 : begin
              assign (class_file, 'c:\classes\class7.dat');
              assign (grade_file, 'c:\grades\grade7.dat');
              assign (student_file, 'c:\periods\period7.dat');
            end;
      end;
      rewrite (class_file);
      rewrite (grade_file);
      rewrite (student_file);
      write (class_file, class);
      write (grade_file, grade);
      write (student_file, student);
      close (class_file);
      close (grade_file);
      close (student_file);
    end;
  teacher.name := ' ';
  writeln;
  writeln;
  write ('Enter the teacher''s name (20 letters max) ==> ');
  repeat
    read (namechar);
    teacher.name := teacher.name + upcase(namechar);
  until eoln;
  teacher.name := copy(teacher.name,1,21);
  teacher.name := teacher.name + ' ';
  readln;
  assign (teacher_file, 'c:\teacher\teacher.dat');
  rewrite (teacher_file);
  write (teacher_file, teacher);
  close (teacher_file);
End.