PROGRAM COLORS (Teacher_File);

USES CRT, UTILITY;

CONST
  def_wincolor    = 7;
  def_wintext     = 0;
  def_winborder   = 15;
  def_wintype     = 2;
  def_winselec    = 9;
  def_maintext    = 15;
  def_mainback    = 1;
  def_mainborder  = 11;
  def_mainbold    = 14;
  def_menutext    = 0;
  def_menuback    = 7;
  def_cuttext     = 1;
  def_cutback     = 7;
  def_selectext   = 15;
  def_selecback   = 0;
  black           = 0;
  blue            = 1;
  green           = 2;
  cyan            = 3;
  red             = 4;
  purple          = 5;
  oarnge          = 6;
  grey            = 7;
  darkgrey        = 8;
  brightblue      = 9;
  brightgreen     = 10;
  brightcyan      = 11;
  brightred       = 12;
  magenta         = 13;
  yellow          = 14;
  white           = 15;
  leftarrow       = #16;
  rightarrow      = #17;
  sighori         = #196;
  dobhori         = #205;
  sigvert         = #179;
  dobvert         = #186;
  sigul           = #218;
  dobul           = #201;
  sigdobul        = #213;
  dobsigul        = #214;
  up              = #72;
  down            = #80;
  left            = #75;
  right           = #77;
  enter           = #13;
  esc             = #27;
  pointer         = '';
  erase           = '   ';


TYPE
  Pref_Record    = RECORD
                     wincolor     : byte;
                     wintext      : byte;
                     winborder    : byte;
                     wintype      : byte;
                     winselec     : byte;
                     maintext     : byte;
                     mainback     : byte;
                     mainborder   : byte;
                     mainbold     : byte;
                     menutext     : byte;
                     menuback     : byte;
                     cuttext      : byte;
                     cutback      : byte;
                     selectext    : byte;
                     selecback    : byte;
                   END;
  Teacher_Record = RECORD
                     Name : STRING[22];
                     Pref : Pref_Record;
                   END;
  Teacher_Info   = FILE OF Teacher_Record;

VAR
  Teacher_File : Teacher_Info;
  Teacher      : Teacher_Record;
  count        : byte;
  hori,
  vert,
  ul           : char;

PROCEDURE ReadFile;

BEGIN
  assign (Teacher_File, 'c:teacher.cfg');
  reset (Teacher_File);
  read (Teacher_File, Teacher);
  close (Teacher_File);
END;

PROCEDURE SaveFile;

BEGIN
  assign (Teacher_File, 'c:teacher.cfg');
  rewrite (Teacher_File);
  write (Teacher_File, Teacher);
  close (Teacher_File);
END;

PROCEDURE Menu;
BEGIN
  with teacher.pref do
    begin
      makewin (true,true,winborder,wintype,wintext,wincolor,44,9,11,6);
      writeln ('  Load');
      writeln ('  Print');
      writeln ('  New');
      write ('  Exit');
      tctb (winselec,wincolor);
      wrtc (2,2,leftarrow);
      wrtc (8,2,rightarrow);
    end;
END;

PROCEDURE MenuBar;
BEGIN
  with teacher.pref do
    begin
      clear (menutext,menuback,40,7,74,7);
      window (40,7,75,8);
      wrts (5,1,' ile');
      wrts (14,1,' dd');
      wrts (21,1,' earch');
      wrts (32,1,' iew');
      tctb (cuttext,cutback);
      wrtc (5,1,'F');
      wrtc (14,1,'A');
      wrtc (21,1,'S');
      wrtc (32,1,'V');
    end;
END;

PROCEDURE BorderType;
BEGIN
  with teacher.pref do
    begin
      case wintype of
        1: begin
             hori := sighori;
             vert := sigvert;
             ul := sigul;
           end;
        2: begin
             hori := dobhori;
             vert := dobvert;
             ul := dobul;
           end;
        3: begin
             hori := dobhori;
             vert := sigvert;
             ul := sigdobul;
           end;
        4: begin
             hori := sighori;
             vert := dobvert;
             ul := dobsigul;
           end;
      end;
      window (40,8,74,19);
      tctb (mainborder,mainback);
      for count := 2 to 35 do
        wrtc (count,1,hori);
      for count := 2 to 11 do
        wrtc (2,count,vert);
      wrtc (2,1,ul);
      wrts (5,1,'Teacher: ');
      tctb (maintext,mainback);
    end;
  wrts (14,1,teacher.name);
END;

PROCEDURE Main;
BEGIN
  with teacher.pref do
    begin
      menubar;
      clear (maintext,mainback,40,8,74,18);
      tctb (maintext,mainback);
      wrts (21,5,'Main Text');
      tctb (mainbold,mainback);
      wrts (21,7,'Bold Text');
      tctb (selectext,selecback);
      wrts (21,9,'Selection Bar');
      bordertype;
      menu;
      regwin;
    end;
END;

PROCEDURE MainScreen;
BEGIN
  TCTB (14,0);
  clrscr;
  wrts (24,2,'WiederGrades 2.0 Preference Setup');
  tctb (15,0);
  writeln;
  writeln ('  Up and down arrows select an item',
           ' and left and right arrows change settings.');
  writeln ('     Press <ESC> to save and exit or press <ENTER> to reset',
           ' default setup.');
  writeln;
  writeln;
  writeln;
  TCTB (11,0);
  wrts (7,6,'Border Style');
  wrts (7,7,'Main Text');
  wrts (7,8,'Main Bold');
  wrts (7,9,'Main Background');
  wrts (7,10,'Main Border');
  wrts (7,11,'Pulldown Text');
  wrts (7,12,'Pulldown Background');
  wrts (7,13,'Pulldown Border');
  wrts (7,14,'Pulldown Arrows');
  wrts (7,15,'Menu Bar Text');
  wrts (7,16,'Menu Bar Background');
  wrts (7,17,'Shortcut Text');
  wrts (7,18,'Shortcut Background');
  wrts (7,19,'Selection Bar Text');
  wrts (7,20,'Selection Bar Background');
  tctb (9,0);
  wrts (16,23,'WiederGrades 2.0 setup for ==>');
  tctb (15,0);
  write (teacher.name);
END;

PROCEDURE ChangeDown (cursor : byte);
BEGIN
  with teacher.pref do
    begin
      case cursor of
         1 : begin
               dec(wintype);
               if wintype = 0 then wintype := 4;
             end;
         2 : begin
               dec(maintext);
               if maintext = 255 then maintext := 15;
             end;
         3 : begin
               dec (mainbold);
               if mainbold = 255 then mainbold := 15;
             end;
         4 : begin
               dec (mainback);
               if mainback = 255 then mainback := 7;
             end;
         5 : begin
               dec (mainborder);
               if mainborder = 255 then mainborder := 15;
             end;
         6 : begin
               dec (wintext);
               if wintext = 255 then wintext := 15;
             end;
         7 : begin
               dec (wincolor);
               if wincolor = 255 then wincolor := 7;
             end;
         8 : begin
               dec (winborder);
               if winborder = 255 then winborder := 15;
             end;
         9 : begin
               dec (winselec);
               if winselec = 255 then winselec := 15;
             end;
        10 : begin
               dec (menutext);
               if menutext = 255 then menutext := 15;
             end;
        11 : begin
               dec (menuback);
               if menuback = 255 then menuback := 7;
             end;
        12 : begin
               dec (cuttext);
               if cuttext = 255 then cuttext := 15;
             end;
        13 : begin
               dec (cutback);
               if cutback = 255 then cutback := 7;
             end;
        14 : begin
               dec (selectext);
               if selectext = 255 then selectext := 15;
             end;
        15 : begin
               dec (selecback);
               if selecback = 255 then selecback := 7;
             end;
      end;
    end;
END;

PROCEDURE ChangeUp (cursor : byte);
BEGIN
  with teacher.pref do
    begin
      case cursor of
         1 : begin
               inc(wintype);
               if wintype = 5 then wintype := 1;
             end;
         2 : begin
               inc(maintext);
               if maintext = 16 then maintext := 0;
             end;
         3 : begin
               inc (mainbold);
               if mainbold = 16 then mainbold := 0;
             end;
         4 : begin
               inc (mainback);
               if mainback = 8 then mainback := 0;
             end;
         5 : begin
               inc (mainborder);
               if mainborder = 16 then mainborder := 0;
             end;
         6 : begin
               inc (wintext);
               if wintext = 16 then wintext := 0;
             end;
         7 : begin
               inc (wincolor);
               if wincolor = 8 then wincolor := 0;
             end;
         8 : begin
               inc (winborder);
               if winborder = 16 then winborder := 0;
             end;
         9 : begin
               inc (winselec);
               if winselec = 16 then winselec := 0;
             end;
        10 : begin
               inc (menutext);
               if menutext = 16 then menutext := 0;
             end;
        11 : begin
               inc (menuback);
               if menuback = 8 then menuback := 0;
             end;
        12 : begin
               inc (cuttext);
               if cuttext = 16 then cuttext := 0;
             end;
        13 : begin
               inc (cutback);
               if cutback = 8 then cutback := 0;
             end;
        14 : begin
               inc (selectext);
               if selectext = 16 then selectext := 0;
             end;
        15 : begin
               inc (selecback);
               if selecback = 8 then selecback := 0;
             end;
      end;
    end;
END;

PROCEDURE ResetDefault;

var
choice : char;

BEGIN
  tctb (15,4);
  wrts (8,22,'Are you sure you want to reset the default configuration? <Y/N>');
  hidecursor (7,22,0);
  choice := upcase(readkey);
  if choice = 'Y'
    then
      with teacher.pref do
        begin
          wincolor := def_wincolor;
          wintext := def_wintext;
          winborder := def_winborder;
          wintype := def_wintype;
          winselec := def_winselec;
          maintext := def_maintext;
          mainback := def_mainback;
          mainborder := def_mainborder;
          mainbold := def_mainbold;
          menutext := def_menutext;
          menuback := def_menuback;
          cuttext := def_cuttext;
          cutback := def_cutback;
          selectext := def_selectext;
          selecback := def_selecback;
        end;
  clear (0,0,8,22,70,22);
END;

PROCEDURE MakeSelections;

VAR
  Cursor : byte;
  Exit,
  Choice : char;

BEGIN
  Main;
  regwin;
  tctb (12,0);
  cursor := 1;
  wrts (4,cursor + 5,pointer);
  exit := 'N';
  repeat
    hidecursor (3,cursor + 5,0);
    tctb (12,0);
    choice := readkey;
    case choice of
      up    : begin
                wrts (4,cursor + 5,erase);
                dec(cursor);
                if cursor = 0 then cursor := 15;
                wrts (4,cursor + 5,pointer);
              end;
      down  : begin
                wrts (4,cursor + 5,erase);
                inc(cursor);
                if cursor = 16 then cursor := 1;
                wrts (4,cursor + 5,pointer);
              end;
      left  : begin
                ChangeDown (cursor);
                Main;
              end;
      right : begin
                Changeup (cursor);
                Main;
              end;
      enter : begin
                ResetDefault;
                Main;
              end;
    end;
  until (choice = #27);
END;

BEGIN
  checkbreak := false;
  ReadFile;
  MainScreen;
  MakeSelections;
  SaveFile;
  clear (7,0,1,1,80,25);
END.