PROGRAM WINST (class_file, grade_file, period_file, teacher_file);

{*****************************************************************************
 *      This program is only used and called during the installation of      *
 *      WiederGrades, thus the name WINST (WiederGradeInstall).  All it      *
 *      does is create the files for WiederGrades, and gets the teacher.     *
 *****************************************************************************}

USES Crt;

Const
  nograde     = -999;
  nul         = 0;
  def_wincolor    = 7;
  def_wintext     = 0;
  def_winborder   = 15;
  def_wintype     = 2;
  def_winselec    = 9;
  def_maintext    = 15;
  def_mainback    = 1;
  def_mainborder  = 11;
  def_mainbold    = 14;
  def_menutext    = 0;
  def_menuback    = 7;
  def_cuttext     = 1;
  def_cutback     = 7;
  def_selectext   = 15;
  def_selecback   = 0;
  maxdgrades      = 30;
  maxtgrades      = 15;
  maxstudents     = 40;
  maxgrade        = 100;
  maxidnum        = 20000;

Type
  grade_range    = nograde..maxgrade;
  daily_range    = nul..maxdgrades;
  test_range     = nul..maxtgrades;
  class_range    = nul..maxstudents;
  idnum_range    = nul..maxidnum;
  dgrade_array   = array [1..maxdgrades] of grade_range;
  tgrade_array   = array [1..maxtgrades] of grade_range;
  dgname_array   = array [1..maxdgrades] of string;
  tgname_array   = array [1..maxtgrades] of string;
  name_array     = array [1..maxstudents] of string;
  idnum_array    = array [1..maxstudents] of idnum_range;
  Pref_Record    = RECORD
                     wincolor     : byte;
                     wintext      : byte;
                     winborder    : byte;
                     wintype      : byte;
                     winselec     : byte;
                     maintext     : byte;
                     mainback     : byte;
                     mainborder   : byte;
                     mainbold     : byte;
                     menutext     : byte;
                     menuback     : byte;
                     cuttext      : byte;
                     cutback      : byte;
                     selectext    : byte;
                     selecback    : byte;
                   END;
  Teacher_Record = RECORD
                     Name : STRING[22];
                     Pref : Pref_Record;
                   END;
  class_record   = record
                     classname : string[11];
                     size      : class_range;
                     name      : name_array;
                     idnum     : idnum_array;
                   end;
  grade_record   = record
                     dnum      : daily_range;
                     tnum      : test_range;
                     dnames    : dgname_array;
                     tnames    : tgname_array;
                     classave  : real;
                   end;
  student_record = record
                     dgrades   : dgrade_array;
                     tgrades   : tgrade_array;
                     currentd  : daily_range;
                     currentt  : test_range;
                     dailysum,
                     testsum   : integer;
                     daily,
                     test,
                     total     : real;
                   end;
  student_array  = array [1..maxstudents] of student_record;
  teacher_info   = file of teacher_record;
  classes        = file of class_record;
  grades         = file of grade_record;
  students       = file of student_array;

Var
  teacher_file : teacher_info;
  class_file   : classes;
  grade_file   : grades;
  student_file : students;
  teacher      : teacher_record;
  student      : student_array;
  grade        : grade_record;
  class        : class_record;
  namechar     : char;
  filea,
  fileb,
  filec        : STRING;
  period,
  count,
  counter      : byte;

Begin
  writeln ('This program will install WiederGrades 2.0 into directory:');
  writeln ('Press any key to continue installing WiederGrades...');
  readln;
  writeln;
  with teacher.pref do
    begin
      wincolor := def_wincolor;
      wintext := def_wintext;
      winborder := def_winborder;
      wintype := def_wintype;
      winselec := def_winselec;
      maintext := def_maintext;
      mainback := def_mainback;
      mainborder := def_mainborder;
      mainbold := def_mainbold;
      menutext := def_menutext;
      menuback := def_menuback;
      cuttext := def_cuttext;
      cutback := def_cutback;
      selectext := def_selectext;
      selecback := def_selecback;
    end;
  for count := 1 to maxstudents do
    begin
      student[count].currentd := 0;
      student[count].currentt := 0;
      student[count].daily := 0.0;
      student[count].test := 0.0;
      student[count].total := 0.0;
      student[count].dailysum := 0;
      student[count].testsum := 0;
      for counter := 1 to maxdgrades do
        student[count].dgrades[counter] := -999;
      for counter := 1 to maxtgrades do
        student[count].tgrades[counter] := -999;
    end;
  grade.dnum := 0;
  grade.tnum := 0;
  for count := 1 to maxdgrades do grade.dnames[count] := '';
  for count := 1 to maxtgrades do grade.tnames[count] := '';
  grade.classave := 0.0;
  class.size := 0;
  class.classname := '';
  for count := 1 to maxstudents do
    begin
      class.name[count] := '';
      class.idnum[count] := nul;
    end;
  for period := 1 to 7 do
    begin
      filea := concat('c:class',chr(period + 48),'.wg2'); write ('.');
      fileb := concat('c:grade',chr(period + 48),'.wg2'); write ('.');
      filec := concat('c:period',chr(period + 48),'.wg2'); write ('.');
      assign (class_file, filea); write ('.');
      assign (grade_file, fileb); write ('.');
      assign (student_file, filec); write ('.');
      rewrite (class_file); write ('.');
      rewrite (grade_file); write ('.');
      rewrite (student_file); write ('.');
      write (class_file, class); write ('.');
      write (grade_file, grade); write ('.');
      write (student_file, student); write ('.');
      close (class_file); write ('.');
      close (grade_file); write ('.');
      close (student_file); write ('.');
    end;
  teacher.name := ' ';
  writeln;
  writeln;
  write ('Enter the teacher''s name (20 letters max) ==> ');
  repeat
    read (namechar);
    teacher.name := teacher.name + upcase(namechar);
  until eoln;
  teacher.name := copy(teacher.name,1,21);
  teacher.name := teacher.name + ' ';
  readln;
  assign (teacher_file, 'c:teacher.cfg');
  rewrite (teacher_file);
  write (teacher_file, teacher);
  close (teacher_file);
End.