{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT WGHELP; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



USES CRT, UTILITY;

Var
  chrc : char;

  Procedure HELP  (wincolor,wintext,winborder,wintype,maintext,mainback : byte);
  Procedure ABOUT (wincolor,wintext,winborder,menupos,wintype,maintext,mainback : byte);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{***************** Creates the window for WiederGrades help ******************}

Procedure HELPWIN (wincolor, wintext, winborder,wintype : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,15,4,50,19);
  REGWIN;
  TCTB (8,0);
  WRTC (66,5,'A');
  case wintype of
    1,4 : WRTS (65,6,'');
    2,3 : WRTS (65,6,'');
  end;
  TCTB (winborder,wincolor);
  WRTS (30,4,' WiederGrades 2.0 Help ');
  window (18,5,63,21);
End;

{=============================================================================}

{************* Draws the page up and page down in the window *****************}

Procedure PAGEUPDN (wincolor,winborder,pagepos,wintype : byte);

Begin
  REGWIN;
  TCTB (winborder,wincolor);
  case wintype of
    1,4 : WRTS (55,22,'');
    2,3 : WRTS (55,22,'');
  end;
  if (pagepos < 6) and (pagepos > 1) then WRTS (55,22,'PgUp/PgDn');
  if pagepos = 1 then WRTS (60,22,'PgDn');
  if pagepos = 6 then WRTS (60,22,'PgUp');
  window (18,5,62,21);
End;

{=============================================================================}

{******************* Creates Page 1 of WiederGrades help *********************}

Procedure PAGE1 (wintext,wincolor : byte);

Begin
  TCTB (wintext,wincolor);
  writeln (' File Menu');
  writeln ('---------------------------------------------');
  writeln ('Load');
  writeln (' Loads the period selected');
  writeln;
  writeln ('Print');
  writeln (' Class Report : Single report of entire class');
  writeln (' One Student  : Ind. report of one student');
  writeln (' All Students : Ind. reports of entire class');
  writeln;
  writeln ('New');
  writeln (' New Six Weeks: Clear grades and averages');
  writeln (' New Year     : Clear everything');
  writeln;
  writeln ('Exit');
  write   (' Exit WiederGrades');
End;

{=============================================================================}

{******************* Creates Page 2 of WiederGrades help *********************}

Procedure PAGE2 (wintext,wincolor : byte);

Begin
  TCTB (wintext,wincolor);
  writeln (' Add Menu');
  writeln ('---------------------------------------------');
  writeln ('Students');
  writeln (' Add students to the class roll');
  writeln;
  writeln ('DailyNames');
  writeln (' Add daily grade names for assignments');
  writeln;
  writeln ('TestNames');
  writeln (' Add test grade names for assignments');
  writeln;
  writeln ('DailyGrades');
  writeln (' Enter daily grades for students');
  writeln;
  writeln ('TestGrades');
  write   (' Enter test grades for students');
End;

{=============================================================================}

{******************* Creates Page 3 of WiederGrades help *********************}

Procedure PAGE3 (wintext,wincolor : byte);

Begin
  TCTB (wintext,wincolor);
  writeln (' Search Menu');
  writeln ('---------------------------------------------');
  writeln ('FirstName');
  writeln (' Search for a student by first name');
  writeln;
  writeln ('LastName');
  writeln (' Search for a student by last name');
  writeln;
  writeln ('IDNumber');
  writeln (' Search for a student by ID number');
  writeln;
  writeln;
  writeln (' Each option lists the students with');
  writeln (' matching names and their averages, or');
  writeln (' states that no matches were found if none');
  write   (' of the students match the target.');
End;

{=============================================================================}

{******************* Creates Page 4 of WiederGrades help *********************}

Procedure PAGE4 (wintext,wincolor : byte);

Begin
  TCTB (wintext,wincolor);
  writeln (' View Menu');
  writeln ('---------------------------------------------');
  writeln ('AllAverages');
  writeln (' Displays a maximum of 20 students per page,');
  writeln (' showing their ID numbers and averages.');
  writeln (' The other 20 students can be seen by');
  writeln (' pressing PgUp or PgDn to flip through');
  writeln (' the student information.');
  writeln;
  writeln;
  writeln ('ClassGrades');
  writeln (' Displays a maximum of 20 students per');
  writeln (' page, showing the current grade position,');
  writeln (' student position, class average, and student');
  writeln (' average.');
  writeln (' All grades may be edited from this option.');
End;

{=============================================================================}

{******************* Creates Page 5 of WiederGrades help *********************}

Procedure PAGE5 (wintext,wincolor : byte);

Begin
  TCTB (wintext,wincolor);
  writeln (' Edit Menu');
  writeln ('---------------------------------------------');
  write   ('Name        : ');
  writeln ('Edit student name');
  write   ('IDNumber    : ');
  writeln ('Edit student ID number');
  writeln;
  write   ('DailyGrades : ');
  writeln ('Edit student daily grade');
  write   ('TestGrades  : ');
  writeln ('Edit student test grade');
  writeln;
  write   ('DailyNames  : ');
  writeln ('Edit daily grade name');
  write   ('TestNames   : ');
  writeln ('Edit test grade name');
  writeln;
  write   ('CurveDaily  : ');
  writeln ('Curve a daily grade');
  write   ('CurveTest   : ');
  writeln ('Curve a test grade');
  writeln;
  write   ('DropLowGrade: ');
  writeln ('Drop all student''s lowest grade');
  write   ('ClassName   : ');
  write   ('Edit class name');
End;

{=============================================================================}

{******************* Creates Page 6 of WiederGrades help *********************}

Procedure PAGE6 (wintext,wincolor : byte);

Begin
  TCTB (wintext,wincolor);
  writeln (' Menu Key Strokes');
  writeln ('---------------------------------------------');
  write   ('<ALT F>  or  <F1>  ==>  ');
  writeln ('Open File Menu');
  write   ('<ALT A>  or  <F2>  ==>  ');
  writeln ('Open Add Menu');
  write   ('<ALT S>  or  <F3>  ==>  ');
  writeln ('Open Search Menu');
  write   ('<ALT V>  or  <F4>  ==>  ');
  writeln ('Open View Menu');
  write   ('<ALT E>  or  <F5>  ==>  ');
  writeln ('Open Edit Menu');
  write   ('<ALT H>  or  <F6>  ==>  ');
  writeln ('Open Help Menu');
  writeln;
  writeln;
  writeln (' Exit Option Key Strokes');
  writeln ('---------------------------------------------');
  write   ('<ESC>       ==>  ');
  writeln ('Exit a menu');
  write   ('<X> or <x>  ==>  ');
  writeln ('Exit from options when');
  writeln ('                 entering data');
  write   ('<ALT X>     ==>  ');
  writeln ('Exit WiederGrades');
End;

{=============================================================================}

{************************ Runs WiederGrades Help *****************************}

Procedure HELP (wincolor,wintext,winborder,wintype,maintext,mainback : byte);

var
  pagepos : byte;

Begin
  pagepos := 1;
  HELPWIN (wincolor,wintext,winborder,wintype);
  PAGE1 (wintext,wincolor);
  repeat
    PAGEUPDN (wincolor,winborder,pagepos,wintype);
    HIDECURSOR (1,1,wincolor);
    repeat
      chrc := readkey;
    until (chrc = #27) or (chrc = #73) or (chrc = #81);
    if chrc = #81 then inc(pagepos);
    if pagepos = 7 then pagepos := 6;
    if chrc = #73 then dec(pagepos);
    if pagepos = 0 then pagepos := 1;
    CLEAR (wintext,wincolor,18,5,63,21);
    case pagepos of
      1 : PAGE1 (wintext,wincolor);
      2 : PAGE2 (wintext,wincolor);
      3 : PAGE3 (wintext,wincolor);
      4 : PAGE4 (wintext,wincolor);
      5 : PAGE5 (wintext,wincolor);
      6 : PAGE6 (wintext,wincolor);
    end;
  until chrc = #27;
  CLEAR (maintext,mainback,4,3,77,24);
End;

{=============================================================================}

{*********************** Creates the about window ****************************}

Procedure ABOUT (wincolor,wintext,winborder,menupos,wintype,maintext,mainback : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,19,5,46,13);
  REGWIN;
  TCTB (8,0);
  if menupos = 6
    then
      case wintype of
        1,4 : WRTS (65,6,'');
        2,3 : WRTS (65,6,'');
      end;
  TCTB (winborder,wincolor);
  WRTS (33,5,' WiederGrades 2.0');
  TCTB (wintext,wincolor);
  window (22,6,63,16);
  writeln;
  writeln ('Author............. Charles T. Wiederhold');
  writeln ('                    M0124 Jester Center');
  writeln ('                    101 East 21st Street');
  writeln ('                    Austin, Texas   78705');
  writeln ('                    (512)495-2578');
  writeln;
  writeln ('Date............... January 1995');
  writeln;
  write   ('Version............ WiederGrades 2.0');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
  CLEAR (maintext,mainback,4,3,77,20);
End;

{=============================================================================}

END.  {*** UNIT WGHELP ***}