{$M $4000,0,255360}
PROGRAM GAMER; {Game Add-on MangER}

USES
  NewDelay,
  Crt,
  Dos,
  Menus,
  Utility,
  SSData,
  TOCADT,
  TOCData;

VAR
  ExitVals  : ExitCharSet;
  DirInfo   : SearchRec;
  OrigMode  : Integer;
  Launched,
  Done      : Boolean;

  Error     : Byte;
  ErrorInfo : STRING;

  NumGames  : Integer;
  Addons    : MenuList;

{***************************************************************************}
FUNCTION EnoughSpace (Drive : Char; DiskSpace : Real) : Boolean;

VAR
  Enough : Boolean;

BEGIN
  IF Drive IN ['A'..'Z'] THEN
      Enough := (DiskFree(ord(Drive) - 64) - (DiskSpace * 1000000)) > (DiskSpace * 1000000)
    ELSE
      Enough := (DiskFree(0) - (DiskSpace * 1000000)) > (DiskSpace * 1000000);
  EnoughSpace := Enough;
  IF NOT Enough THEN
      BEGIN
        MakeWin (0 + 16,0,10,6,60,6,True,True);
        TcTb (12 + 16,0);
        WrtS (2,1,'Error: Not enough room available on the specified drive!');
        TcTb (15 + 16,0);
        gotoXY (10,2);
        write ('You need approximately ',  DiskSpace:0:1, ' megs free...');
        WrtS (6,3,'Please free up enough disk space and try again.');
        TcTb (14 + 16,0);
        WrtS (15,4,'Press any key to exit GAMER');
        REPEAT UNTIL KeyPressed;
      END;
END;

{***************************************************************************}
FUNCTION DoLaunch (AddonTitle : STRING; Launcher : STRING) : Boolean;

VAR
  ExitChars : ExitCharSet;
  Choice    : Char;
  Cursor    : Byte;
  Menu      : MenuType;

BEGIN
  Menu[1] := ' YES ';
  Menu[2] := ' NO ';
  MakeWin (0 + 16,0,16,5,48,7,True,True);
  TcTb (14 + 16,0);
  WrtCenter (46,2,'Run ' + Launcher + ' to play.');
  TcTb (15 + 16,0);
  WrtCenter (46,1,AddonTitle + ' Activated');
  WrtCenter (46,3,'Would you like to play now?');
  TcTb (7 + 16,0);
  WrtS (20,4,Menu[1]);
  WrtS (20,5,Menu[2]);
  Cursor := 1;
  ExitChars := [#13,#27];
  ArraySelect (7 + 16,0,15 + 16,1,20,4,2,Cursor,Choice,Menu,ExitVals);
  IF Choice = #13 THEN
      CASE Cursor OF
        1 : DoLaunch := True;
        2 : DoLaunch := False;
      END
    ELSE DoLaunch := False;
END;

{***************************************************************************}
PROCEDURE Initialize
  (VAR GameMenu : MenuList;
   VAR Cursor   : Byte);

VAR
  Version      : Real;
  TempStr,
  GameTitle,
  AddonDir,
  GameDir,
  Current      : STRING;
  AddonTitle   : STRING[32];
  SSIFile      : File;
  ModifyInit,
  InitFile     : Text;
  Count,
  Counter      : Byte;
  NumRead      : Word;
  Buffer       : LongInt;
  AddonItem    : MenuElementType;
  CurrentFound : Boolean;

BEGIN

  Done := False;
  Error := 0;
  Cursor := 1;
  MenuCreateList (GameMenu);
  IF CheckFile ('GAMER.INI','',0) THEN
      BEGIN
        assign (InitFile,'GAMER.INI');
        reset (InitFile);
        REPEAT
          readln (InitFile,TempStr);
        UNTIL (TempStr = '// End of text header') OR EOF(InitFile);
        IF TempStr <> '// End of text header' THEN
            BEGIN
              Done := True;
              Error := 1;
              Exit;
            END;
        readln (InitFile,Version);
        close (InitFile);
        IF Version <> GamerVersion THEN
            BEGIN
              assign (InitFile,'GAMER.INI');
              reset (InitFile);
              assign (ModifyInit,'GAMER.IN_');
              rewrite (ModifyInit);
              REPEAT
                readln (InitFile,TempStr);
                writeln (ModifyInit,TempStr);
              UNTIL (TempStr = '// End of text header') OR EOF(InitFile);
              readln (InitFile,Version);
              writeln (ModifyInit,GamerVersion:0:2);
              REPEAT
                readln (InitFile,TempStr);
                writeln (ModifyInit,TempStr);
              UNTIL EoF(InitFile);
              close (InitFile);
              erase (InitFile);
              close (ModifyInit);
              rename (ModifyInit,'GAMER.INI');
            END;
        assign (InitFile,'GAMER.INI');
        reset (InitFile);
        REPEAT
          readln (InitFile,TempStr);
        UNTIL (TempStr = '// End of text header') OR EOF(InitFile);
        IF TempStr <> '// End of text header' THEN
            BEGIN
              Done := True;
              Error := 1;
              Exit;
            END;
        readln (InitFile,Version);
        readln (InitFile,NumGames);
        FOR Count := 1 TO NumGames DO
          BEGIN
            readln (InitFile,GameTitle);
            readln (InitFile,AddonDir);
            findfirst (AddonDir,Directory,DirInfo);
            IF DosError = 0 THEN
                BEGIN
                  readln (InitFile,Current);
                  IF Current <> 'NONE' THEN
                      CurrentFound := False
                    ELSE CurrentFound := True;

                  readln (InitFile,GameDir);
                  FindFirst (AddonDir + '\*.ssi',AnyFile,DirInfo);
                  WHILE DosError = 0 DO
                    BEGIN
                      AddonItem.FileName := DirInfo.Name;
                      assign (SSIFile,AddonDir + '\' + DirInfo.Name);
                      reset (SSIFile,1);
                      blockread (SSIFile,AddonItem.Version,sizeof(AddonItem.Version),NumRead);
                      blockread (SSIFile,Buffer,sizeof(Buffer),NumRead);
                      blockread (SSIFile,AddonTitle,sizeof(AddonTitle),NumRead);
                      IF AddonItem.Version > 1 THEN
                          blockread (SSIFile,AddonItem.Launcher,sizeof(AddonItem.Launcher),NumRead)
                        ELSE AddonItem.Launcher := 'DUKE3D.EXE';
                      IF AddonTitle = Current THEN
                          BEGIN
                            AddonItem.Activated := True;
                            CurrentFound := True;
                          END
                        ELSE AddonItem.Activated := False;
                      AddonItem.Title := ' ' + GameTitle + ' - ' + AddonTitle + ' ';
                      FOR Counter := 1 TO 3 DO
                        blockread (SSIFile,AddonItem.LongDescrpt[Counter],
                                   sizeof(AddonItem.LongDescrpt[Counter]),NumRead);
                      close (SSIFile);
                      MenuInsertElement (GameMenu,AddonItem);
                      FindNext (DirInfo);
                    END;
                END
              ELSE
                BEGIN
                  Done := True;
                  ErrorInfo := AddonDir;
                  Error := 2;
                  Exit;
                END;
            IF NOT(CurrentFound) THEN
              BEGIN
                Done := True;
                ErrorInfo := Current;
                Error := 6;
                Exit;
              END;
          END;
        MenuResetList (GameMenu);
        FOR Count := 1 TO MenuListLength(GameMenu) DO
          BEGIN
            MenuGetNextItem (GameMenu,AddonItem);
            MenuDeleteElement (GameMenu,AddonItem);
            AddonItem.Position := Count;
            MenuInsertElement (GameMenu,AddonItem);
          END;
        close (InitFile);
      END
    ELSE
      BEGIN
        Done := True;
        Error := 3;
        Exit;
      END;
  IF MenuListLength(GameMenu) = 0 THEN
      BEGIN
        Done := True;
        Error := 4;
        Exit;
      END;
END;

{***************************************************************************}
PROCEDURE Hack (GameDir, FileName : STRING);

VAR
  HackScript     : Text;
  NewFile,
  HackFile       : FILE;
  Location,
  TempStr,
  BreakStr,
  HackFileName,
  HackFileSubDir : STRING;
  NumRead,
  NumWritten     : Word;
  Code           : Integer;
  LeftToRead     : LongInt;
  Count,
  Counter,
  NumFiles       : Byte;
  Buffer         : ^LargeBufType;
  HackItem       : HackRec;

BEGIN
  assign (HackScript,FileName);
  reset (HackScript);
  readln (HackScript,NumFiles);
  new (Buffer);
  FOR Count := 1 TO NumFiles DO
    BEGIN
      readln (HackScript,HackFileName);
      readln (HackScript,HackFileSubDir);
      IF HackFileSubDir <> '' THEN
          Location := GameDir + HackFileSubDir
        ELSE Location := GameDir;
      IF CheckFile (HackFileName, Location,Archive) THEN
          BEGIN
            assign (HackFile,Location + HackFileName);
            assign (NewFile,Location + 'HACKFILE.SSI');
         END;
      IF DosError = 0 THEN
        BEGIN
          reset (HackFile,1);
          rewrite (NewFile,1);
          readln (HackScript,TempStr);
          NumRead := 0;
          WHILE TempStr <> 'END' DO
            BEGIN
              BreakStr := copy (TempStr,1,pos(' ',TempStr) - 1);
              delete (TempStr,1,pos(' ',TempStr));
              val (BreakStr,HackItem.ByteLoc,Code);
              BreakStr := copy (TempStr,1,pos(' ',TempStr) - 1);
              delete (TempStr,1,pos(' ',TempStr));
              val (BreakStr,Hackitem.VarType,Code);
              IF Hackitem.VarType = 0 THEN
                  BEGIN
                    BreakStr := copy (TempStr,1,pos(' ',TempStr) - 1);
                    delete (TempStr,1,pos(' ',TempStr));
                    val (BreakStr,Hackitem.StrLength,Code);
                  END;
              LeftToRead := (Hackitem.ByteLoc - 1) - NumRead;
              WHILE LeftToRead > 0 DO
                BEGIN
                  IF LeftToRead > 64000 THEN
                      BEGIN
                        blockread (HackFile,Buffer^,sizeof(Buffer^),NumRead);
                        blockwrite (NewFile,Buffer^,NumRead,NumWritten);
                        LeftToRead := LeftToRead - 64000;
                      END
                    ELSE
                      BEGIN
                        blockread (HackFile,Buffer^,LeftToRead,NumRead);
                        blockwrite (NewFile,Buffer^,NumRead,NumWritten);
                        LeftToRead := 0;
                      END;
                END;
              CASE Hackitem.VarType OF
                0 : BEGIN
                      blockread (HackFile,Hackitem.StringVal,Hackitem.StrLength,NumRead);
                      Hackitem.StringVal := TempStr;
                      FOR Counter := 1 TO length(HackItem.StringVal) DO
                        blockwrite (NewFile,HackItem.StringVal[Counter],1,NumWritten);
                      TempStr := '';
                      FOR Counter := (length(Hackitem.StringVal) + 1) TO Hackitem.StrLength DO
                        blockwrite (NewFile,TempStr,1,NumWritten);
                    END;
                1 : BEGIN
                      blockread (HackFile,Hackitem.CharVal,sizeof(Hackitem.CharVal),NumRead);
                      Hackitem.CharVal := TempStr[1];
                      blockwrite (NewFile,Hackitem.CharVal,NumRead,NumWritten);
                    END;
                2 : BEGIN
                      blockread (HackFile,Hackitem.BooleanVal,sizeof(Hackitem.BooleanVal),NumRead);
                      IF TempStr = 'TRUE' THEN
                          Hackitem.BooleanVal := True
                        ELSE Hackitem.BooleanVal := False;
                      blockwrite (NewFile,Hackitem.BooleanVal,NumRead,NumWritten);
                    END;
                3 : BEGIN
                      blockread (HackFile,Hackitem.ByteVal,sizeof(Hackitem.ByteVal),NumRead);
                      val (TempStr,Hackitem.ByteVal,Code);
                      blockwrite (NewFile,Hackitem.ByteVal,NumRead,NumWritten);
                    END;
                4 : BEGIN
                      blockread (HackFile,Hackitem.IntegerVal,sizeof(Hackitem.IntegerVal),NumRead);
                      val (TempStr,Hackitem.IntegerVal,Code);
                      blockwrite (NewFile,Hackitem.IntegerVal,NumRead,NumWritten);
                    END;
                5 : BEGIN
                      blockread (HackFile,Hackitem.WordVal,sizeof(Hackitem.WordVal),NumRead);
                      val (TempStr,Hackitem.WordVal,Code);
                      blockwrite (NewFile,Hackitem.WordVal,NumRead,NumWritten);
                    END;
                6 : BEGIN
                      blockread (HackFile,Hackitem.LongIntVal,sizeof(Hackitem.LongIntVal),NumRead);
                      val (TempStr,Hackitem.LongIntVal,Code);
                      blockwrite (NewFile,Hackitem.LongIntVal,NumRead,NumWritten);
                    END;
                7 : BEGIN
                      blockread (HackFile,Hackitem.RealVal,sizeof(Hackitem.RealVal),NumRead);
                      val (TempStr,Hackitem.RealVal,Code);
                      blockwrite (NewFile,Hackitem.RealVal,NumRead,NumWritten);
                    END;
              END;
              readln (HackScript,TempStr);
            END;
          REPEAT
            blockread (HackFile,Buffer^,SizeOf(Buffer^),NumRead);
            blockwrite (NewFile,Buffer^,NumRead,NumWritten);
          UNTIL (NumRead = 0) OR (NumWritten <> NumRead);
          close (HackFile);
          close (NewFile);
          assign (HackFile,Location + HackFileName);
          erase (HackFile);
          assign (NewFile,Location + 'HACKFILE.SSI');
          rename (NewFile,Location + HackFileName);
        END;
    END;
  dispose (Buffer);
  close (HackScript);
  erase (HackScript);
END;

{***************************************************************************}
PROCEDURE Install (Addon : MenuElementType; GameTitle, AddonTitle, GameDir, AddonDir : STRING);

VAR
  IniFile,
  NewIniFile : Text;
  InsertFile,
  SSIFile    : FILE;
  Buffer     : ^LargeBufType;
  Count      : Byte;
  NumRead,
  NumWritten : Word;
  Version,
  TOCSize,
  LeftToRead : LongInt;
  Location,
  TempStr    : STRING;
  SSITitle   : STRING[32];
  Launcher   : STRING[12];
  TOCItem    : TOCListElementType;
  TOC        : TOCListType;

{---------------------------------------------------------------------------}
PROCEDURE CreateMark;

VAR
  Counter  : Byte;
  Script,
  MarkFile : Text;
  TempStr  : STRING;

BEGIN
  assign (MarkFile,GameDir + '\' + FilesMark);
  rewrite (MarkFile);
  writeln (MarkFile,TOCSize);
  ResetList (TOC);
  FOR Counter := 1 TO TOCSize DO
    BEGIN
      GetNextItem (TOC,TOCItem);
      IF (TOCItem.FileName <> 'HACK.SCP') AND (TOCItem.FileName <> 'UNHACK.SCP') THEN
        BEGIN
          writeln (MarkFile,TOCItem.SubDir);
          writeln (MarkFile,TOCItem.FileName)
        END;
    END;
  SetFAttr (MarkFile,Hidden);
  close (MarkFile);

  assign (MarkFile,GameDir + '\' + HackMark);
  rewrite (MarkFile);
  assign (Script,AddonDir + '\UNHACK.SCP');
  reset (Script);
  REPEAT
    readln (Script,TempStr);
    writeln (MarkFile,TempStr);
  UNTIL EoF(Script);
  close (Script);
  SetFAttr (MarkFile,Hidden);
  close (MarkFile);
END;

{---------------------------------------------------------------------------}

BEGIN

  assign (SSIFile,AddonDir + '\' + Addon.FileName);
  reset (SSIFile,1);
  blockread (SSIFile,Version,sizeof(Version),NumRead);
  blockread (SSIFile,TOCSize,sizeof(TOCSize),NumRead);
  blockread (SSIFile,SSITitle,sizeof(SSITitle),NumRead);
  IF Version > 1 THEN
      blockread (SSIFile,Launcher,sizeof(Launcher),NumRead)
    ELSE Launcher := 'DUKE3D.EXE';
  blockread (SSIFile,Addon.LongDescrpt,sizeof(Addon.LongDescrpt),NumRead);
  CreateList (TOC);
  FOR Count := 1 TO TOCSize DO
    BEGIN
      blockread (SSIFile,TOCItem,sizeof(TOCItem),NumRead);
      InsertElement (TOC,TOCItem);
    END;
  ResetList (TOC);
  FOR Count := 1 TO TOCSize DO
    BEGIN
      GetNextItem (TOC,TOCItem);
      IF (TOCItem.FileName <> 'HACK.SCP') AND (TOCItem.FileName <> 'UNHACK.SCP') THEN
          BEGIN
            IF TOCItem.GameDir THEN
                Location := GameDir
              ELSE Location := GameDir + TOCItem.SubDir;
              IF CheckFile (TOCItem.FileName,GameDir,Archive) THEN
                  BEGIN
                    findfirst (Location + BackupDir,Directory,DirInfo);
                    IF DOSError <> 0 THEN
                        mkdir (Location + BackupDir);
                    CopyFile (TOCItem.FileName,GameDir,Location + BackupDir + '\');
                  END;
              assign (InsertFile,GameDir + TOCItem.FileName);
          END
        ELSE assign (InsertFile,AddonDir + '\' + TOCItem.FileName);
      rewrite (InsertFile,1);
      new(Buffer);
      LeftToRead := TOCItem.FileSize;
      WHILE LeftToRead > 0 DO
        BEGIN
          IF LeftToRead > 64000 THEN
              BEGIN
                blockread (SSIFile,Buffer^,sizeof(Buffer^),NumRead);
                blockwrite (InsertFile,Buffer^,NumRead,NumWritten);
                LeftToRead := LeftToRead - 64000;
              END
            ELSE
              BEGIN
                blockread (SSIFile,Buffer^,LeftToRead,NumRead);
                blockwrite (InsertFile,Buffer^,NumRead,NumWritten);
                LeftToRead := 0;
              END;
        END;
      dispose(Buffer);
      close (InsertFile);
    END;
  close (SSIFile);
  CreateMark;
  DestroyList (TOC);
  assign (IniFile,'GAMER.INI');
  assign (NewIniFile,'GAMER.IN_');
  reset (IniFile);
  rewrite (NewIniFile);
  REPEAT
    readln (IniFile,TempStr);
    writeln (NewIniFile,TempStr);
  UNTIL TempStr = GameTitle;
  readln (IniFile,TempStr);
  writeln (NewIniFile,TempStr);
  readln (IniFile,TempStr);
  writeln (NewIniFile,AddonTitle);
  REPEAT
    readln (IniFile,TempStr);
    writeln (NewIniFile,TempStr);
  UNTIL EOF(IniFile);
  close (IniFile);
  close (NewIniFile);
  erase (IniFile);
  rename (NewIniFile,'GAMER.INI');
END;

{***************************************************************************}
PROCEDURE UnInstall (Addon : MenuElementType; GameTitle, GameDir, AddonDir : STRING);

VAR

  Counter  : Byte;
  Remove   : FILE;
  MarkFile : Text;
  FileName : STRING;
  NumFiles : LongInt;

  IniFile,
  NewIniFile : Text;

  DeleteFile,
  InsertFile,
  SSIFile    : FILE;
  Count      : Byte;
  NumRead    : Word;
  Version,
  TOCSize    : LongInt;
  Location,
  TempStr    : STRING;
  SSITitle   : STRING[32];
  Launcher   : STRING[12];
  TOCItem    : TOCListElementType;
  TOC        : TOCListType;

BEGIN
  assign (SSIFile,AddonDir + '\' + Addon.FileName);
  reset (SSIFile,1);
  blockread (SSIFile,Version,sizeof(Version),NumRead);
  blockread (SSIFile,TOCSize,sizeof(TOCSize),NumRead);
  blockread (SSIFile,SSITitle,sizeof(SSITitle),NumRead);
  IF Version > 1 THEN
      blockread (SSIFile,Launcher,sizeof(Launcher),NumRead)
    ELSE Launcher := 'DUKE3D.EXE';
  blockread (SSIFile,Addon.LongDescrpt,sizeof(Addon.LongDescrpt),NumRead);
  CreateList (TOC);
  FOR Count := 1 TO TOCSize DO
    BEGIN
      blockread (SSIFile,TOCItem,sizeof(TOCItem),NumRead);
      InsertElement (TOC,TOCItem);
    END;
  ResetList (TOC);
  FOR Count := 1 TO TOCSize DO
    BEGIN
      GetNextItem (TOC,TOCItem);
      IF (TOCItem.FileName <> 'HACK.SCP') AND (TOCItem.FileName <> 'UNHACK.SCP') THEN
          BEGIN
            IF TOCItem.GameDir THEN
                Location := GameDir
              ELSE Location := GameDir + TOCItem.SubDir + '\';
            IF CheckFile (TOCItem.FileName,Location,Archive) THEN
                BEGIN
                  assign (InsertFile,Location + TOCItem.FileName);
                  erase (InsertFile);
                END;
             IF CheckFile (TOCItem.FileName, Location + Backupdir + '\',Archive) THEN
                 BEGIN
                   CopyFile (TOCItem.FileName,Location + BackupDir + '\',Location);
                   assign (DeleteFile,Location + BackupDir + '\' + TOCItem.FileName);
                   erase (DeleteFile);
                 END;
             findfirst (Location + BackupDir + '\*.*',Archive,DirInfo);
             IF DosError = 18 THEN rmdir (Location + BackupDir);
          END;
    END;
  close (SSIFile);

  IF CheckFile (FilesMark,GameDir + '\',Archive) THEN
    BEGIN
      assign (MarkFile,GameDir + '\' + FilesMark);
      erase (MarkFile);
    END;
  IF CheckFile (HackMark,GameDir + '\',Archive) THEN
    BEGIN
      assign (MarkFile,GameDir + '\' + HackMark);
      erase (MarkFile);
    END;

  DestroyList (TOC);

  assign (IniFile,'GAMER.INI');
  assign (NewIniFile,'GAMER.IN_');
  reset (IniFile);
  rewrite (NewIniFile);
  REPEAT
    readln (IniFile,TempStr);
    writeln (NewIniFile,TempStr);
  UNTIL TempStr = GameTitle;
  readln (IniFile,TempStr);
  writeln (NewIniFile,TempStr);
  readln (IniFile,TempStr);
  writeln (NewIniFile,'NONE');
  REPEAT
    readln (IniFile,TempStr);
    writeln (NewIniFile,TempStr);
  UNTIL EOF(IniFile);
  close (IniFile);
  close (NewIniFile);
  erase (IniFile);
  rename (NewIniFile,'GAMER.INI');
END;

{***************************************************************************}
PROCEDURE RecoverFromMark (GameDir : STRING);

VAR
  Counter  : Byte;
  Remove   : FILE;
  MarkFile : Text;
  Location,
  SubDir,
  FileName : STRING;
  NumFiles : LongInt;

BEGIN
  assign (MarkFile,GameDir + '\' + FilesMark);
  reset (MarkFile);
  readln (MarkFile,NumFiles);
  FOR Counter := 1 TO NumFiles DO
    BEGIN
      readln (MarkFile,SubDir);
      readln (MarkFile,FileName);
      IF SubDir = '' THEN
          Location := GameDir
        ELSE Location := GameDir + SubDir + '\';
      IF CheckFile (FileName,Location,Archive) THEN
          BEGIN
            assign (Remove,Location + FileName);
            erase (Remove);
          END;
      IF CheckFile (FileName,Location + BackupDir + '\',Archive) THEN
          BEGIN
            CopyFile (FileName,Location + BackupDir + '\',Location);
            assign (Remove,Location + BackupDir + '\' + FileName);
            erase (Remove);
          END;
      findfirst (Location + BackupDir + '\*.*',AnyFile,DirInfo);
      IF DosError = 18 THEN rmdir (Location + '\' + BackupDir);
    END;
  close (MarkFile);
  IF CheckFile (FilesMark,GameDir + '\',Archive) THEN
    BEGIN
      assign (MarkFile,GameDir + '\' + FilesMark);
      erase (MarkFile);
    END;
  IF CheckFile (HackMark,GameDir + '\',Archive) THEN
      Hack (GameDir,GameDir + '\' + HackMark);
END;

{***************************************************************************}
PROCEDURE InstallAddon (GameMenu : MenuList; Addon : MenuElementType);

VAR
  TempItem,
  Remove   : MenuElementType;
  TempChar : Char;
  IniFile  : Text;
  TempStr,
  AddonTitle,
  GameTitle,
  Current,
  AddonDir,
  GameDir  : STRING;

BEGIN
  GameTitle := copy(Addon.Title,2,pos('-',Addon.Title) - 3);
  AddonTitle := copy(Addon.Title,pos('-',Addon.Title) + 2,length(Addon.Title) - pos('-',Addon.Title) - 2);
  assign (IniFile,'GAMER.INI');
  reset (IniFile);
  readln (IniFile,TempStr);
  readln (IniFile,TempStr);
  REPEAT
    readln (IniFile,TempStr);
  UNTIL TempStr = GameTitle;
  readln (IniFile,AddonDir);
  readln (IniFile,Current);
  readln (IniFile,GameDir);
  close (IniFile);

  IF CheckFile (FilesMark,GameDir,Archive) AND (Current = 'NONE') THEN
    RecoverFromMark (GameDir);

  findfirst (AddonDir + '\' + Addon.FileName,AnyFile,DirInfo);
  IF NOT(EnoughSpace (GameDir[1],(DirInfo.Size/1000000))) THEN
      BEGIN
        Done := True;
        Error := 5;
        Exit;
      END;

  IF Addon.Activated THEN
      BEGIN
        IF CheckFile (Addon.FileName,AddonDir + '\',Archive) THEN
            BEGIN
              Clear (14 + 16,1,1,25,80,25);
              WrtS (2,1,'WORKING: Removing ' + AddonTitle + ' files...');
              UnInstall (Addon,GameTitle,GameDir,AddonDir);
            END;
        MenuDeleteElement (GameMenu,Addon);
        Addon.Activated := False;
        MenuInsertElement (GameMenu,Addon);
        IF CheckFile ('\UNHACK.SCP',AddonDir,Archive) THEN
            BEGIN
              Clear (14 + 16,1,1,25,80,25);
              WrtS (2,1,'WORKING: Restoring original ' + GameTitle + ' files...');
              Hack (GameDir,AddonDir + '\UNHACK.SCP');
            END;
        Clear (14 + 16,1,1,25,80,25);
        WrtS (2,1,'COMPLETE: ' + AddonTitle + ' Deactivated');
      END
    ELSE
      IF Current <> 'NONE' THEN
          BEGIN
            MenuResetList (GameMenu);
            Remove.Title := ' ' + GameTitle + ' - ' + Current + ' ';
            REPEAT
              MenuGetNextItem (GameMenu,TempItem);
            UNTIL Remove.Title = TempItem.Title;
            Remove := TempItem;
            MenuDeleteElement (GameMenu,Remove);
            Remove.Activated := False;
            MenuInsertElement (GameMenu,Remove);
            IF CheckFile (Remove.FileName,AddonDir + '\',Archive) THEN
                BEGIN
                  Clear (14 + 16,1,1,25,80,25);
                  WrtS (2,1,'WORKING: Removing ' + copy(Remove.Title,pos('-',Remove.Title) + 2,length(Remove.Title) -
                        pos('-',Remove.Title) - 2) + ' files...');
                  UnInstall (Addon,GameTitle,GameDir,AddonDir);
                END;
            IF CheckFile ('\UNHACK.SCP',AddonDir,Archive) THEN
                BEGIN
                  Clear (14 + 16,1,1,25,80,25);
                  WrtS (2,1,'WORKING: Restoring original ' + GameTitle + ' files...');
                  Hack (GameDir,AddonDir + '\UNHACK.SCP');
                END;
            Clear (14 + 16,1,1,25,80,25);
            WrtS (2,1,'COMPLETE: ' + AddonTitle + ' Deactivated');
          END;
  IF Current <> AddonTitle THEN
      BEGIN
        IF CheckFile (Addon.FileName,AddonDir + '\',Archive) THEN
            BEGIN
              Clear (14 + 16,1,1,25,80,25);
              WrtS (2,1,'WORKING: Installing ' + AddonTitle + ' files...');
              Install (Addon,GameTitle,AddonTitle,GameDir,AddonDir);
            END;
        MenuDeleteElement (GameMenu,Addon);
        Addon.Activated := True;
        MenuInsertElement (GameMenu,Addon);
        IF CheckFile ('\HACK.SCP',AddonDir,Archive) THEN
            BEGIN
              Clear (14 + 16,1,1,25,80,25);
              WrtS (2,1,'WORKING: Modifying ' + GameTitle + ' files...');
              Hack (GameDir,AddonDir + '\HACk.SCP');
            END;
        Clear (14 + 16,1,1,25,80,25);
        WrtS (2,1,'COMPLETE: ' + AddonTitle + ' Activated');
        IF DoLaunch(AddonTitle,Addon.Launcher) THEN
            BEGIN
              CursorOn;
              TextMode (OrigMode);
              Done := True;
              Launched := True;
              delete (GameDir,length(GameDir),1);
              chdir (GameDir);
              writeln ('Type ', Addon.Launcher, ' to play ', AddonTitle);
{              IF CheckFile (Addon.Launcher,GameDir + '\',Archive) THEN
                exec (GameDir + '\' + Addon.Launcher,'');}
            END;
      END;
END;

{***************************************************************************}
FUNCTION DoInstall (Addon : MenuElementType) : Boolean;

VAR
  AddonTitle : STRING;
  ExitChars  : ExitCharSet;
  Choice     : Char;
  Cursor     : Byte;
  Menu       : MenuType;

BEGIN
  Menu[1] := ' YES ';
  Menu[2] := ' NO ';
  MakeWin (0 + 16,0,17,6,45,6,True,True);
  TcTb (15 + 16,0);
  CASE Addon.Activated OF
    False : WrtS (3,1,'Are you sure you would like to activate ');
    True  : WrtS (2,1,'Are you sure you would like to deactivate ');
  END;
  AddonTitle := copy(Addon.Title,pos('-',Addon.Title) + 2,length(Addon.Title) - pos('-',Addon.Title) - 2);
  TcTb (14 + 16,0);
  WrtS (22 - (length(AddonTitle) DIV 2) - (length(AddonTitle) MOD 2),2,AddonTitle);
  WrtS (2,1,'');
  TcTb (7 + 16,0);
  WrtS (19,3,Menu[1]);
  WrtS (19,4,Menu[2]);
  Cursor := 1;
  ExitChars := [#13,#27];
  ArraySelect (7 + 16,0,15 + 16,1,19,3,2,Cursor,Choice,Menu,ExitVals);
  IF Choice = #13 THEN
      CASE Cursor OF
        1 : DoInstall := True;
        2 : DoInstall := False;
      END
    ELSE DoInstall := False;
END;

{***************************************************************************}
PROCEDURE ControlProcessing;

VAR
  GameMenu : MenuList;
  Choice   : Char;
  Height,
  Cursor   : Byte;
  Addon    : MenuElementType;

BEGIN
  Initialize (GameMenu,Cursor);
  ExitVals := [#13,#27];
  IF NOT Done THEN
      BEGIN
        MainScreenSetup;
        DrawStatusBar (1 + 16,7,'   <' + #24 + #25 + '>-Select Game/Add-on    <ENTER>-Activate/Deactivate' +
                       '    <ESC>-Exit GAMER');
        DrawMenuWindow (GameMenu,True,Cursor);
        Addon.Position := Cursor;
        MenuRetrieveElement (GameMenu,Addon);
        DrawInfoWindow (Addon,True);
        IF MenuListLength(GameMenu) >= 10 THEN
            Height := 10
          ELSE Height := MenuListLength (GameMenu);
      END;

  WHILE NOT Done DO
    BEGIN
      REPEAT
        MenuSelect (15,1,8 + 16,7,2,1,Height,Cursor,Choice,GameMenu,Addon,ExitVals);
      UNTIL Choice IN ExitVals;
      CASE Choice OF
        #27 : Done := True;
        #13 : IF DoInstall (Addon) THEN
                  BEGIN
                    DrawMenuWindow (GameMenu,False,Cursor);
                    InstallAddon (GameMenu,Addon);
                  END;
      END;
      IF NOT Done THEN
        BEGIN
          DrawStatusBar (1 + 16,7,'   <' + #24 + #25 + '>-Select Game/Add-on    <ENTER>-Activate/Deactivate' +
                         '    <ESC>-Exit GAMER');
          DrawMenuWindow (GameMenu,False,Cursor);
          MenuRetrieveElement (GameMenu,Addon);
          DrawInfoWindow (Addon,False);
        END;
    END;
  MenuDestroyList (GameMenu);
END;

{***************************************************************************}
PROCEDURE OutputError;

BEGIN
  write ('Error 00', Error, ': ');
  CASE Error OF
    1 : writeln ('GAMER.INI not properly formatted for use with GAMER');
    2 : writeln ('Invalid directory in GAMER.INI - ', ErrorInfo);
    3 : writeln ('GAMER.INI does not exist!');
    4 : writeln ('Could not detect any add-ons!');
    5 : writeln ('Not enough disk space available. Please free some and try again.');
    6 : writeln ('Currently activated addon not found - ', ErrorInfo);
  END;

  writeln ('Please consult the README.TXT for help information.');
  writeln;

END;
{***************************************************************************}

BEGIN
  OrigMode := LastMode;
  TextMode (3);
  HighIntensity;
  CursorOff;
  ControlProcessing;
  IF NOT Launched THEN
      BEGIN
        CursorOn;
        TextMode (OrigMode);
      END;
  IF (Error > 0) THEN OutputError;
END.