{$M $9999,0,655360}
PROGRAM MakeSSI;

USES
  Dos,
  Crt,
  List2Data,
  List2ADT;

CONST
  Valid  = ['F','T','V','L','D','M'];
  Exit   = ['Q'];

TYPE
  BufferType = ARRAY [1..64000] OF Char;

VAR
  SSIFileName : FileNameType;

  Version     : LongInt;
  Title       : TitleType;
  LongDescrpt : ARRAY [1..3] OF DescrptLine;
  TOCSize     : LongInt;
  Launcher    : FileNameType;

  Count       : 1..400;
  Counter     : LongInt;
  DirInfo     : SearchRec;
  Selection   : Char;

{****************************************************************************}
FUNCTION StrInt (Str : STRING) : Integer;

VAR
  ErrorPos : Integer;
  NewInt   : Integer;

BEGIN
  val (Str, NewInt, ErrorPos);
  IF (ErrorPos = 0) THEN
      StrInt := NewInt
    ElSE StrInt := -1;
End;

{****************************************************************************}
FUNCTION EditFileName : FileNameType;

VAR
  Temp : FileNameType;

BEGIN
  GotoXY (1,17);
  write (' New SSI Filename ==> ');
  readln (Temp);
  FOR Count := 1 TO length(Temp) DO
    Temp[Count] := upcase(Temp[Count]);
  Count := 1;
  WHILE (Temp[Count] <> '.') AND (Count <> length(Temp)) DO inc(Count);
  IF Temp[Count] <> '.' THEN Temp := Temp + '.SSI';
  EditFileName := Temp;
END;

{****************************************************************************}
FUNCTION EditTitle : TitleType;

VAR
  Temp : TitleType;

BEGIN
  GotoXY (36,18);
  writeln ('Maximum length ',#24);
  GotoXY (1,17);
  write (' New SSI Title ==> ');
  readln (Temp);
  FOR Count := 1 TO length(Temp) DO
    Temp[Count] := upcase(Temp[Count]);
  EditTitle := Temp;
END;

{****************************************************************************}
FUNCTION EditVersion (Current : LongInt) : LongInt;

VAR
  TempStr : STRING;
  TempInt : LongInt;

BEGIN
  GotoXY (1,17);
  write (' New SSI Version ==> ');
  readln (TempStr);
  TempInt := StrInt (TempStr);
  IF TempInt <> -1 THEN
      EditVersion := Tempint
    ELSE EditVersion := Current;
END;

{****************************************************************************}
FUNCTION EditLauncher : FileNameType;

VAR
  Temp : FileNameType;

BEGIN
  GotoXY (1,17);
  write (' New Launcher Filename ==> ');
  readln (Temp);
  FOR Count := 1 TO length(Temp) DO
    Temp[Count] := upcase(Temp[Count]);
  Count := 1;
  WHILE (Temp[Count] <> '.') AND (Count <> length(Temp)) DO inc(Count);
  IF Temp[Count] <> '.' THEN Temp := Temp + '.EXE';
  EditLauncher := Temp;
END;

{****************************************************************************}
FUNCTION EditTOCSize (Current : LongInt) : LongInt;

VAR
  TempStr : STRING;
  TempInt : LongInt;

BEGIN
  GotoXY (1,17);
  write (' New SSI File Count ==> ');
  readln (TempStr);
  TempInt := StrInt (TempStr);
  IF TempInt <> -1 THEN
      EditTOCSize := Tempint
    ELSE EditTOCSize := Current;
END;

{****************************************************************************}
FUNCTION EditDescrptLine (LineNumber : Byte) : DescrptLine;

VAR
  Temp : DescrptLine;

BEGIN
  GotoXY (1,17);
  writeln (' Enter line #', LineNumber, ' of the SSI long description:');
  GotoXY (1,18);
  writeln ('                                                                               ');
  GotoXY (2,19);
  writeln (#24,'.................... Maximum Size ..................................',#24);
  GotoXY (2,18);
  readln (Temp);
  EditDescrptLine := Temp;
END;

{****************************************************************************}
FUNCTION ModifyTOCGameDir : Boolean;

VAR
  Temp : Char;

BEGIN
  GotoXY (1,15);
  write (' Is the file in the game root directory? (Y/N) ==> ');
  readln (Temp);
  Temp := upcase(Temp);
  Count := 1;
  IF Temp <> 'Y' THEN
      ModifyTOCGameDir := False
    ElSE ModifyTOCGameDir := True;
END;

{****************************************************************************}
FUNCTION ModifyTOCSubDir : TitleType;

VAR
  Temp : TitleType;

BEGIN
  GotoXY (29,16);
  writeln ('Maximum length ',#24);
  GotoXY (1,15);
  write (' Enter the subdir ==> ');
  readln (Temp);
  FOR Count := 1 TO length(Temp) DO
    Temp[Count] := upcase(Temp[Count]);
  ModifyTOCSubDir := Temp;
END;

{****************************************************************************}
FUNCTION ModifyTOCGameVer : TitleType;

VAR
  Temp : TitleType;

BEGIN
  GotoXY (35,16);
  writeln ('Maximum length ',#24);
  GotoXY (1,15);
  write (' Enter the game version ==> ');
  readln (Temp);
  FOR Count := 1 TO length(Temp) DO
    Temp[Count] := upcase(Temp[Count]);
  ModifyTOCGameVer := Temp;
END;

{****************************************************************************}
PROCEDURE ModifyFileInfo (VAR NewTOCItem : ListElementType);

CONST
  Valid = ['I','S','G'];
  Exit  = ['D','Q'];

VAR
  TempTOCItem : ListElementType;
  Selection   : Char;

BEGIN

  TempTOCItem := NewTOCItem;
  REPEAT
    clrscr;
    writeln (' Modifying File        : ',TempTOCItem.FileName);
    writeln (' Size of File          : ',TempTOCItem.FileSize);
    writeln (' Buffer String (n/a)   : ',TempTOCItem.String2);
    writeln (' Buffer Integer (n/a)  : ',TempTOCItem.Integer1);
    writeln (' Buffer Integer (n/a)  : ',TempTOCItem.Integer2);
    writeln;
    writeln (' (I)n Game Root Dir    : ',TempTOCItem.GameDir);
    writeln (' (S)ubdir (if not root): ',TempTOCItem.SubDir);
    writeln (' (G)ame version info   : ',TempTOCItem.GameVer);
    writeln (' (D)one - accept changes');
    writeln (' (Q)uit - do not accept changes');
    writeln;
    writeln (' Make a selection ==> ');

    REPEAT
      GotoXY (23,13);
      Selection := upcase(readkey);
      IF (Selection IN Valid) OR (Selection IN Exit) THEN
          write (Selection)
        ElSE
          BEGIN
            sound (1000);
            delay (50);
            nosound;
          END;
    UNTIL (Selection IN Valid) OR (Selection IN Exit);

    CASE Selection OF
      'I' : TempTOCItem.GameDir := ModifyTOCGameDir;
      'S' : TempTOCItem.SubDir := ModifyTOCSubDir;
      'G' : TempTOCItem.GameVer := ModifyTOCGameVer;
    END;

  UNTIL Selection IN Exit;

  IF Selection = 'D' THEN NewTOCItem := TempTOCitem;

END;

{****************************************************************************}
FUNCTION ValidFile (FileName : FileNameType) : Boolean;

VAR
  TempStr : STRING;

BEGIN
  IF (FileName = 'MAKESSI.EXE') OR (FileName = 'UNDOSSI.EXE') OR
     (FileName = SSIFileName) THEN  ValidFile := False
END;

{****************************************************************************}
PROCEDURE CreateSSIFile;

CONST
  Valid = ['I','M','D','A'];

VAR
  SSIFile,
  InsertFile  : File;
  SSIScp      : Text;
  TOCItem     : ListElementType;
  TOC         : ListType;
  Buffer      : ^BufferType;
  NumRead,
  NumWritten  : Word;
  LeftToRead  : LongInt;
  Done,
  Abort       : Boolean;
  Selection   : Char;

BEGIN
  Abort := False;
  CreateList (TOC);

  FindFirst('*.*',Archive,DirInfo);
  WHILE (DOSError = 0) AND (NOT Abort) DO
    BEGIN
      IF ValidFile (DirInfo.Name) THEN
           BEGIN

             FOR Count := 1 TO 12 DO
               TOCItem.FileName[Count] := #00;
             FOR Count := 1 TO 32 DO
               BEGIN
                 TOCItem.SubDir[Count] := #00;
                 TOCItem.GameVer[Count] := #00;
                 TOCItem.String2[Count] := #00;
               END;

             TOCItem.FileName := DirInfo.Name;
             TOCItem.FileSize := DirInfo.Size;
             TOCItem.GameDir := True;
             TOCItem.SubDir := '';
             TOCItem.GameVer := '';
             TOCItem.String2 := '';
             TOCItem.Integer1 := 0;
             TOCItem.Integer2 := 0;
             Done := False;

             REPEAT
               clrscr;
               writeln (' Include File        : ',TOCItem.FileName);
               writeln (' Size of File        : ',TOCItem.FileSize);
               writeln (' Is in Game Root Dir : ',TOCItem.GameDir);
               writeln (' Subdir (if not root): ',TOCItem.SubDir);
               writeln (' Game version info   : ',TOCItem.GameVer);
               writeln (' Buffer string       : ',TOCItem.String2);
               writeln (' Buffer integer #1   : ',TOCItem.Integer1);
               writeln (' Buffer integer #2   : ',TOCItem.Integer2);
               writeln;
               writeln (' (I)nclude this file');
               writeln (' (M)odify this files properties');
               writeln (' (D)o not include this file');
               writeln (' (A)bort SSI file creation');
               writeln;
               writeln (' Make a selection ==> ');

               REPEAT
                 GotoXY (23,15);
                 Selection := upcase(readkey);
                 IF Selection IN Valid THEN
                     write (Selection)
                   ElSE
                     BEGIN
                       sound (1000);
                       delay (50);
                       nosound;
                     END;
               UNTIL Selection IN Valid;

               CASE Selection OF
                 'I' : BEGIN
                         InsertElement (TOC,TOCItem);
                         Done := True;
                         inc(TOCSize);
                       END;
                 'D' : Done := True;
                 'M' : ModifyFileInfo (TOCItem);
                 'A' : Abort := True;
               END;
             UNTIL Done OR Abort;
           END;
      FindNext(DirInfo);
    END;

    IF NOT Abort THEN
        BEGIN
          clrscr;
          write (' Would you like to generate a script file of this session? (Y/N) ');
          readln (Selection);
          Selection := upcase(Selection);
          IF Selection = 'Y' THEN
            BEGIN
              assign (SSIScp,'MAKESSI.SCP');
              rewrite (SSIScp);
              writeln (SSIScp,SSIFileName);
              writeln (SSIScp,Version);
              writeln (SSIScp,TOCSize);
              writeln (SSIScp,Title);
              writeln (SSIScp,Launcher);
              writeln (SSIScp,LongDescrpt[1]);
              writeln (SSIScp,LongDescrpt[2]);
              writeln (SSIScp,LongDescrpt[3]);
              ResetList (TOC);
              FOR Count := 1 TO TOCSize DO
                BEGIN
                  GetNextItem (TOC,TOCItem);
                  writeln (SSIScp,TOCItem.FileName);
                  writeln (SSIScp,TOCItem.GameDir);
                  writeln (SSIScp,TOCItem.SubDir);
                  writeln (SSIScp,TOCItem.GameVer);
                  writeln (SSIScp,TOCItem.String2);
                  writeln (SSIScp,TOCItem.Integer1);
                  writeln (SSIScp,TOCItem.Integer2);
                END;
              close (SSIScp);
            END;
          assign (SSIFile,SSIFileName);
          rewrite (SSIFile,1);
          blockwrite (SSIFile,Version,sizeof(Version),NumWritten);
          blockwrite (SSIFile,TOCSize,sizeof(TOCSize),NumWritten);
          blockwrite (SSIFile,Title,sizeof(Title),NumWritten);
          blockwrite (SSIFile,Launcher,sizeof(Launcher),NumWritten);
          blockwrite (SSIFile,LongDescrpt,sizeof(LongDescrpt),NumWritten);
          ResetList (TOC);
          FOR Count := 1 TO TOCSize DO
            BEGIN
              GetNextItem (TOC,TOCItem);
              blockwrite (SSIFile,TOCItem,sizeof(TOCItem),NumWritten);
            END;
          clrscr;
          writeln (' Creating SSI File: ', SSIFileName);
          writeln (' SSI Title: ', Title);
          writeln (' SSI File Type Version: ', Version);
          writeln (' SSI File Launcher: ', Launcher);
          writeln (' Number of Files to Insert: ', TOCSize);
          ResetList (TOC);
          FOR Count := 1 TO TOCSize DO
            BEGIN
              GetNextItem (TOC,TOCItem);
              writeln (' Inserting File: ', TOCitem.FileName);
              assign (InsertFile,TOCItem.FileName);
              reset (InsertFile,1);
              new(Buffer);
              LeftToRead := TOCItem.FileSize;
              WHILE LeftToRead > 0 DO
                BEGIN
                  IF LeftToRead > 64000 THEN
                      BEGIN
                        blockread (InsertFile,Buffer^,sizeof(Buffer^),NumRead);
                        blockwrite (SSIFile,Buffer^,NumRead,NumWritten);
                        LeftToRead := LeftToRead - 64000;
                      END
                    ELSE
                      BEGIN
                        blockread (InsertFile,Buffer^,LeftToRead,NumRead);
                        blockwrite (SSIFile,Buffer^,NumRead,NumWritten);
                        LeftToRead := 0;
                      END;
                END;
              dispose(Buffer);
              close (InsertFile);
            END;
          DestroyList (TOC);
          close (SSIFile);
          writeln;
          writeln (' ',SSIFileName,' has been created.');
          writeln;
        END
      ELSE
        BEGIN
          clrscr;
          writeln ('Creation of SSI file aborted.');
        END;
END;

{****************************************************************************}
PROCEDURE UseScript (ScriptName : STRING);

VAR
  SSIFile,
  InsertFile  : File;
  SSIScp      : Text;
  TOCItem     : ListElementType;
  TOC         : ListType;
  Buffer      : ^BufferType;
  NumRead,
  NumWritten  : Word;
  LeftToRead  : LongInt;
  InGameDir   : Char;

BEGIN

  clrscr;
  assign (SSIScp,ScriptName);
  reset (SSIScp);
  readln (SSIScp,SSIFileName);
  readln (SSIScp,Version);
  readln (SSIScp,TOCSize);
  readln (SSIScp,Title);
  readln (SSIScp,Launcher);
  readln (SSIScp,LongDescrpt[1]);
  readln (SSIScp,LongDescrpt[2]);
  readln (SSIScp,LongDescrpt[3]);
  CreateList (TOC);
  FOR Count := 1 TO TOCSize DO
    BEGIN
      readln (SSIScp,TOCItem.FileName);
      findfirst (TOCItem.FileName,Archive,DirInfo);
      TOCItem.FileSize := DirInfo.Size;
      readln (SSIScp,InGameDir);
      IF InGameDir = 'Y' THEN
          TOCItem.GameDir := True
        ELSE TOCItem.GameDir := False;
      readln (SSIScp,TOCItem.SubDir);
      readln (SSIScp,TOCItem.GameVer);
      readln (SSIScp,TOCItem.String2);
      readln (SSIScp,TOCItem.Integer1);
      readln (SSIScp,TOCItem.Integer2);
      InsertElement (TOC,TOCItem);
    END;
  close (SSIScp);

  assign (SSIFile,SSIFileName);
  rewrite (SSIFile,1);
  blockwrite (SSIFile,Version,sizeof(Version),NumWritten);
  blockwrite (SSIFile,TOCSize,sizeof(TOCSize),NumWritten);
  blockwrite (SSIFile,Title,sizeof(Title),NumWritten);
  blockwrite (SSIFile,Launcher,sizeof(Launcher),NumWritten);
  blockwrite (SSIFile,LongDescrpt,sizeof(LongDescrpt),NumWritten);
  ResetList (TOC);
  FOR Count := 1 TO TOCSize DO
    BEGIN
      GetNextItem (TOC,TOCItem);
      blockwrite (SSIFile,TOCItem,sizeof(TOCItem),NumWritten);
    END;
  clrscr;
  writeln (' Creating SSI File: ', SSIFileName);
  writeln (' SSI Title: ', Title);
  writeln (' SSI File Type Version: ', Version);
  writeln (' Number of Files to Insert: ', TOCSize);
  ResetList (TOC);
  FOR Count := 1 TO TOCSize DO
    BEGIN
      GetNextItem (TOC,TOCItem);
      writeln (' Inserting File: ', TOCitem.FileName);
      assign (InsertFile,TOCItem.FileName);
      reset (InsertFile,1);
      new(Buffer);
      LeftToRead := TOCItem.FileSize;
      WHILE LeftToRead > 0 DO
        BEGIN
          IF LeftToRead > 64000 THEN
              BEGIN
                blockread (InsertFile,Buffer^,sizeof(Buffer^),NumRead);
                blockwrite (SSIFile,Buffer^,NumRead,NumWritten);
                LeftToRead := LeftToRead - 64000;
              END
            ELSE
              BEGIN
                blockread (InsertFile,Buffer^,LeftToRead,NumRead);
                blockwrite (SSIFile,Buffer^,NumRead,NumWritten);
                LeftToRead := 0;
              END;
        END;
      dispose(Buffer);
      close (InsertFile);
    END;
  DestroyList (TOC);
  close (SSIFile);
  writeln;
  writeln (' ',SSIFileName,' has been created.');
  writeln;

END;

{****************************************************************************}
PROCEDURE NewSSIFile;

BEGIN
  FOR Count := 1 TO 12 DO
    BEGIN
      SSIFileName[Count] := #00;
      Launcher[Count] := #00;
    END;
  FOR Count := 1 TO 32 DO
    Title[Count] := #00;
  FOR Count := 1 TO 70 DO
    BEGIN
      LongDescrpt[1][Count] := #00;
      LongDescrpt[2][Count] := #00;
      LongDescrpt[3][Count] := #00;
    END;

  SSIFileName := 'DEFAULT.SSI';
  Version := 2;
  TOCSize := 0;
  Title := 'SUNSTORM INTERACTIVE ADD-ON';
  LongDescrpt[1] := 'description line 1';
  LongDescrpt[2] := 'description line 2';
  LongDescrpt[3] := 'description line 3';
  Launcher := 'DEFAULT.EXE';

  textcolor (7);
  textbackground (0);

  REPEAT
    clrscr;
    writeln (' Sunstorm Interactive SSI File Creator by Charlie Wiederhold');
    writeln;
    writeln (' (F)ilename ............. ', SSIFilename);
    writeln (' (T)itle ................ ', Title);
    writeln (' (V)ersion .............. ', Version);
    writeln (' (L)auncher ............. ', Launcher);
    writeln (' (D)escription: ');
    writeln ('     ',LongDescrpt[1]);
    writeln ('     ',LongDescrpt[2]);
    writeln ('     ',LongDescrpt[3]);
    writeln (' (M)ake SSI File and exit');
    writeln (' (Q)uit without creating');
    writeln;
    writeln;
    writeln (' Make a selection ==> ');

    REPEAT
      GotoXY (23,15);
      Selection := upcase(readkey);
      IF (Selection IN Valid) OR (Selection IN Exit) THEN
          write (Selection)
        ElSE
          BEGIN
            sound (1000);
            delay (50);
            nosound;
          END;
    UNTIL (Selection IN Valid) OR (Selection IN Exit);

    IF Selection IN Valid THEN
        CASE Selection OF
          'F' : SSIFileName := EditFileName;
          'T' : Title := EditTitle;
          'V' : Version := EditVersion(Version);
          'L' : Launcher := EditLauncher;
          'D' : FOR Count := 1 TO 3 DO
                  LongDescrpt[Count] := EditDescrptLine(Count);
          'M' : CreateSSIFile;
        END;
  UNTIL (Selection IN Exit) OR (Selection = 'M');
END;

{****************************************************************************}

BEGIN

  IF ParamCount = 0 THEN
      NewSSIFile
    ELSE
      BEGIN
        findfirst (ParamStr(1),Archive,DirInfo);
        IF DOSError = 0 THEN
            UseScript (ParamStr(1))
          ELSE writeln ('That script file does not exist.');
      END;
END.