UNIT InstData;

INTERFACE

USES
  NewDelay,
  Crt,
  DOS,
  Utility;

CONST
  New_Gamer_Version = 1.01;
  Install_Version   = ' ver1.05 ';
  Developer         = 'Sunstorm Interactive, Inc.';
  Year              = '(1997)';
  Game_ID_File      = 'SW.EXE';
  Game_ID_Dir       = 'SW';
  Game_Title        = 'SHADOW WARRIOR';
  Game_Short        = 'SW';
  Addon_Dir         = 'WANTON';
  Addon_Title       = 'WANTON DESTRUCTION';
  Addon_Short       = 'WANTON';
  NumFiles          = 4;
  DiskSpace         = 4.0;

TYPE
  PathType  = STRING[60];
  FileArray = ARRAY [1..NumFiles] OF STRING;

FUNCTION  EnoughSpace (GamerPath : PathType) : Boolean;
FUNCTION  Startup_Drive : Char;
FUNCTION  IntroScreen : Boolean;
PROCEDURE InstallScreenSetup (GamerPath : PathType);
PROCEDURE MainScreenSetup;

IMPLEMENTATION

{***************************************************************************}
FUNCTION EnoughSpace (GamerPath : PathType) : Boolean;

VAR
  Enough : Boolean;
  Drive  : Char;

BEGIN
  Drive := GamerPath[1];
  IF Drive IN ['A'..'Z'] THEN
      Enough := (DiskFree(ord(Drive) - 64) - (DiskSpace * 1000000)) > (DiskSpace * 1000000)
    ELSE
      Enough := (DiskFree(0) - (DiskSpace * 1000000)) > (DiskSpace * 1000000);
  EnoughSpace := Enough;
  IF NOT Enough THEN
      BEGIN
        MakeWin (0 + 16,0,10,9,60,6,True,True);
        TcTb (12 + 16,0);
        WrtS (2,1,'Error: Not enough room available on the specified drive!');
        TcTb (15 + 16,0);
        gotoXY (10,2);
        write ('You need approximately ',  DiskSpace:0:1, ' megs free...');
        WrtS (4,3,'Please free up enough disk space and install again.');
        TcTb (14 + 16,0);
        WrtS (8,4,'Press any key to exit installation program.');
        REPEAT UNTIL KeyPressed;
      END;
END;

{***************************************************************************}
FUNCTION Startup_Drive : Char;

VAR
  HTregs : registers;

BEGIN
  HTregs.AX := $3305;
  MsDos(HTregs);
  Startup_Drive := Char(HTregs.DL + 64);
END;

{***************************************************************************}
FUNCTION IntroScreen : Boolean;

VAR
  TempChar : Char;

BEGIN
  MainScreenSetup;
  MakeWin (9,1,9,6,63,12,True,True);
  TcTb (14,1);
  WrtS (31 - (length(Addon_Title + ' Developed By ' + Developer) DIV 2),1,Addon_Title +
                                   ' Developed By ' + Developer);
  TcTb (15,1);
  WrtS (2,3,'This program will aid you through the installation process');
  WrtS (2,4,'of the GAMER add-on management software, and all items');
  WrtS (2,5,'needed for ' + Addon_Title + ' to run properly.');
  WrtS (2,7,'The GAMER software is used to activate all add-ons');
  WrtS (2,8,'developed by ' + Developer);
  TcTb (11,1);
  WrtS (33,10,'Press <ENTER> to continue...');
  REPEAT
    TempChar := readkey;
  UNTIL TempChar IN [#13,#27];
  IF TempChar = #27 THEN
      BEGIN
        IntroScreen := True;
        Exit;
      END
    ELSE
      IntroScreen := False;
END;

{***************************************************************************}
PROCEDURE InstallScreenSetup (GamerPath : PathType);

BEGIN
  MakeWin (9,1,4,12,72,6,True,True);
  TcTb (15,1);
  WrtS (2,1,'Now installing the files into the destination directory:');
  WrtS (8,4,'0%');
  WrtS (60,4,'100%');
  WrtS (10,3,'Current file:');
  WrtS (38,3,'Percent Complete:');

  TcTb (14,1);
  WrtS (2,2,GamerPath);
  WrtC (59,3,'%');

  TcTb (0 + 16,0 + 16);
  WrtS (10,4,'                                                  ');
END;

{***************************************************************************}
PROCEDURE MainScreenSetup;

VAR
  Count,
  Counter : Byte;

BEGIN
  Clear (1 + 16,7,1,1,80,1);
  WrtS (40 - (length('SSInstall Developed By ' + Developer + ' ' + Year) DIV 2),1,
                     'SSInstall Developed By ' + Developer + ' ' + Year);
  Window (1,2,80,25);
  TcTb (7 + 16,0);
  Window (1,2,80,25);
  FOR Count := 2 TO 24 DO
    WrtS (1,Count,'');
  TcTb (14 + 16,0);
  WrtS (81 - length(Install_Version),23,Install_Version);
  Clear (1 + 16,7,1,25,80,25);
  WrtS (80 - length(Addon_Title),1,Addon_Title);
  WrtS (2,1,'Hit <ESC> at anytime to abort installation');
END;

{***************************************************************************}

END.